#!/usr/bin/perl -X
use strict;

#---------------------- Configure section ----------------------

# samba server
my $srv = '127.0.0.1';

# admin user for samba server
# set in sp.conf
my $smbuser = 'sp-helper';

# admin's password for samba server
# set in sp.conf
my $smbpass;

# create hierarchy home dir (NOT USED YET!)
my $create_home = 0;

# directory for hierarchy home dir
my $path2homes = '/home/samba/homes';

# Account comment encoding for /etc/passwd. utf-8 if undefined.
# If server locale differs from utf-8, set it here.
# List of available encodings: iconv --list
my $comment_encoding = 'utf-8'; # KOI8-R, etc

#---------------------- End of Configure section ---------------



#------------------ Do not edit after this line! ---------------

$| = 1;

my ($OS,$act,$client,$date,%gconf,$Mandriva,$Ubuntu);
$date = date();
OS();

%gconf = &read_config('/var/www/cgi-bin/sp/sp.conf');

if ( defined($gconf{'sphelper_smbuser'}) )
{
	$smbuser = $gconf{'sphelper_smbuser'};
}

$smbpass = $gconf{'sphelper_smbpass'};

open(LOG, ">>/var/log/sphelper.log") || die "Can't open log for write: $!";
print LOG "$date  CONNECT: ";
# local $SIG{ALRM} = sub { Quit("Exiting due TimeOut") };
# alarm 105;

while (<>)
{
    my $line = chomp_all($_);

    # required auth part, generated in common.pl:
    # my $auth_part = qq[<auth><user>$gconf{'db_user'}</user><password>$gconf{'db_pass'}</password></auth>];
    if ( $line =~ m^<auth><user>(.+)</user><password>(.+)</password></auth>^ )
	{
		unless ( $1 eq $gconf{'db_user'} and $2 eq $gconf{'db_pass'} )
		{
			print "Unauthorized: wrong password\n";
			exit(-1);
		}
	}
    else
    {
		print "Unauthorized: can't parse\n";
		exit(-1);
    }

    if ( $line =~ m^<sp_adduser><user>(.+)</user><passwd>(.+)</passwd><group1>(.+)</group1><group2>(.+)</group2><comment>(.+)</comment></sp_adduser>^ )
    {
		# <sp_adduser><user>petrov</user><passwd>p</passwd><group1>students</group1><group2>c6a</group2><comment> </comment></sp_adduser>
		my $user = $1; my $passwd = $2; my $group1 = $3;
		my $group2; $group2 = $4 if $4 ne 'no group'; my $comment = $5;
		Log("sp_adduser_req: $user,$passwd,$group1,$group2,$comment\n");
		if ( $user eq 'root' )
		{
			print "<sp_adduser>Error: root is system reserved</sp_adduser>";
			exit(-1);
		}
		my $answer = AddUser("$user","$passwd","$group1","$group2","$comment");
		print "<sp_adduser>$answer</sp_adduser>";
    }
    elsif ( $line =~ m^<sp_user_info><user>(.+)</user></sp_user_info>^ )
    {
		# <sp_user_info><user>u10</user></sp_user_info>

		# dja:   ? ?!

		# my $user = $1;
		# my $answer = UserInfo("$user");
		# print $answer; 

		#   :)
		print UserInfo($1);
    }
    elsif ( $line =~ m^<sp_user_del>(.+)</sp_user_del>^ )
    {
		# <sp_user_del>u15</sp_user_del>	
		my $user = $1; my $answer;
		DelUser($user);
    }
    elsif ( $line =~ m^<sp_user_chpass><user>(.+)</user><passwd>(.+)</passwd></sp_user_chpass>^ )
    {
		# <sp_user_chpass><user>petrov</user><passwd>p</passwd></sp_user_chpass>	
		my $user = $1; my $pass = $2;
		my $ans = ChPassUser($user,$pass);
		print $ans;
    }
    elsif ( $line =~ m^<sp_bells_cron>(.*)</sp_bells_cron>^ )
    {
	   	bells_cron(\$line);
    }
    elsif ( $line =~ m^<sp_content_filter>(.*)</sp_content_filter>^ )
    {
	   	#   ip  
	   	internet_access_control_configure_squid($1);
    }
    elsif ( $line eq 'quit' or $line eq 'q' )
    {
        Quit('Exiting due command "quit"');
    }
    else
    {
        print "$line\n";
    }
}

sub ChPassUser {
    my ($user,$passwd) = @_;
    my $ret_data;
    if ($user eq 'root')
    {
		return "root password change is denied";
    }

    if (NotExist('samba',"$user")) { $ret_data = qq^smb user "$user" not found^ }
    else { 
	system("( echo \"$passwd\" ; echo \"$passwd\" ) | smbpasswd -s \"$user\"  >> /var/log/sphelper.log 2>&1");
	$ret_data = qq^password for smb user "$user" changed^;
    }
    return $ret_data
}
sub CreateHomeDir {
#    <sp_adduser><user>petrov</user><passwd>p</passwd><group1>students</group1><group2>c6a</group2><comment> </comment></sp_adduser>
    my ($user,$group1,$group2) = @_;
    my $p2hEx if -d "$path2homes" || system qq^mkdir -p "$path2homes"^;
    my $p2sEx if -d "$path2homes/$group1" || system qq^mkdir -p "$path2homes/$group1"^;
    if ($group1 eq 'students') {
	my $pnum = $group2; $pnum =~ s/(\D)//gi;
	if (length $pnum == 1) { $pnum = '0'.$pnum }
	mkdir "$path2homes/$group1/parallel$pnum" unless -d "$path2homes/$group1/parallel$pnum";
	mkdir "$path2homes/$group1/parallel$pnum/$group2" unless -d "$path2homes/$group1/parallel$pnum/$group2";
	mkdir "$path2homes/$group1/parallel$pnum/$group2/$user" unless -d "$path2homes/$group1/parallel$pnum/$group2/$user";
    }
    GetLocale();
    
#    mkdir  "$path2homes/$group1/$group2/$user";
}
#sub GetLocale {
#    print setlocale(LC_CTYPE);
#}
sub DelUser {
    my $cmd = qq^smbpasswd -x $_[0] >> /var/log/sphelper.log^;
    $cmd .= qq^; userdel $_[0] >> /var/log/sphelper.log^ if $Mandriva;
    system $cmd;
}
sub AddUser
{
    my ($user,$passwd,$group1,$group2,$comment) = @_;
    
    my $ret_data;
    my $mojno = 0;

    if (GroupExist("$group1")) { $mojno = 1 }
    else { GroupCreate("$group1"),$mojno = 1 }

    if ($group2 and GroupExist("$group2")) { $mojno = 1 }
    elsif ($group2) { GroupCreate("$group2"),$mojno = 1 }

    if ( $mojno )
    {
		# if home dir already exists before user creation, chown it to future user
	    if ( -e "/home/$user" )
	    {
			system qq[echo 'chown -R $user:$group1 /home/$user' >> /var/log/sphelper.log];
			system qq[chown -R $user:$group1 /home/$user >> /var/log/sphelper.log 2>&1];
	    }

		$ret_data = AddUnixUser("$user","$group1","$group2","$comment","$passwd");
		$ret_data .= '|';
		$ret_data .= AddSmbUser("$user","$passwd");
    }

    CreateHomeDir($user,$group1,$group2) if $create_home;
    return $ret_data;
}
sub DelUserFromGroup {
    my ($user,$group) = @_;
    my $cmd = qq^gpasswd -d $user $group >> /var/log/sphelper.log^;
    system $cmd;
}
sub AddUser2Group {
    my ($user,$group) = @_;
    my $cmd = qq^gpasswd -a $user $group >> /var/log/sphelper.log^;
    system $cmd;
}
sub AddUnixUser {
    my ($username,$group1,$group2,$comment,$pass) = @_;
    my $cmdt = '-m' if $Ubuntu;

    # ecnode account comment for /etc/passwd to server's locale
	use Text::Iconv;
	my $converter = Text::Iconv->new ( 'windows-1251', $comment_encoding );
	$comment = $converter->convert($comment);

    if (NotExist('unix',"$username"))
    {
		my $txt; $txt = qq^-G "$group2" ^ if $group2;

		my $cmd = qq^useradd "$username" -g "$group1" $txt -c "$comment" $cmdt >> /var/log/sphelper.log 2>&1^;
        system $cmd;
    }
    else
    {
	my @forg = split/,/,UserInfoFor($username);
	#
	if ($forg[0] eq 'students' and $forg[1] =~ /^class_/) {
	    if ($forg[1] ne $group2) {
		DelUserFromGroup($username,$forg[1]);
	        unless ( GroupExist($group2) )
	        {
		  GroupCreate($group2);
	        }
		AddUser2Group($username,$group2);
		system qq[usermod --comment "$comment" $username >> /var/log/sphelper.log];
	    }
	}# teacher
	#elsif ($forg[0] eq 'teachers') {
	#    print "ok"
	#}
	# teachers,students,c5b
	my $cmd = qq^( echo "$pass" ; echo "$pass" ) | smbpasswd -s "$username"  >> /var/log/sphelper.log 2>&1^;
	system $cmd;
#	return "0"
	}
	
	# set unix password
	system("(echo \"$pass\"; echo \"$pass\") | passwd \"$username\" >> /var/log/sphelper.log 2>&1");

}
sub AddSmbUser {
    my ($username,$passwd) = @_;
    if (NotExist('smb',"$username")) {
        system("( echo \"$passwd\" ; echo \"$passwd\" ) | smbpasswd -s -a \"$username\"  >> /var/log/sphelper.log 2>&1")
    }
    else { print "Samba user \"$username\" exist. Ignoring...\n" }
}
sub UserInfo {
    my $user = $_[0];
    my $ans = `id $user`; my ($g,@groups,$gr_pull);
    if ($ans =~ /(groups=)(.+)/gi) {
	$g = $2; @groups = split /,/,$g;
	foreach my $gr(@groups) { $gr =~ /(\()(.+)(\))/; $gr_pull .= "$2,"; }
	$gr_pull =~ s/,$//;
	return "<sp_user_info><user>$user</user><groups>$gr_pull</groups></sp_user_info>";
    }
    else { return "<sp_user_info>no such user</sp_user_info>" }
}
sub UserInfoFor {
    my $user = $_[0];
    my $ans = `id $user`; my ($g,@groups,$gr_pull);
    if ($ans =~ /(groups=)(.+)/gi) {
	$g = $2; @groups = split /,/,$g;
	foreach my $gr(@groups) { $gr =~ /(\()(.+)(\))/; $gr_pull .= "$2,"; }
	$gr_pull =~ s/,$//;
	return "$gr_pull";
    }
    else { return "<sp_user_info>no such user</sp_user_info>" }
}
sub GroupCreate {
    my $cmd = qq^net rpc group add "$_[0]" -S $srv -U $smbuser%"$smbpass"  > /dev/null 2>&1^;
    my $ret = system($cmd);

    # dja add: unix group
    my $cmd = qq|groupadd -f "$_[0]"|;
    my $ret2 = system($cmd);

    return ($ret and $ret2);
}

#========================================================================
# Records given
# <line>strings...</line><line>strings...</line>...
# to file and reloads cron
#========================================================================
sub bells_cron()
{
	my $line = shift;

	# TODO: make crossplatform, make config var
	my $sp_bells_cron = '/etc/cron.d/sp_bells_cron';

	if ( $$line eq '' )
	{
		system "rm -f $sp_bells_cron";
	}
	else
	{
		my @cron_lines;

		if ( @cron_lines = ( $$line =~ m|<line>([^<]+)</line>|g ) )
		{
			open F, ">$sp_bells_cron";
			print F "# Bells\n# (C) http://spcms.ru\n\n";
			for my $line ( @cron_lines )
			{
				print F "$line\n";
			}
			close F;

			system "chmod 644 $sp_bells_cron";
		}
	}

	# TODO: brute force is bad
	system "service crond restart > /dev/null 2>&1";
	system "service cron  restart > /dev/null 2>&1";

	print "<OK>\n";
	
}

sub chomp_all {
    my $l = $_[0]; chomp $l; $l =~ s/\r//; return $l;
}
sub date {
    my ($sec,$min,$hour,$mday,$mon,$year,$wday,undef,undef)=localtime; $year += 1900;
    $date = sprintf ("%02d.%02d.%04d",$mday,$mon+1,$year);
    return sprintf ("%02d.%02d.%04d",$mday,$mon+1,$year)." ".sprintf ("%02d:%02d:%02d", $hour,$min,$sec);
}
sub Log {
    print LOG "$_[0]"
}
sub Quit {
    my $text2log = $_[0];
    Log("$text2log\n"); close LOG; exit;
}
sub NotExist {
    my $system = $_[0]; my $username = $_[1]; my $notexist;
    if ($system eq 'unix') {
	$notexist = system("id \"$username\"  >> /var/log/sphelper.log 2>&1")
    }
    else {
	my $cmd = qq^net rpc user info $username -S $srv -U $smbuser%"$smbpass" >> /var/log/sphelper.log 2>&1^;
	$notexist = system $cmd;
    }
    return $notexist
}
sub GroupExist {
    my $group = $_[0];
    my $exists = system("grep -P ^\"$group:\" \"/etc/group\" >> /var/log/sphelper.log 2>&1");
    return 1 if !$exists || 0;
}
sub Trim {
    my @out = @_;
    for (@out) {
        s/^\s+//; 
        s/\s+$//; 
    }
    return @out == 1 ? $out[0] : @out;
}
sub read_config($) {
  my %config;
  open CONFIG, "$_[0]" or die("   .<br> = $_[0]");
  while (<CONFIG>)
  {
    chomp;
    s/#.*//;
    s/^\s+//;
    s/\s+$//;
    next unless length;
    my ( $var, $value ) = split ( /\s*=\s*/, $_, 2 );
    $config { $var } = $value;
  }
  close CONFIG;  return ( %config );
}
sub OS {
    my $s = `cat /etc/issue`;
    if ($s =~ /Mandriva/) { $Mandriva = 1 }
    elsif ($s =~ /Ubuntu/) { $Ubuntu = 1 }
    return $OS;
}

#========================================================================
#        
#  ,     
#========================================================================
sub internet_access_control_configure_squid
{
	#   
	my $content_filter_file =
		$gconf{'squid_content_filter'} || '/var/www/sp_squid_content_filter';

	#  
	my $squid_conf = find_squid_conf();

	#  
	#   squid 2.7+
	my $content_filter_line = "include $content_filter_file";

	my $dns = shift;
	if ( $dns eq 'off' )
	{
		Log("rm -f $content_filter_file\n");
		system("rm -f $content_filter_file");
		#  
		if ( 0 == system(qq[grep -q '$content_filter_line' $squid_conf]) )
		{
			#  
			# , !             
			Log( qq[perl -i -p -e 's!^$content_filter_line\\n?\$!!' $squid_conf\n] );
			system( qq[perl -i -p -e 's!^$content_filter_line\\n?\$!!' $squid_conf] );
		}

		# #  
		# squid_reload();
		# return;
		goto reconfugure_squid;
	}

	open F, ">$content_filter_file";
		# dns_nameservers ip1 ip2
		Log ("dns_nameservers $dns\n");
		print F "dns_nameservers $dns\n";
	close F;

	# grep -q = grep quiet, exitcode 0 if found
	#  ?
	if ( system(qq[grep -q '$content_filter_line' $squid_conf]) )
	{
		# 
		Log( qq[echo '$content_filter_line' >> $squid_conf\n] );
		system( qq[echo '$content_filter_line' >> $squid_conf] );
	}

	#  
	reconfugure_squid:
	squid_reload();

}

#========================================================================
#   
#========================================================================
sub find_squid_conf()
{
	my @variants = (
		'/etc/squid/squid.conf',  # alt, mandriva
		'/etc/squid3/squid.conf', # ubuntu
	);

	for my $path ( @variants )
	{
		if ( -f $path )
		{
			return $path;
		}
	}

	return '';
}

#========================================================================
#     
#========================================================================
sub squid_reload()
{
	my @init_squid = (
		'/etc/init.d/squid',
		'/etc/init.d/squid3',
	);

	for my $path ( @init_squid )
	{
		if ( -f $path )
		{
			return system("$path reload > /dev/null 2>&1");
		}
	}

	return -1;
}

1;
