# (C) http://spcms.ru
use strict;
use locale;

sub aj_login_free() {
    my $log = param('login');

    aj_print '  .'
      unless $log;

    my $q = $gdb->prepare('select 1 from sp_users where log = ?') or db_error();
    $q->execute($log) or db_error();
    my $a = ( $q->fetchrow_array() )[0];
    $q->finish;
    if ($a) {
        aj_print
q[<span class="login_validity_fail">  ,<br> .</span>];
    }
    else {

        if ( $gconf{'create_dc_users'} eq 'sp-helper' ) {
            $log =~ s/[^0-9a-zA-Z_.\-]//;

            unless ( length $log ) {
                aj_print
q[<span class="login_validity_fail"> .</span>];
            }

            my $sp_user_info = sphelper_request(
                "<sp_user_info>" . "<user>$log</user>" . "</sp_user_info>" );

            if ( $sp_user_info =~ m|<sp_user_info>no such user</sp_user_info>| )
            {
                aj_print " .";
            }
            else {
                aj_print
q[<span class="login_validity_fail">  ,<br> .</span>];
            }
        }
        else {
            aj_print " .";
        }

    }
}

sub aj_subgrp() {
    my $c = param('c');
    my $s = param('s');

    if ( !$c or !$s ) {
        aj_print qq[<span class="bred">  </span>];
    }

    sec_gt0 $c;
    sec_gt0 $s;

    my $response =
'&nbsp;&nbsp;: <select name=g class=def><option value=""></option>';
    my $q = sqlp qq[select id,name from sp_class_subgrp_ref
          where  c = $c and s = $s];
    my @a;
    my $found = 0;
    while ( @a = $q->fetchrow_array ) {
        $found ||= 1;
        $response .=
          ($DEBUG)
          ? qq[<option value="$a[0]">ID=$a[0] $a[1]</option>]
          : qq[<option value="$a[0]">$a[1]</option>];
    }
    $response .= '</select>';
    if ($found) {
        aj_print $response;
    }
    aj_print
      qq[&nbsp;&nbsp;: <a href="?act=subgroups&c=$c&s=$s"></a>];
}

sub aj_acl_switch() {
    my $id  = param('id');
    my $uid = param('uid');
    sec_gt0 $uid;
    my $gid = param('gid');

    unless ( $gid == 1 or $gid == 6 ) {
        security_alert( $gid, ' GID' );
    }

    if ( exists $uid_to_gid_cache{$uid} ) {
        delete $uid_to_gid_cache{$uid};
    }

    if ( exists $uid_exists_in_ACL_cache{"$uid,$gid"} ) {
        delete $uid_exists_in_ACL_cache{"$uid,$gid"};
    }

    if ( sqlff "select 1 from sp_users_acl where uid = $uid and gid = $gid" ) {
        sql "delete from sp_users_acl where uid = $uid and gid = $gid";
        aj_print "$uid,$gid,0";
    }
    else {
        sql "insert into sp_users_acl (uid, gid) values ($uid, $gid)";
        aj_print "$uid,$gid,1";
    }

}

sub aj_sms_send() {
    my $datetime = strftime( '%Y-%m-%d %H:%M:%S', localtime );

    my $number = param('number');
    $number =~ s/[^\+\d]//g;
    my $text = param('text');

    my $catch_naked_text_before_converting = $text;

    $text =~ s/'//g;
    $text = trim($text);

    unless ( length($text) ) {
        system
qq[echo '$datetime | ERROR! Empty SMS to $number | raw text: $catch_naked_text_before_converting' >> sms-log2];
        aj_print(" ");
    }

    my $rc;

    if ( $gconf{'sms_center_login'} ) {

        $text = utf8_to_win($text);

        my $ua = LWP::UserAgent->new;
        my $r;

        $ua->agent('SP');

        my $sender = sqlff
          q[select f_char from sp_settings where name = 'sms-gate-sender'];

        $r = $ua->post(
            $g_sms_gate_url,
            {
                     'login' => $gconf{'sms_center_login'}
                  || 'test', 'password' => $gconf{'sms_center_password'}
                  || '123', 'sender' => uri_escape($sender), 'number' =>
                  $number, 'text' => uri_escape($text) }
        );

        if ( $r->is_success ) {
            if ( $r->content =~ m|^OK| ) {
                system qq[echo '$datetime | $number | $text' >> sms-log2];

                aj_print(0);
            }
            elsif ( $r->content =~ m|^FAIL: (.+)| ) {
                system qq[echo '$datetime | ERROR! ]
                  . $r->content
                  . qq[ | $number | $text' >> sms-log2];
                aj_print($1);
            }
            else {
                my $tmp = $r->content;
                $tmp =~ s/[';\n\r]//go;
                $tmp = trim($text);

                system qq[echo '$datetime | ERROR! ]
                  . $r->content
                  . qq[ | $number | $text' >> sms-log2];

                aj_print("-1");
            }
        }
        else {
            system qq[echo '$datetime | ERROR! ]
              . $r->content
              . qq[ | $number | $text' >> sms-log2];

            aj_print(" ");
        }

    }
    else {

        $text     = utf8_to_koi8r($text);
        $datetime = win_to_koi8r($datetime);

        $rc = system
qq[export LC_ALL=ru_RU.KOI8-R; echo '$text' | gnokii --sendsms $number --long 1500];

        if ( $rc == 0 ) {
            system qq[echo '$datetime | $number | $text' >> sms-log2];
        }
        else {
            system
qq[echo '$datetime | ERROR! Code: $rc | $number | $text' >> sms-log2];
        }

        aj_print($rc);

    }

}

our %g_allowed_autocomplete_types =
  map { $_ => 1 } qw|human.first_name human.middle_name|;

sub aj_autocomplete() {
    my $type = param('type');
    my $text = lc( utf8_to_win( trim( substr( param('text'), 0, 64 ) ) ) );

    unless ( length($text) ) {
        aj_print("-1");
    }

    unless ( exists( $g_allowed_autocomplete_types{$type} ) ) {
        aj_print("     ");
    }

    my ( $table, $field ) = split( /\./, $type );

    $text = $gdb->quote($text);
    $text =~ s/'//g;

    my @response;

    sqlffa( \@response,
qq[select distinct $field from $table where lower($field) like '%$text%' order by 1]
    );

    aj_print( join( "\n", @response ) );
}

sub aj_whitelist() {
    my $list_id = param('id');

    if ( defined($list_id) and $list_id != -1 ) {
        sec_gteq0($list_id);
    }

    my $name = utf8_to_win( trim( param('name') ) );

    my $op = param('op');

    if ( $op eq 'get-list' ) {
        aj_print( get_whitelists_html() );
    }

    if ( $op eq 'delete-list' ) {
        sql "delete from SP_SITES_WHITELIST where id = $list_id";
        aj_print("ok");
    }

    escape_tag( \$name );

    $name = substr( $name, 0, 64 );

    if ( $list_id == -1 ) {
        sqlb( "INSERT INTO SP_SITES_WHITELIST (NAME) VALUES (?)", $name );

        $list_id =
          sqlff("select gen_id(GEN_SP_SITES_WHITELIST_ID, 0) from dual");
    }
    else {
        sqlb( "update SP_SITES_WHITELIST set name = ? where id = $list_id",
            $name );
    }

    my @list = split( /\s+/, utf8_to_win( param('list') ) );

    sql "delete from SP_SITES_WHITELIST_ITEMS where LIST_ID = $list_id";

    for (@list) {
        $_ = substr( $_, 0, 64 );

        sqlb(
"insert into sp_sites_whitelist_items (list_id, site) values ($list_id, ?)",
            $_
        );
    }

    aj_print("ok");

}

1;
