#!/usr/bin/perl -w
use strict;

#------------------------------------------------------------
#  
#------------------------------------------------------------
#  .      'y'  
#   chown  chmod
# perl setup.pl
#------------------------------------------------------------
# 
# ( setup_auto.pl,   )
# perl setup.pl --yes
#------------------------------------------------------------

my $issue = `cat /etc/issue`;

my $apache = 'apache';                                 # default & mandriva
   $apache = 'www-data' if $issue =~ m/untu/i;         # ubuntu
   $apache = 'apache2'  if -e '/etc/altlinux-release'; # alt

print "\n";
# Slackware: /etc/slackware-version
# Mandrake:  /etc/mandrake-release
# Red Hat:   /etc/redhat-release
# Fedora:    /etc/fedora-release
# SuSE:      /etc/SuSE-release
# united:    /etc/UnitedLinux-release
# Debian:    /etc/debian_version

print "--------\n";
print "SP Setup\n";
print "--------\n";

print "Checking required modules...\n";

my @req = qw [
Archive/Zip
CGI
CGI/Carp
CGI/Cookie
CGI/Session
Compress/Zlib
Cwd
Data/Dumper
DBD/InterBase
DBI
Digest/MD5
Encode
File/Copy
File/Find
File/stat
GD
GD/Graph/bars
GD/Graph/pie
HTML/TagFilter
Image/Magick
IO/File
IO/Handle
IO/Socket/INET
locale
LWP/UserAgent
Mail/Sender
MIME/Base64
POSIX
strict
Text/Iconv
Time/HiRes
Time/Local
URI/Escape
];

#    5.8.8:
# Archive/Zip
# CGI
# CGI/Carp
# Data/Dumper
# Encode
# IO/Handle
# IO/Socket/INET
# locale
# MIME/Base64
# POSIX
# strict
# Time/HiRes
# Time/Local

#  :
# DBD/InterBase
# DBI
# GD
# GD/Graph/bars
# HTML/TagFilter
# Image/Magick
# Mail/Sender
# Text/Iconv

my %mod = map { $_ => 1 } @req;

for my $path ( @INC )
{
  for my $m ( @req )
  {
    if ( -e "$path/$m.pm" ) { delete $mod{"$m"} }
  }
}

if ( scalar %mod )
{
  print "ERROR: These modules are not installed:\n";
  print "---------------------------------------\n";
  print join "\n", sort keys %mod;
  print "\n";
  exit;
}

eval
{
  require GD::Graph::bars;
  print 'WARNING: GD::Graph::bars v'.$GD::Graph::bars::VERSION.
        " installed. Must be at least v1.25\n"
    if $GD::Graph::bars::VERSION lt '1.25';
};

print "OK. All required modules installed.\n\n";

# print "This script must be run in ...cgi-bin/sp dir\n";
# print "(usualy /var/www/cgi-bin/sp/) under root.\n";
print "This script will chown -R to apache and chmod executables to 500\n";

unless ( defined $ARGV[0] and $ARGV[0] eq '--yes' )
{
  print "\nDo you really want to continue? ";
  $a = <>;
  exit if $a !~ /^y/i;
}
print "--- going /var/www/cgi-bin/sp\n";
chdir "/var/www/cgi-bin/sp";

print "--- chowning all to apache:apache...\n";
system "chown -R $apache:$apache *";
print "--- chmoding all to 400...\n";
system "chmod -R 400 *";

print "--- chmoding 500 cms/cms.pl sp.cgi msg.pl sms-cron.pl\n";
system "chmod 500 cms/cms.pl sp.cgi msg.pl sms-cron.pl";

system "chmod 644 sms-log"  if ( -e 'sms-log'  );
system "chmod 644 sms-log2" if ( -e 'sms-log2' );

system "chmod +x cms tpl dic";
system 'find tpl -type d -exec chmod u+x {} \;';
system 'find cms/tpl -type d -exec chmod +x {} \;';
system "touch sp.cgi msg.pl cms/cms.pl";

#  psp-bot
system "chmod ugo+r common.pl";

#   
system "chown $apache:mail sp.conf";
system "chmod ug+r sp.conf";

print "--- chmoding all dirs +x in tpl\n";
chdir "/var/www/cgi-bin/sp/tpl";
system 'find . -type d -exec chmod +x {} \;';
chdir "/var/www/cgi-bin/sp/cms/tpl";
system 'find . -type d -exec chmod +x {} \;';

#  'setup_sp_html.sh'
# ------------------------------------

chdir "/var/www/cgi-bin/sp";

print "--- moving sphtml/* to /var/www/html/sp/\n";

#    /var/www/html/sp/,  
unless ( -e '/var/www/html/sp/' )
{
	mkdir '/var/www/html/sp/';
	system "chown $apache:$apache /var/www/html/sp/";
	system "chmod 755 /var/www/html/sp/";
}

if ( -e 'sphtml/' )
{
	system "cp -Rf -- sphtml/* /var/www/html/sp/";
	system "rm -rf ./sphtml";
}

print "\n--- going /var/www/html/sp/\n";
chdir "/var/www/html/sp";
my $dirs_nonuser = 'yui fancybox soundmanager2 img FCKeditor jsTree jquery cms tmp';
# TODO:    - ,   .  @files = `ls -1`;       chown/chmod
print "--- chowning all to apache:apache...\n";
system "chown -R $apache:$apache $dirs_nonuser";
system "chown $apache:$apache *.ico";
system "chown $apache:$apache *.css";
system "chown $apache:$apache *.js";

print "--- chmoding all to 600...\n";
system "chmod -R 600 $dirs_nonuser";
system "chmod 600 *.ico";
system "chmod 600 *.css";
system "chmod 600 *.js";

#  /var/www/html/sp/pic     ,    SPEC/postin
print "--- chown:$apache chmod:775 pic...\n";
system "chown $apache:$apache pic";
system "chmod 775 pic";

print "--- chmoding 500 connector.cgi\n";
system "chmod 500 /var/www/html/sp/FCKeditor/editor/filemanager/connectors/perl/connector.cgi";
system "touch /var/www/html/sp/FCKeditor/editor/filemanager/connectors/perl/connector.cgi";

print "--- chmoding all dirs +x\n";
system 'find /var/www/html/sp/ -type d -exec chmod +x {} \;';
