#!/usr/bin/perl -w

# =======================================================================
#      XXI  CMS (  --CMS) ,
#      (   SQL +    ).
# , ,      .
#      !
# =======================================================================

use strict;
use CGI 'redirect'; #    
use CGI::Carp;

push @INC, '/var/www/cgi-bin/sp';

require "common.pl";

my $generated_sql = "/tmp/sp_update_gen.sql";

unless ( $ARGV[0] )
{
	exit print "usage $0 /path/to/sp.conf /path/to/file.sql [--cms]\n";
}

#  CMS?
my $for_cms = 0;

if ( defined($ARGV[2]) and $ARGV[2] eq '--cms' )
{
	$for_cms = 1;
}

my %c;
#    
open CONFIG, $ARGV[0] or die("Can't open $ARGV[0]: $!");
	while (<CONFIG>)
	{
		chomp;
		s/#.*//;
		s/^\s+//;
		s/\s+$//;
		next unless length;
		my ($var, $value) = split( /\s*=\s*/, $_, 2 );
		$c{$var} = $value;
	}
close CONFIG;

open O, '>', $generated_sql;
open F, '<', $ARGV[1];

	#       ,   
	if ( $for_cms )
	{
		print O qq[connect $c{'cmsdbhost'}:$c{'cmsdbname'} user $c{'cmsdbuser'} password $c{'cmsdbpasswd'};\n];
	}
	else
	{
		print O qq[connect $c{'db_server'}:$c{'db_path'} user $c{'db_user'} password $c{'db_pass'};\n];
	}

	while (<F>)
	{
		print O $_;
	}

close F;
close O;

my $isql = find_tool('isql');

if ( $isql )
{

	# 1   XXI
	my $dialect = 1;
	my $DB      = $c{'db_path'};

	# 3   CMS
	if ( $for_cms )
	{
		$dialect = 3;
		$DB = $c{'cmsdbname'};
	}

	print "\n*** Running SQL from $ARGV[1] on $DB\n";
	system("$isql -sqldialect $dialect -charset WIN1251 -input $generated_sql");
	print "*** Running SQL completed.\n\n";
}
else
{
	print "ERROR: isql from Firebird not found!\n";
}

unlink($generated_sql);
