/*
4.1 -> 4.2
*/

CREATE GENERATOR GEN_GRADUATES_ID;

CREATE TABLE GRADUATES (
    ID_G     SMALLINT NOT NULL,
    FIO      VARCHAR(128),
    YEAR_G   SMALLINT,
    CLASS    VARCHAR(64),
    MEDAL    SMALLINT,
    SUM_PUP  SMALLINT
);

CREATE INDEX GRADUATES_IDX1 ON GRADUATES (ID_G);
CREATE INDEX GRADUATES_IDX2 ON GRADUATES (MEDAL);
CREATE INDEX GRADUATES_IDX3 ON GRADUATES (YEAR_G);

SET TERM ^ ;

CREATE OR ALTER TRIGGER GRADUATES_BI FOR GRADUATES
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.id_g is null) then
    new.id_g = gen_id(gen_graduates_id,1);
end
^

SET TERM ; ^
