/* -------------------------------------------------------------------- */
/* news comment */
/* -------------------------------------------------------------------- */

update modules
	set m_config = m_config || 'news_comment=1,'
	where modulename='news';

update modules_cnf_users
	set m_config = m_config || 'news_comment=1,'
	where mod_id = (select i_id from modules where modulename = 'news');

commit;

CREATE GENERATOR GEN_NEWS_COMMENT_ID;

CREATE TABLE NEWS_COMMENT (
    CN_ID    INTEGER NOT NULL,
    N_ID     INTEGER,
    TEXT     VARCHAR(2048),
    AUTOR    INTEGER,
    OWNER    INTEGER,
    DATE_CN  TIMESTAMP
);

ALTER TABLE NEWS_COMMENT ADD CONSTRAINT PK_NEWS_COMMENT PRIMARY KEY (CN_ID);

CREATE UNIQUE INDEX NEWS_COMMENT_IDX1 ON NEWS_COMMENT (CN_ID, N_ID);

SET TERM ^ ;

/* Trigger: NEWS_COMMENT_BI */
CREATE OR ALTER TRIGGER NEWS_COMMENT_BI FOR NEWS_COMMENT
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.cn_id is null) then
    new.cn_id = gen_id(gen_news_comment_id,1);
end
^
SET TERM ; ^


/* -------------------------------------------------------------------- */
/* news informer */
/* -------------------------------------------------------------------- */

INSERT INTO MODULES
(MODULENAME, VISIBLE_NAME, MODULEDIR, MODULEFILE, M_DEF_LINK, ACCESS, M_PLACE, SHOW_ON, M_CONFIG)
VALUES
('newsinf', ' - ', NULL, NULL, 'mod=newsinf', ',6,,2,,4,', 'left', ',AllPage,', ',newsinf_view=1,newsinf_num=7,newsinf_txt_len=45,newsinf_sh_date=');


/* -------------------------------------------------------------------- */
/* customblock */
/* -------------------------------------------------------------------- */

UPDATE MODULES SET VISIBLE_NAME = '  1' WHERE (MODULENAME = 'customblock');

/* -------------------------------------------------------------------- */
/* 3    */
/* -------------------------------------------------------------------- */

INSERT INTO MODULES (MODULENAME, VISIBLE_NAME, MODULEDIR, MODULEFILE, M_DEF_LINK, ACCESS, M_PLACE, SHOW_ON, M_CONFIG) VALUES ('customblock2', '  2', NULL, NULL, 'mod=customblock2', ',6,2,4,', 'left', NULL, NULL);
INSERT INTO MODULES (MODULENAME, VISIBLE_NAME, MODULEDIR, MODULEFILE, M_DEF_LINK, ACCESS, M_PLACE, SHOW_ON, M_CONFIG) VALUES ('customblock3', '  3', NULL, NULL, 'mod=customblock3', ',6,2,4,', 'left', NULL, NULL);
INSERT INTO MODULES (MODULENAME, VISIBLE_NAME, MODULEDIR, MODULEFILE, M_DEF_LINK, ACCESS, M_PLACE, SHOW_ON, M_CONFIG) VALUES ('customblock4', '  4', NULL, NULL, 'mod=customblock4', ',6,2,4,', 'left', NULL, NULL);

/* ,  ,   1 */
ALTER TABLE CUSTOM_BLOCK ADD BLOCK_NUMBER SMALLINT DEFAULT 1 NOT NULL;
UPDATE CUSTOM_BLOCK SET BLOCK_NUMBER = 1;

/* -------------------------------------------------------------------- */
/*  -  */
/* -------------------------------------------------------------------- */

CREATE TABLE PMENU_DATA (
    SBORNIK     VARCHAR(32),
    KOD         SMALLINT NOT NULL,
    VYHOD       VARCHAR(16),
    PRICE       NUMERIC(15,2),
    BELKI       NUMERIC(15,2),
    JIRY        NUMERIC(15,2),
    UGLEVODY    NUMERIC(15,2),
    KKAL        NUMERIC(15,2),
    TYPE_ZO     SMALLINT,
    DATE_ZO     DATE,
    NUMOU       SMALLINT,
    SORT_ORDER  SMALLINT
);

CREATE INDEX PMENU_DATA_IDX1 ON PMENU_DATA (DATE_ZO);
CREATE INDEX PMENU_DATA_IDX2 ON PMENU_DATA (KOD);
CREATE INDEX PMENU_DATA_IDX3 ON PMENU_DATA (TYPE_ZO);
CREATE INDEX PMENU_DATA_IDX4 ON PMENU_DATA (SORT_ORDER);
CREATE INDEX PMENU_DATA_IDX5 ON PMENU_DATA (NUMOU);

CREATE GENERATOR GEN_PMENU_MOU_REF_ID;

CREATE TABLE PMENU_MOU_REF (
    ID_OU      SMALLINT NOT NULL,
    NAME_OU    VARCHAR(256),
    MAIL       VARCHAR(64),
    NAME_REAL  VARCHAR(128)
);


/* Trigger: PMENU_MOU_REF_BI */
SET TERM ^ ;

CREATE OR ALTER TRIGGER PMENU_MOU_REF_BI FOR PMENU_MOU_REF
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.id_ou is null) then
    new.id_ou = gen_id(gen_pmenu_mou_ref_id,1);
end
^

SET TERM ; ^

CREATE TABLE PMENU_REF (
    KOD     SMALLINT NOT NULL,
    NAME_B  VARCHAR(512)
);

ALTER TABLE PMENU_REF ADD CONSTRAINT PK_PMENU_REF PRIMARY KEY (KOD);

CREATE GENERATOR GEN_PMENU_TYPE_REF_ID;

CREATE TABLE PMENU_TYPE_REF (
    ID_TYPE    SMALLINT NOT NULL,
    TYPE_NAME  VARCHAR(256)
);

CREATE UNIQUE INDEX PMENU_TYPE_REF_IDX1 ON PMENU_TYPE_REF (ID_TYPE);

SET TERM ^ ;

/* Trigger: PMENU_TYPE_REF_BI */
CREATE OR ALTER TRIGGER PMENU_TYPE_REF_BI FOR PMENU_TYPE_REF
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.id_type is null) then
    new.id_type = gen_id(gen_pmenu_type_ref_id,1);
end
^

SET TERM ; ^

INSERT INTO MODULES
(MODULENAME, VISIBLE_NAME, MODULEDIR, MODULEFILE, M_DEF_LINK, ACCESS, M_PLACE, SHOW_ON, M_CONFIG)
VALUES
('pmenu', ' - ', NULL, NULL, 'mod=pmenu', ',6,', 'center', NULL, NULL);


/* -------------------------------------------------------------------- */
/*  */
/* -------------------------------------------------------------------- */

INSERT INTO MODULES (MODULENAME, VISIBLE_NAME, MODULEDIR, MODULEFILE, M_DEF_LINK, ACCESS, M_PLACE, SHOW_ON, M_CONFIG) VALUES
('bellsinf', ' - ', NULL, NULL, 'mod=bellsinf', ',6,,2,,4,', 'left', ',AllPage,', NULL);
INSERT INTO MODULES (MODULENAME, VISIBLE_NAME, MODULEDIR, MODULEFILE, M_DEF_LINK, ACCESS, M_PLACE, SHOW_ON, M_CONFIG) VALUES
('bells',    ' - ', NULL, NULL, 'mod=bells', ',6,,2,,4,', 'center', NULL, NULL);

CREATE GENERATOR GEN_BELLS_REF_ID;
CREATE GENERATOR GEN_BELLS_ID;

CREATE TABLE BELLS_REF (
    I_ID          SMALLINT NOT NULL,
    NAME_TAB      VARCHAR(512),
    SMENA         SMALLINT,
    DAYS_OF_WEEK  VARCHAR(13) DEFAULT '0,0,0,0,0,0,0',
    USE_INFORMER  SMALLINT DEFAULT 0,
    USE_CRON      SMALLINT DEFAULT 0
);

CREATE TABLE BELLS (
    I_ID    SMALLINT NOT NULL,
    TAB_ID  SMALLINT,
    BSTART  TIME,
    BEND    TIME,
    LESSON  SMALLINT
);

CREATE INDEX BELLS_IDX1 ON BELLS (TAB_ID);

ALTER TABLE BELLS_REF ADD CONSTRAINT PK_BELLS_REF PRIMARY KEY (I_ID);
ALTER TABLE BELLS     ADD CONSTRAINT PK_BELLS     PRIMARY KEY (I_ID);

SET TERM ^ ;

/* Trigger: BELLS_REF_BI */
CREATE TRIGGER BELLS_REF_BI FOR BELLS_REF
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.i_id is null) then
    new.i_id = gen_id(gen_bells_ref_id,1);
end
^

/* Trigger: BELLS_BI */
CREATE TRIGGER BELLS_BI FOR BELLS
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.i_id is null) then
    new.i_id = gen_id(gen_bells_id,1);
end
^

SET TERM ; ^

/* -: 2  */
INSERT INTO BELLS_REF
(I_ID, NAME_TAB, SMENA, DAYS_OF_WEEK, USE_INFORMER, USE_CRON)
VALUES
(1, '',   1, '1,1,1,1,1,0,0', 1, 0);

INSERT INTO BELLS (I_ID, TAB_ID, BSTART, BEND, LESSON) VALUES (1,  1, '08:30:00', '09:10:00', 1);
INSERT INTO BELLS (I_ID, TAB_ID, BSTART, BEND, LESSON) VALUES (2,  1, '09:25:00', '10:05:00', 2);
INSERT INTO BELLS (I_ID, TAB_ID, BSTART, BEND, LESSON) VALUES (3,  1, '10:20:00', '11:00:00', 3);
INSERT INTO BELLS (I_ID, TAB_ID, BSTART, BEND, LESSON) VALUES (4,  1, '11:15:00', '11:55:00', 4);
INSERT INTO BELLS (I_ID, TAB_ID, BSTART, BEND, LESSON) VALUES (5,  1, '12:10:00', '12:50:00', 5);
INSERT INTO BELLS (I_ID, TAB_ID, BSTART, BEND, LESSON) VALUES (6,  1, '13:05:00', '13:45:00', 6);

INSERT INTO BELLS_REF
(I_ID, NAME_TAB, SMENA, DAYS_OF_WEEK, USE_INFORMER, USE_CRON)
VALUES
(2, '', 1, '0,0,0,0,0,1,0', 1, 0);

INSERT INTO BELLS (I_ID, TAB_ID, BSTART, BEND, LESSON) VALUES (7,  2, '08:30:00', '09:10:00', 1);
INSERT INTO BELLS (I_ID, TAB_ID, BSTART, BEND, LESSON) VALUES (8,  2, '09:15:00', '09:55:00', 2);
INSERT INTO BELLS (I_ID, TAB_ID, BSTART, BEND, LESSON) VALUES (9,  2, '10:10:00', '10:50:00', 3);
INSERT INTO BELLS (I_ID, TAB_ID, BSTART, BEND, LESSON) VALUES (10, 2, '11:05:00', '11:45:00', 4);
INSERT INTO BELLS (I_ID, TAB_ID, BSTART, BEND, LESSON) VALUES (11, 2, '12:00:00', '12:40:00', 5);
INSERT INTO BELLS (I_ID, TAB_ID, BSTART, BEND, LESSON) VALUES (12, 2, '12:45:00', '13:25:00', 6);

ALTER SEQUENCE GEN_BELLS_REF_ID RESTART WITH 3;
ALTER SEQUENCE GEN_BELLS_ID     RESTART WITH 13;

/* for themes */
CREATE INDEX MODULES_CNF_USERS_IDX1
ON MODULES_CNF_USERS (OWNER);

CREATE INDEX THEMES_IDX1
ON THEMES (OWNER);

/* for news cetegory */
CREATE GENERATOR GEN_NEWS_CAT_ID;

CREATE TABLE NEWS_CAT (
    ID_N   SMALLINT,
    CAT    VARCHAR(256),
    OWNER  SMALLINT
);

CREATE INDEX NEWS_CAT_IDX1 ON NEWS_CAT (ID_N, OWNER);

SET TERM ^ ;

CREATE OR ALTER TRIGGER NEWS_CAT_BI FOR NEWS_CAT
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.id_n is null) then
    new.id_n = gen_id(gen_news_cat_id,1);
end
^

SET TERM ; ^

ALTER TABLE NEWS ADD CAT SMALLINT;
CREATE INDEX NEWS_IDX1 ON NEWS (CAT);

commit;

INSERT INTO NEWS_CAT (CAT, OWNER) VALUES ('', 6);
INSERT INTO NEWS_CAT (CAT, OWNER) VALUES ('', 6);
INSERT INTO NEWS_CAT (CAT, OWNER) VALUES ('', 6);
INSERT INTO NEWS_CAT (CAT, OWNER) VALUES ('', 6);
INSERT INTO NEWS_CAT (CAT, OWNER) VALUES ('', 6);
INSERT INTO NEWS_CAT (CAT, OWNER) VALUES ('', 6);

CREATE INDEX TEST_USERS_ANSWERS_IDX1 ON TEST_USERS_ANSWERS (QID);

INSERT INTO MODULES
(MODULENAME, VISIBLE_NAME,      MODULEDIR, MODULEFILE, M_DEF_LINK,    ACCESS,      M_PLACE, SHOW_ON,    M_CONFIG)
VALUES
('bloginf', ' - ', NULL,      NULL,       'mod=bloginf', ',6,,2,,4,', 'left', ',AllPage,', ',bloginf_view=1,bloginf_num=7,bloginf_txt_len=45,bloginf_sh_date=,');
