/*
4.1 -> 4.2
*/

CREATE INDEX SP_CLASS_SUBGRP_REF_IDX1 ON SP_CLASS_SUBGRP_REF (C, S);

SET TERM ^ ;

CREATE PROCEDURE GET_ACCOUNT_DETAIL (
    ACCOUNT_ID INTEGER)
RETURNS (
    ENTRY_DATE DATE,
    DOC_CLASS_NAME VARCHAR(50),
    DEBET_SUM NUMERIC(15,2),
    CREDIT_SUM NUMERIC(15,2),
    BALANSE NUMERIC(15,2))
AS
DECLARE VARIABLE DEBET_ATTR INTEGER;
DECLARE VARIABLE UNIT_VALUE NUMERIC(15,4);
DECLARE VARIABLE X_BALANSE NUMERIC(15,2);
DECLARE VARIABLE V_DEBET_SUM NUMERIC(15,2);
DECLARE VARIABLE V_CREDIT_SUM NUMERIC(15,2);
begin
  x_balanse = 0;
  for
    select
      t1.entry_date,
      t2.name as doc_class_name,
      (t3.node_id - t1.debet_node) as debet_attr,
      t1.unit_value
    from sys_entry t1, sys_doc_class_ref t2, sys_matrix t3
    where
      t1.doc_class = t2.doc_class_id and
      t3.view_class = 4001 and
      (t3.node_id = t1.debet_node or t3.node_id = t1.credit_node) and
      t3.vw_pupil = :account_id
    order by entry_date, doc_class, doc
    into :entry_date, :doc_class_name, :debet_attr, :unit_value
  do begin
     if (debet_attr = 0) then begin
        debet_sum = unit_value;
        credit_sum = null;
     end
     else begin
        credit_sum = unit_value;
        debet_sum = null;
     end
     if (debet_sum is null) then v_debet_sum = 0; else v_debet_sum = debet_sum;
     if (credit_sum is null) then v_credit_sum = 0; else v_credit_sum = credit_sum;
     balanse = x_balanse + v_debet_sum - v_credit_sum;
     x_balanse = balanse;
     suspend;
  end
end^

SET TERM ; ^

update RDB$RELATIONS
set RDB$DESCRIPTION = '4.2'
where RDB$RELATION_NAME = 'SP_SETTINGS';
