#!/usr/bin/speedy -X -- -M50
# (C) http://spcms.ru
#!/usr/bin/perl -W

use Archive::Zip qw( :ERROR_CODES :CONSTANTS );
use Image::Magick;
use File::Find;
use File::Copy;
use File::stat;
use Cwd;
use GD::Graph::bars;
use locale;
use POSIX qw(locale_h strftime);
use Time::Local;
use CGI::Session;
use CGI::Carp qw(fatalsToBrowser name=SP_CMS);
use HTML::TagFilter;
use strict;

sub recurse_MMenuPrintList($);
sub level_down(@);
sub dump_queries();

$CGI::POST_MAX = 5242880;

use CGI qw(:standard -no_xhtml);

our $GZIP;

BEGIN {

    sub __cgi_carp_handle_errors {
        my $msg = shift;
        $msg =~ s|/var/www/cgi-bin/sp/||go;
        $msg =~
s/at (.+) line (\d+)/&mdash; <b style="color:#049">$1<\/b>  <b style="color:090">$2<\/b>/g;
        $msg =~ s/, near (.+)/ : <b>$1<\/b>/g;
        $msg =~ s/\n$//o;
        $msg =~ s/\n/<br><br>/go;
        $msg =~
s/Execution of (.+) aborted due to compilation errors\./ <b>$1<\/b> ./go;
        $msg =~
s/Global symbol &quot;([\$\@\%]\w+)&quot; requires explicit package name/<b style="color:red">$1<\/b>  /go;
        $msg =~ s/syntax error/ /go;
        $msg =~
s/Compilation failed in require/   <b style="color:red">require<\/b>/go;
        $msg =~
          s/Unmatched right square bracket/   /go;
        $msg =~
s/Type of arg 1 to push must be array/   push   /go;
        $msg =~ s/Not enough arguments for/  /go;
        $msg =~
s/Bareword (.+) not allowed while (.+) in use/ <b>$1<\/b>       <b>$2<\/b> (  \$, @  %?)/go;
        $msg =~ s/has too many errors/ &ndash;   /go;
        $msg =~ s/Too many arguments for/   /go;
        $msg =~ s/Illegal division by zero/  /go;
        $msg =~
          s/Illegal declaration of subroutine/  /go;
        $msg =~
s/Unmatched right curly bracket/   /go;
        $msg =~ s/at end of line/  /go;
        $msg =~
s/Might be a runaway multi-line (.+) string starting on line (\d+)/,   <b>$1<\/b>    <b>$2<\/b>/go;
        $msg =~
s/Undefined subroutine (.+) called/   $1/go;
        $msg =~ s/Unrecognized character/ /go;
        $msg =~
s/Can't modify constant item in scalar assignment/      /go;
        $msg =~
s/Can't use string \(&quot;(.+)&quot;\) as an? (.+) while &quot;(.+)&quot; in use/    <b>$1<\/b>  <b>$2<\/b>   <b>$3<\/b>/go;
        $msg =~
s/Can't use an undefined value as an ARRAY reference/     /go;
        $msg =~ s/\n/<br><br>/go;
        $msg =~
s/Can't call method &quot;(.+)&quot; on an undefined value/    <b>$1<\/b>   /go;
        exit print
q[<html><head><title>  -  </title><meta name="charset" content="windows-1251"><meta http-equiv="Content-Type" charset="windows-1251" content="text/html"></head>
<body bgcolor=#f5f5f5>
<table width=100% border=0 cellspacing=0 cellpadding=0>
<tr><td>
<div style="background:#fff;border:2px solid #d50;margin:18px 25px;padding:12px 16px;width:auto;font-family:'Lucida Console',monospace; border-radius: 7px;">
<table border=0 cellspacing=0 cellpadding=0>
<tr><td style="font: normal 11pt/1.1em 'Lucida Console', monospace;">
<h1 style="margin-bottom:16px; border-bottom: 1px dotted #ccc; font: normal 20pt/1.1em sans-serif;"></h1>
] . $msg
          . qq[<hr style="margin-top:2em">     <a href="//spcms.ru/feedback" target="_blank"></a>.           .   ,     .
</td></tr></table>
</div>
</td></tr></table></body></html>];
    }
    CGI::Carp::set_message( \&__cgi_carp_handle_errors );
}

require "../common.pl";
require "../menu.pl";

use vars
  qw($DEBUG $GZIP %SQLH $HTTP_HEADER_ADD %ACL $INCVER $gpage %gconf $guid $ggid $gdate
  @wdays @wdays2_from_monday @mnths $g_http_headers_sent $state_date $connected $stat_inbox_new
  %Cache_block %Cache_time %CACHE @names_unique @modules $CS $KSHP $gdsnac $gdbac $owner
  $gdsn $gdbcms $gdsnxxi $gdb $gdbCS $gdsnCS %NewsAutors @editable_self_property_names);

@editable_self_property_names = qw|
  ORGANIZATION_NAME SHORT_ORG_NAME DIRECTOR POST_ADDRESS PHONE
  LICENCE_REG_NO LICENCE_GIVEOUT_DATE LICENCE_TIMEOUT_DATE
  ACCREDITATION_REG_NO ACCREDITATION_GIVEOUT_DATE ACCREDITATION_TIMEOUT_DATE
  |;

$DEBUG           = 0;
$gpage           = '';
%ACL             = ();
%SQLH            = ();
$HTTP_HEADER_ADD = '';

$g_http_headers_sent = 0;

%gconf = read_config('../sp.conf');

if ( $gconf{'site_gzip'} && ( $ENV{HTTP_ACCEPT_ENCODING} || '' ) =~ /gzip/o ) {
    $GZIP = 1;
}

$gdate = todate(time);

my $chpu  = $gconf{'chpu'};
my $mdou  = $gconf{'mdou'};
my $LIGHT = '';
$KSHP = KSHP();
ConnectDBCms();
ConnectDBXxi();
ChpuUn();

our $queryes = 0;
our $gentime;
if ($DEBUG) { $gentime = Time::HiRes::time(); }

my $tpl_file = 'news.html';
my $cms      = "$gconf{'cms'}";
my $rootdir =
  defined( $gconf{'cms_rootdir'} ) ? $gconf{'cms_rootdir'} : '/var/www/html';
my $rootdirsp = $rootdir . '/sp';
our $theme_dir = $rootdirsp . '/cms/themes';
my $theme_url     = '/sp/cms/themes';
my $sp_url        = '/sp/cms';
my $htaccess_file = $rootdir . '/.htaccess';
my @M_Place       = ( "left", "center", "top", "right" );
my @DefaultThemes = qw(sp-blog sp-default sp-grayskin sp-silver xp);
our ($theme);
my ( $sitedate, $error404, $title_head );
our ($autor_insert);
my %MOD_CONFIG;
my $imagemagick = 'convert';
my $timeZone = strftime( "%z", localtime(time) );
my @rfc822_month =
  qw|zero_index_not_used Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec|;

my $HEAD;

setlocale( LC_ALL, "ru_RU.CP1251" );

GetOwner();

GetTheme();
$theme ||= '';

unless ( grep /^$theme$/, @DefaultThemes ) {
    if ( $owner ne '6' and !defined param 'edt' ) {
        $theme_dir = "$rootdirsp/cms/themes/Users_Themes/$owner";
    }
}

$GZIP = 0 if defined param 'edt';

StartHeaders();

if ( $gconf{'central_site'} eq 'yes' ) { $CS = 1; }

Kernel();

print generate_footers() if defined param 'edt';

print dump_queries() if ( $DEBUG and defined param 'edt' );

if ( defined param 'edt' ) {
    print "</body></html>";
}

sub KSHP {
    if ( !$gconf{"accountdbname"} ) { $KSHP = 0 }
    elsif ( $gconf{"db_path"} ne $gconf{"accountdbname"} ) { $KSHP = 1 }
}
sub contentConfig { return 1 }

sub content {
    my $empty = 'empty';
    if ( param('mod') eq 'content' ) {
        if ( defined param('rc') ) {
            ContentCall( param('rc'), $empty );
        }  elsif ( defined param('ls') ) {
            ContentCall( $empty, param('ls') );
        } elsif ( defined param('edt') ) {
            ContentEdit();
        }
        else {
            ContentCall( $empty, '0' );
        };
    }
    else {
        ContentCall( $empty, '0' );
    };
}

sub ContentEdit {
    if ( param('edt') eq 'lst' ) { ContentPrintList() }
    elsif ( param('edt') =~ /^ajax_search_name_sc/ ) {
        print "asd\n";
    }
    elsif ( param('edt') eq 'ajax_pub' ) {
        my $c_id = param('ci');
        sec_gteq0($c_id);
        my $zapros =
"select c_type, published, parent from content where c_id = $c_id and owner = $owner";
        my $q = $gdbcms->prepare($zapros) or db_error();
        $q->execute() or db_error();
        my $published = '0';
        my $parent;
        my @a;
        my %types;

        while ( @a = $q->fetchrow_array() ) {
            $types{$c_id} = $a[0];
            if ( $a[1] eq '0' ) { $published = '1'; }
            $parent = $a[2];
        }
        if ( $types{$c_id} eq '1' ) {
            sqlcms(
"update CONTENT set PUBLISHED = $published where c_id = $c_id and owner = $owner"
            );
        }
        else {
            sqlcms(
"update CONTENT set PUBLISHED = $published where (c_id = $c_id or parent = $c_id) and owner = $owner"
            );
        }
        aj_print('');
    }
    elsif ( param('edt') eq 'ajax_pubcs' ) {
        my $c_id = param('ci');
        my $cs_id;
        ConnectDBCS();
        unless ( $cs_id =
            sqlffcms("select cs_id from content where c_id = $c_id") )
        {
            $cs_id = LastContentAdd2CS($c_id);
            sqlcms(
"update CONTENT set CS_ID = '$cs_id' where c_id = $c_id and owner = $owner"
            );
        }
        else {
            my $sh_id = SchoolID();
            sqlCS(
"delete from CS_LAST_CONTENT where i_id = $cs_id and sh_id = '$sh_id'"
            );
            sqlcms(
"update CONTENT set CS_ID = '0' where c_id = $c_id and owner = $owner"
            );
        }
        aj_print('');
    }
    elsif ( param('edt') eq 'mva' ) {
        my $a_id = param('ai');
        my $s_id = param('si');
        sqlcms(
"update CONTENT set PARENT = $s_id where C_ID = $a_id and owner = $owner"
        );
        ContentPrintList();
    }
    elsif ( param('edt') eq 'ac' and !defined param('chead') ) {
        ContentAddForm('ac');
    }
    elsif ( param('edt') eq 'as' and !defined param('chead') ) {
        ContentAddForm('as');
    }
    elsif ( ( param('edt') eq 'ac' or param('edt') eq 'as' )
        and defined param('chead') )
    {
        my $type   = '1';
        my $parent = param('section');
        my $chead  = substr( param('chead'), 0, 511 );
        if ( param('edt') eq 'as' ) {
            if ( $chead eq ' ' ) {
                stop(
"  ' '  .<br>       ."
                );
            }
            $type = $parent = '0';
        }
        my $text = param('text');
        my $date =
          ( param('R1') eq 'special' )
          ? "'" . param('startdate') . ":00'"
          : "'NOW'";
        my $published = ( param('C1') eq 'on' ) ? '1' : '0';
        my $permalink = param('permalink') || 'NULL';
        $permalink = cms_uniq_permalink($permalink);

        sqlbcms(
"INSERT INTO content (HEAD, STARTDATE, ENDDATE, TEXT, PUBLISHED, AUTOR, OWNER, C_TYPE, PARENT, PERMALINK)
		values (?, $date, $date, ?, $published, $autor_insert, $owner, $type, $parent, ?)",
            $chead, $text, $permalink
        );

        ContentPrintList();
    }
    elsif ( param('edt') eq 'ec' and !defined param('chead') ) {
        my $c_id = param('ci');
        sec_gteq0($c_id);
        my $q = $gdbcms->prepare(
qq{select HEAD, TEXT, PUBLISHED, PERMALINK from CONTENT where c_id = $c_id and owner = $owner}
        ) or db_error();
        $q->execute() or db_error();
        my @a;
        my ( $chead, $text, $published, $permalink );
        while ( @a = $q->fetchrow_array() ) {
            $chead     = $a[0];
            $text      = $a[1];
            $published = $a[2];
            $permalink = $a[3];
        }
        ContentAddForm( "sc", $c_id, $chead, $text, $published, $permalink );
    }
    elsif ( param('edt') eq 'sc' and defined param('chead') ) {
        my $c_id  = param('ci');
        my $chead = substr( param('chead'), 0, 511 );
        my $text  = param('text');
        my $date  = "STARTDATE = 'NOW',";
        if ( param('R1') eq 'V2' ) { $date = '' }
        elsif ( param('R1') eq 'special' ) {
            $date = "STARTDATE = '" . param('startdate') . ":00',";
        }
        my $published = ( param('C1') eq 'on' ) ? '1' : '0';
        my $permalink = param('permalink') || 'NULL';
        $permalink = cms_uniq_permalink( $permalink, 'content', $c_id );

        sqlbcms(
"update CONTENT set HEAD=?,$date TEXT=?, PUBLISHED=$published, PERMALINK=?
		where C_ID = $c_id and owner = $owner", $chead, $text, $permalink
        );

        ContentPrintList();
    }
    elsif ( param('edt') eq 'del' ) {
        if ( defined param('ci') ) {
            my $c_id = param('ci');
            sqlcms("delete from CONTENT where c_id = $c_id and owner = $owner");
            if (
                sqlffcms(
"select i_id from mainmenu where i_link = '$cms?mod=content&rc=$c_id' and owner='$owner'"
                )
              )
            {
                sqlcms(
"delete from mainmenu where i_link = '$cms?mod=content&rc=$c_id' and owner = $owner"
                );
            }
        }
        elsif ( defined param('si') ) {
            my $c_id           = param('si');
            my @DefaultSection = sqlfcms(
"select c_id, head from content where c_id = $c_id and owner = $owner"
            );
            if ( $DefaultSection[1] ne ' ' ) {
                my $UndefSectionID = sqlffcms(
"select c_id from content where head = ' ' and owner = '$owner'"
                );
                sqlcms(
"update CONTENT set PARENT = '$UndefSectionID' where PARENT = $c_id and owner = $owner"
                );
                sqlcms(
                    "delete from CONTENT where c_id = $c_id and owner = $owner"
                );
                if (
                    sqlffcms(
"select i_id from mainmenu where i_link = '$cms?mod=content&ls=$c_id' and owner='$owner'"
                    )
                  )
                {
                    sqlcms(
"delete from mainmenu where i_link = '$cms?mod=content&ls=$c_id' and owner = $owner"
                    );
                }
            }
            else {
                stop(
" ' '  .   ."
                );
            }
        }
        ContentPrintList();
    }
}

sub ContentAddForm {
    my $my    = param('my');
    my $filtr = param('filter');

    my $hiddenedt = $_[0];
    my $c_id      = $_[1];
    my $chead     = $_[2];
    my $text      = $_[3];
    my $published = $_[4];
    my $permalink = $_[5];
    my %CEdit     = (
        as => ' ',
        ac => ' ',
        ec => ' ',
        es => ' '
    );
    print qq^
<h1>: $CEdit{param('edt')}</h1>
<table class=adminform width="100%">
<tr><td>
<form method="POST" action="$cms" name="textForm" onsubmit="return validateForm(this)"><p> :<br>
<input type="text" name="chead" class="def2" value='$chead' maxlength="512"></p>
<p>:<br>
<textarea name="text" id="FCKeditor1" rows=30 cols="71" style="width:100%;height:422px;">^;

    $text =~ s|</textarea>|&lt;/textarea&gt;|g;

    print $text;
    my $dateText;
    my $cheked = 'checked';
    if ( param('edt') eq 'ec' or param('edt') eq 'es' ) {
        $dateText =
qq^<label><input type="radio" value="V2" checked name="R1" onclick="e('ustartdate').style.display='none'"> </label><br>^;
        $cheked = '';
    }
    print qq^</textarea></p>
<input type="hidden" name="mod" value="content" />
<input type="hidden" name="filter" value="$filtr"/>
<input type="hidden" name="edt" value="$hiddenedt"/>
<input type="hidden" name="ci" value="$c_id"/>
<input type="hidden" name="my" value="$my"/>
</td><td valign="top" style="width:168px">
<fieldset><legend> :</legend>
$dateText
<label><input type="radio" value="V1" $cheked name="R1" onclick="e('ustartdate').style.display='none'"> </label><br>

<label><input type="radio" name="R1" value="special" onclick="e('ustartdate').style.display=''"> </label>
<div id="ustartdate" style="display:none">
  <input type="text" name="startdate" size="20" value="^
      . date("d.m.Y H:s")
      . qq^" style="text-align: center">
</div>
</fieldset>^;

    if ( param('edt') eq 'ac' ) {
        my $zapros =
          "select c_id, head from content where c_type = 0 and owner = $owner";
        my $q = $gdbcms->prepare($zapros) or db_error();
        $q->execute() or db_error();
        my @a;
        print
qq^<fieldset style="max-width: 300px; overflow-x: auto; padding: 2"><legend></legend><br><select name=section>^;
        while ( @a = $q->fetchrow_array() ) {
            print qq[<option value="$a[0]">$a[1]</option>];
        }
        print '</select><br></fieldset>';
    }
    print qq^
<fieldset style="padding: 2">
<legend> :</legend>
<input type="text" value="$permalink" name="permalink" size="27" maxlength="256"><br>
 
</fieldset>

<p><label><input type="checkbox" name="C1" value="on" checked="checked">&nbsp;  </label></p>

<div class=hr></div>
<p class="c">
 <button type=submit name="B1"><img src='/sp/img/ok.gif' width=16 height=16 align=absmiddle> </button>
</p><p class="c">
 <button type=button onClick="redir('$cms?mod=content&edt=lst&filter=$filtr')"><img src='/sp/img/button_stop.gif' width=16 height=16 align=absmiddle> </button>
</p>
</form>
<div class=hr></div>
<p class="c"><button type=button onclick="if(confirm('   ?')){redir('?mod=content&edt=del&ci=$c_id');}"><img src='/sp/img/button_del.gif' width=16 height=16 align=absmiddle> </button></p>

</td></tr></table>^;
}

sub ContentPrintList {
    GetConfig('content');
    PageNumUpdate() if param('pgnum');
    my $filtr = param('filter') || '';
    my $ch = sqlff(
"select f_int from sp_user_settings where uid = '$autor_insert' and id = '3'"
    );
    my $view_my = $ch || '2';
    if ( defined param('chk_my') ) {
        sql(
"delete from sp_user_settings where uid = '$autor_insert' and id = '3'"
        ) if $ch;
        sql(
"insert into sp_user_settings (uid,id,f_int) values ('$autor_insert','3','1')"
        ) if !$ch;
        $view_my = '2' if $ch;
        $view_my = '1' if !$ch;
    }
    my $pg = param('pg') || '1';
    my $module = param('mod');
    my $zapros =
      "select c_id, head from content where c_type = 0 and owner = $owner";
    my $q = $gdbcms->prepare($zapros) or db_error();
    $q->execute() or db_error();
    my @a;
    my %sections;
    while ( @a = $q->fetchrow_array() ) { $sections{ $a[0] } = $a[1]; }
    print qq^<h1>:  </h1>^;
    print
qq^<p style="line-height: 1.8em; margin-left: 1.6em"><a class="img i_folder_new" href="$cms?mod=content&edt=as&filter=$filtr"> </a>&nbsp;&nbsp;
	<a class="img i_page_add" href="$cms?mod=content&edt=ac&filter=$filtr"> </a><br>
	  : <select name=section onchange='top.location.href = this.options[this.selectedIndex].value'>
        ^;
    my $key;
    my $selected = "";
    unless ( param('filter') =~ /^-?\d+\/?\d*$/ ) { $selected = "selected"; }
    print
qq[<option value="$cms?mod=content&edt=lst&filter=$key" $selected> </option>];

    foreach $key ( keys %sections ) {
        my $selected = "";
        if ( $key eq param('filter') ) { $selected = "selected" }
        print
qq[<option value="$cms?mod=content&edt=lst&filter=$key" $selected>$sections{$key}</option>];
    }
    my $checked_my = 'checked' if $view_my eq 1;
    print qq^</select>&nbsp;&nbsp;&nbsp;<label for=avg>
            <input id=avg type="checkbox" $checked_my onClick=document.location.href="$cms?mod=content&edt=lst&filter=$key&chk_my">
               
            </label></p>
        ^;

    my $central_site_th = '';

    if ( $owner == 6 ) {
        $central_site_th = qq[<th title=" "></th>];
    }

    my $author_login = sqlff("select log from sp_users where uid = $guid");

    print qq^<table align="center" class="adminlist" width="97%"><tr>
	<th class="n" title=" "></th>
	<th>/</th>
	<th title=" "></th>
	$central_site_th
	<th title="    "></th>
	<th> </th>
	<th></th>
	<th></th>
	<th></th></tr>^;

    my $sec_id = "";
    if ( param('filter') =~ /^-?\d+\/?\d*$/ ) {
        my $par = param('filter');
        $sec_id = "and parent = $par";
    }
    my $sql_my = "and autor = $autor_insert" if $view_my eq '1';
    $q = sqlpcms2page(
"select head, c_type, startdate, autor, published, c_id, parent, cs_id, permalink from content where owner = $owner $sec_id $sql_my order by c_type, startdate DESC"
    );
    my $i = 1;

    while ( @a = $q->fetchrow_array() ) {
        my $rows    = $i / 2;
        my $autor   = GetNameByUid( $a[3] );
        my $type    = $a[1];
        my $trclass = 'row0';
        unless ( $rows =~ /^-?\d+\/?\d*$/ ) { $trclass = 'row1'; }

        my $moveing =
"<select name=section onchange='top.location.href = this.options[this.selectedIndex].value'>";
        my ( $sections_option, $selected );
        my @sections_w;
        foreach $key ( keys %sections ) {
            $selected = ( $key eq $a[6] ) ? ' selected' : '';
            $sections_option = $sections{$key};
            strip_tag( \$sections_option, 'clear' );
            if ( length( $sections{$key} ) > 50 ) {
                @sections_w = split( ' ', $sections_option );
                $sections_option = '';
                for ( my $j = 0 ; length($sections_option) < 45 ; $j++ ) {
                    $sections_option .= $sections_w[$j] . ' ';
                }
                $sections_option .= '...';
            }
            $moveing .=
qq[<option value="$cms?mod=content&edt=mva&ai=$a[5]&si=$key&filter=$filtr&pg=$pg"$selected>$sections_option</option>];
        }
        $moveing .= "</select>";

        my $for_menu  = 'rc';
        my $conent_id = "ci";
        if ( $a[1] eq '0' ) {
            $for_menu  = 'ls';
            $conent_id = "si";
            $moveing   = '-';
        }

        if ( $owner == 6 ) {
            print qq^<tr class="$trclass">
				<td class="n"><a title="" href="^
              . ( $a[8] ? "/$a[8]" : "/content/$for_menu/$a[5]" )
              . qq^" target="_blank"><img src="/sp/img/eye.png"></a></td><td>^;
        }
        else {
            print qq^<tr class="$trclass">
				<td class="n"><a title="" href="^
              . ("/$author_login/content/$for_menu/$a[5]")
              . qq^" target="_blank"><img src="/sp/img/eye.png"></a></td><td>^;
        }

        my $item =
          ( $type eq '0' )
          ? "<b class='img i_folder'>$a[0]</b>"
          : "<div class='img i_page'>$a[0]</div>";
        unless ( $a[0] eq ' ' ) {
            print
qq^<a title="" href="$cms?mod=content&edt=ec&ci=$a[5]&filter=$filtr&pg=$pg">$item</a>^;
        }
        else {
            print $item;
        }

        print
qq[</td><td class="c"><input type="checkbox" onClick="pubcontentsh('$a[5]')"]
          . ( $a[4] eq '1' ? ' checked' : '' )
          . ' title="   "></td>';
        if ( $owner eq '6' and !$CS ) {
            print
qq[<td class="c"><input type="checkbox" onClick="pubcontentcs('$a[5]')"]
              . ( $a[7] ? ' checked' : '' )
              . ' title="   "></td>';
        }

        my $dynamic_murl =
          ( defined( $a[8] ) and $gconf{'chpu'} )
          ? "/$a[8]" : "$cms?mod=content&$for_menu=$a[5]";

        print qq^<td>$moveing</td><td class="c">
		<form method="POST" action="$cms">
		<input type="hidden" name="mod" value="mainmenu" />
		<input type="hidden" name="edt" value="add" />
		<input type="hidden" name="mhead" value="$a[0]" />
		<input type="hidden" name="murl" value="$dynamic_murl" />
		<input type="submit" value="" name="B1"></form></td>
		<td class="c d-a" nowrap>$a[2]</td><td class="c d-a">$autor</td><td class="c">^;

        unless ( $a[0] eq ' ' ) {
            ( my $a0forJava = $a[0] ) =~ s/"|'//gi;
            print
qq^<a title="" href="$cms?mod=content&edt=del&$conent_id=$a[5]&filter=$filtr&pg=$pg" onClick="return confirm('    $a0forJava?')"><img src='/sp/img/button_del.gif' width=16 height=16></a>^;
        }
        else { print '&nbsp;'; }

        print qq^</td></tr>^;
        $i++;
    }
    print "</table>";
    print PageNext($view_my);
}

sub ContentCall {
    my $rc = $_[0];
    my $ls = $_[1];
    if ( $rc ne 'empty' ) {
        sec_gteq0($rc);

        $rc = substr( $rc, 0, 30 );

        my $q = sqlpcms(
"select head, text, autor from content where published = 1 and c_id = $rc and owner = '$owner' and c_type = '1'"
        );

        my @a;
        my %replace;
        while ( @a = $q->fetchrow_array() ) {
            %replace = (
                head  => $a[0],
                text  => $a[1],
                autor => GetNameByUid( $a[2] )
            );
        }
        my $head_section = sqlffcms(
"select head from content where c_id = (select parent from content where c_id = $rc and owner = $owner)"
        );
        $title_head = "$head_section - $replace{'head'}";
        $title_head = "$replace{'head'}"
          if $head_section eq " ";
        ReturnPage( "$theme_dir/$theme/content.html", \%replace );
    }
    elsif ( $ls ne 'empty' ) {
        my $tmpID = '';
        if ( $ls =~ m/^-?\d+\/?\d*$/ and $ls ne '0' ) {
            $ls = substr( $ls, 0, 19 );
            $tmpID = "and c_id = $ls";
        }

        my $q = sqlpcms(
            "select head, text, c_id, I_SORT, parent from CONTENT
                    where c_type = '0' $tmpID and parent = '0' and published = '1' and owner = '$owner'"
        );

        my (
            @a,       %replace, %replace2, @sect_id,
            %id_head, %id_text, %id_sort,  $item
        );
        my @tpl_data_cache = open_tpl("$theme_dir/$theme/contentitem.html");
        my @tpl_data;
        my $BlockContent;
        my @tpl_data_cache2 = open_tpl("$theme_dir/$theme/contentitem2.html");
        while ( @a = $q->fetchrow_array() ) {
            $id_head{ $a[2] } = $a[0];
            $id_text{ $a[2] } = $a[1];
            $id_sort{ $a[2] } = $a[3];
        }
        foreach $item ( sort { $id_sort{$a} <=> $id_sort{$b} } keys %id_sort ) {
            my @tpl_data2;
            my $BlockContent2;
            my $zapros =
"select head, autor, c_id from content where parent = '$item' and c_type = '1' and published = '1' and owner = '$owner' order by I_SORT DESC";
            my $q = $gdbcms->prepare($zapros) or db_error();
            $q->execute() or db_error();
            my $content;
            my $i = 1;
            my @a;

            while ( @a = $q->fetchrow_array() ) {
                $replace2{headcontent} = $a[0];
                $replace2{autor}       = GetNameByUid( $a[1] );
                $replace2{linkcontent} = "$cms?mod=content&rc=$a[2]";
                @tpl_data2             = @tpl_data_cache2;
                tpl_replace_ant( \%replace2, \@tpl_data2 );
                my $htmlline;
                foreach $htmlline (@tpl_data2) { $BlockContent2 .= $htmlline; }
            }
            %replace = (
                headsection => $id_head{$item},
                description => $id_text{$item},
                content     => $BlockContent2
            );
            $title_head = $replace{'headsection'};
            @tpl_data   = @tpl_data_cache;
            tpl_replace_ant( \%replace, \@tpl_data );
            my $htmlline;
            foreach $htmlline (@tpl_data) { $BlockContent .= $htmlline }
        }
        return $BlockContent;
    }
}

sub MouNameInTitle {
    my @mou_name = MOUNameLocal();
    my $num = qq^  $mou_name[1]^ if $mou_name[1];

    my $title;

    if ( defined($owner) and $owner != 6 ) {
        $title =
          qq[<title>]
          . human_hash($owner) .
          qq[ - $mou_name[0] $num -  </title>];
    }
    else {
        $title = qq^<title>$mou_name[0] $num -  </title>^;
    }

    $HEAD .= $title unless $HEAD =~ /$title/;
}

sub Kernel {
    $LIGHT = ' Light' if $gconf{'light'};

    $HEAD = q[<script type="text/javascript" src="/sp/doiMenuDOM.js"></script>
	<meta name="generator" content=" : www.spcms.ru">
	<meta name="keywords" content=" , SP, CMS, ,  ,  ,  ,   ,  ,  ,  ,   sms,  , -1, 83-,   " />
	<link rel="alternate" type="application/rss+xml" title="" href="/rss">
	];

    if (    !defined param('edt')
        and param('mod') ne 'rss'
        and !defined param('act') )
    {
        my ( $top, $left, $center, $right );

        unless ( -d "$theme_dir/$theme" ) {
            print
qq[<div style="color:black; background-color: white; border: 1px solid red; padding: 16px; font: normal 9pt/1.3em; width: 500px; margin: 16px auto;">
					     &quot;<b style="color:red">$theme</b>&quot;    . : <a style="text-decoration: underline" href="$cms?mod=themes&edt=lst"> </a>.       -      ,      .
				</div>];

            if ( $owner == 6 ) {
                $theme = 'sp-default';
            }
            else {
                $theme = '../../sp-default';
            }
        }

        unless ( -f "$theme_dir/$theme/index.html" ) {
            print
qq[<div style="color:black; background-color: white; border: 1px solid red; padding: 16px; font: normal 9pt/1.3em; width: 500px; margin: 16px auto;">
					     &quot;<b style="color:red">$theme</b>&quot;    index.html.<br><br>: <a style="text-decoration: underline" href="$cms?mod=themes&edt=lst"> </a>.       -      ,      .
				</div>];

            if ( $owner == 6 ) {
                $theme = 'sp-default';
            }
            else {
                $theme = '../../sp-default';
            }
        }

        MouNameInTitle();
        $sitedate = SiteDate();

        my $gid_o = gid_o();

        if (   0 == $gid_o
            or 1 == $gid_o )
        {
            $gid_o = 6;
        }

        my $zapros =
"SELECT modulename, modules_cnf_users.m_place, i_sort, modules_cnf_users.show_on
					FROM modules, modules_cnf_users
					WHERE modules_cnf_users.mod_id = modules.i_id and
						modules_cnf_users.published = 1 and modules_cnf_users.owner = '$owner'
						and modules.access like '%,$gid_o,%'";

        my $q = sqlpcms($zapros);

        my @a;
        my ( %ModulesTop, %ModulesLeft, %ModulesCenter, %ModulesRight, $item );
        while ( @a = $q->fetchrow_array() ) {
            if ( $a[1] eq 'top' and ChkShowOn( $a[0], $a[3] ) ) {
                $ModulesTop{ $a[0] } = $a[2];
            }
            elsif ( $a[1] eq 'left' and ChkShowOn( $a[0], $a[3] ) ) {
                $ModulesLeft{ $a[0] } = $a[2];
            }
            elsif ( $a[1] eq 'center' and ChkShowOn( $a[0], $a[3] ) ) {
                $ModulesCenter{ $a[0] } = $a[2];
            }
            elsif ( $a[1] eq 'right' and ChkShowOn( $a[0], $a[3] ) ) {
                $ModulesRight{ $a[0] } = $a[2];
            }
        }

        my @ex_mod =
          qw(pmenu aboutou news content names graduates account feedback analytics loginform gallery guestbook);

        no strict 'refs';

        if ( param('print') == 1 ) {
            my %modules_enabled =
              ( %ModulesTop, %ModulesLeft, %ModulesRight, %ModulesCenter );
            my $module_name = param('mod');

            if ( exists( $modules_enabled{$module_name} ) ) {

                my $html = q[
<div class="dontprint" style="border: 1px solid #777; padding: 8px 16px; margin: 8px 16px;">
    .<br>
    ,  <a href='#' onclick="history.back();"></a>.<br>
  ,  <a href='#' onclick="print(); return false;"></a>.<br>
       .<br>
    .
</div>
];

                $html .= &$module_name();

                if ($GZIP) {
                    binmode(STDOUT);
                    print Compress::Zlib::memGzip($html);
                }
                else { print $html; }

                exit;

            }
        }

        foreach $item ( sort { $ModulesTop{$a} <=> $ModulesTop{$b} }
            keys %ModulesTop )
        {
            if ( grep /^$item$/, @ex_mod ) { $top .= &$item() }
            elsif ( $Cache_block{ $item . $owner }
                and $Cache_time{ $item . $owner } eq $gdate )
            {
                $top .= $Cache_block{ $item . $owner };
            }
            else {
                my $l = &$item();
                $top .= $l;
                $Cache_block{ $item . $owner } = $l;
                $Cache_time{ $item . $owner }  = $gdate;
            }
        }
        foreach $item ( sort { $ModulesLeft{$a} <=> $ModulesLeft{$b} }
            keys %ModulesLeft )
        {
            if ( grep /^$item$/, @ex_mod ) { $left .= &$item() }
            elsif ( $Cache_block{ $item . $owner }
                and $Cache_time{ $item . $owner } eq $gdate )
            {
                $left .= $Cache_block{ $item . $owner };
            }
            else {
                my $l = &$item();
                $left .= $l;
                $Cache_block{ $item . $owner } = $l;
                $Cache_time{ $item . $owner }  = $gdate;
            }
        }
        foreach $item ( sort { $ModulesCenter{$a} <=> $ModulesCenter{$b} }
            keys %ModulesCenter )
        {
            if ( grep /^$item$/, @ex_mod ) { $center .= &$item() }
            elsif ( $Cache_block{ $item . $owner }
                and $Cache_time{ $item . $owner } eq $gdate )
            {
                $center .= $Cache_block{ $item . $owner };
            }
            else {
                my $l = &$item();
                $center .= $l;
                $Cache_block{ $item . $owner } = $l;
                $Cache_time{ $item . $owner }  = $gdate;
            }
        }
        foreach $item ( sort { $ModulesRight{$a} <=> $ModulesRight{$b} }
            keys %ModulesRight )
        {
            if ( grep /^$item$/, @ex_mod ) { $right .= &$item() }
            elsif ( $Cache_block{ $item . $owner }
                and $Cache_time{ $item . $owner } eq $gdate )
            {
                $right .= $Cache_block{ $item . $owner };
            }
            else {
                my $l = &$item();
                $right .= $l;
                $Cache_block{ $item . $owner } = $l;
                $Cache_time{ $item . $owner }  = $gdate;
            }
        }
        if ( param('mod') eq "search" and param('inp') ) {
            $center .= searchResults();
        }
        my %replace = (
            top    => $top,
            center => $center,
            left   => $left,
            right  => $right
        );
        PrintPage( "$theme_dir/$theme/index.html", \%replace );
        undef($top), undef($left), undef($center), undef($right),
          undef($error404);
    }
    elsif ( param('mod') eq 'rss' ) { rss() }
    elsif ( param('act') ) {
        if ( session_check(1) ) {
            my %tmpHash;
            $tmpHash{'mod'} = param('mod');
            no strict 'refs';
            stop("   (1).") unless ( $tmpHash{'mod'} );
            $tmpHash{'mod'}();
        }
        else { exit print redirect("$cms") }
    }
    else {
        if ( CheckSession() ) {
            ModulesSinhro('cms');

            undef %Cache_block if %Cache_block;
            undef %Cache_time  if %Cache_time;

            my %tmpHash;

            $tmpHash{'mod'} = param('mod');

            no strict 'refs';

            stop("   (2).") unless ( $tmpHash{'mod'} );

            $tmpHash{'mod'}();
        }
    }
}

sub CheckParams {
    my @maybeundef = qw(ci filter ni what to chk_my si);
    my @params_123 = qw(ow id ls arc pg rc rn ai section i_id fio
      pgnum ou view num_symb num_head_on_page sh_dt
      n_id n_c);
      my @params_012 = qw(nb mi m cat);
    foreach my $p (param) {
        if ( grep /^\Q$p\E$/ig, @params_123 ) {
            if ( param($p) !~ m/^\d+$/ or param($p) <= 0 ) { error404(1) }
        }
        elsif ( grep /^\Q$p\E$/ig, @maybeundef ) {
            if ( param($p) ne "" and param($p) !~ m/^\d+$/ and param($p) <= 0 )
            {
                error404(2);
            }
        }
        elsif ( grep /^\Q$p\E$/ig, @params_012 ) {
            if ( param($p) !~ m/^\d+$/ or param($p) < 0 ) { error404(3) }
        }
        if ( $p eq 'mod' ) {
            my $k = param('mod');
            unless ( grep /^\Q$k\E$/, @modules ) { error404(4) }
        }

        if ( $p eq 'fltm' ) {
            my $k = param('fltm');
            if ( !grep /^\Q$k\E$/, @M_Place and $k ne "" ) { error404(5) }
        }
    }
}

sub timeRFC822 {

    my $ISO_time = shift;

    $ISO_time =~ s/.\d{4}$//;

    $ISO_time =~
s/(\d{4})-(\d{2})-(\d{2}) (\d{2}:\d{2}:\d{2})/$3 $rfc822_month[$2] $1 $4 $timeZone/;

    return $ISO_time;

}

sub analytics {
    if ( param('edt') eq 'code' ) {
        if ( $ENV{'REQUEST_METHOD'} eq 'GET' ) { print AnalyticsForm() }
        elsif ( $ENV{'REQUEST_METHOD'} eq 'POST' ) {
            my $text = param('text');
            if ( sqlffcms("select 1 from ANALYTICS where owner = $owner") ) {
                sqlbcms(
                    "update ANALYTICS set CONTENT = ? where owner = $owner",
                    $text );
            }
            else {
                sqlbcms(
                    "insert into ANALYTICS (CONTENT, owner) values (?, $owner)",
                    $text
                );
            }
            print AnalyticsForm();
        }
    }
}

sub AnalyticsForm {
    my $content = sqlffcms("select CONTENT from ANALYTICS where OWNER = $owner")
      || '';
    $content =~ s|</textarea>|&lt;/textarea&gt;|g;
    my $form = qq[
            <h1>:  </h1>
            <form style="margin: 0 5%" method="POST" action="$cms" name="textForm" onsubmit="return validateForm(this)">
            <input type="hidden" name="mod" value="analytics">
            <input type="hidden" name="edt" value="code">
            <p style="margin-bottom:8px">     .<br>
            : <a href="http://metrika.yandex.ru/" target="_blank">.</a>, <a href="http://google.com/analytics/" target="_blank">Google Analytics</a>  . .</p>
            <textarea rows=30 cols="71" style="width:100%;height:422px;" name="text">$content</textarea>
            <p style="margin-top:8px" align="center">
            <button type="submit"><img src="/sp/img/save.png"></button></p>
        </form>];
    return $form;
}

sub customblockReal {
    if ( param('edt') eq 'edit' ) {
        if ( $ENV{'REQUEST_METHOD'} eq 'GET' ) {
            print CustomblockForm( $_[0] );
        }
        elsif ( $ENV{'REQUEST_METHOD'} eq 'POST' ) {
            my $text = param('text');
            if (
                sqlffcms(
"select 1 from CUSTOM_BLOCK where owner = $owner and BLOCK_NUMBER = '$_[0]'"
                )
              )
            {
                sqlbcms(
"update CUSTOM_BLOCK set CONTENT = ? where owner = $owner and BLOCK_NUMBER = '$_[0]'",
                    $text
                );
            }
            else {
                sqlbcms(
"insert into CUSTOM_BLOCK (CONTENT, owner, BLOCK_NUMBER) values (?, $owner,'$_[0]')",
                    $text
                );
            }
            print CustomblockForm( $_[0] );
        }

    }
    else {
        return sqlffcms(
"select CONTENT from CUSTOM_BLOCK where OWNER = $owner and BLOCK_NUMBER = '$_[0]'"
        ) || '';
    }
}

sub customblock() {
    customblockReal('1');
}

sub customblock2() {
    customblockReal('2');
}

sub customblock3() {
    customblockReal('3');
}

sub customblock4() {
    customblockReal('4');
}

sub CustomblockForm {
    my $content = sqlffcms(
"select CONTENT from CUSTOM_BLOCK where OWNER = $owner and BLOCK_NUMBER = '$_[0]'"
    ) || '';
    $content =~ s|</textarea>|&lt;/textarea&gt;|g;
    my $bnum = $_[0];
    $bnum = '' if $_[0] eq '1';
    my $form = qq[
        <h1>:  </h1>
        <form style="margin: 0 5%" method="POST" action="$cms" name="textForm" onsubmit="return validateForm(this)">
	<input type="hidden" name="mod" value="customblock$bnum">
	<input type="hidden" name="edt" value="edit">
	<p style="margin-bottom:4px">:</p>
        <textarea name="text" id="FCKeditor1">$content</textarea>
	<p style="margin-top:8px" align="center">
	<button type="submit"><img src="/sp/img/save.png"> </button>
	</p>
        </form>];
    return $form;
}

sub newsinf {
    GetConfig('newsinf');
    unless ( param 'edt' ) {
        my ( @a, $ret_data, %replace, $BlockContent, @tpl_data );
        my $attr           = { ib_timestampformat => '%d.%m.%y' };
        my @tpl_data_cache = open_tpl("$theme_dir/$theme/newsinf_item.html");
        my $q              = sqlpcms(
"select first $MOD_CONFIG{'newsinf_num'} news_id,head,startdate,text from news where published = 1 and owner = '$owner' order by startdate DESC",
            $attr
        );
        while ( @a = $q->fetchrow_array() ) {
            my $date_n = $a[2] if $MOD_CONFIG{'newsinf_sh_date'} || '';
            if ( $MOD_CONFIG{'newsinf_view'} eq '2' ) {
                strip_tag( \$a[3], 'clear' );
                substr( $a[3], $MOD_CONFIG{'newsinf_txt_len'}, length( $a[3] ) )
                  = '...'
                  if length( $a[3] ) > $MOD_CONFIG{'newsinf_txt_len'};
            }
            elsif ( $MOD_CONFIG{'newsinf_view'} eq '3' ) {
                strip_tag( \$a[3], 'clear' );
            }
            my $txtt = $a[3] if $MOD_CONFIG{'newsinf_view'} ne '1' || '';
            %replace = (
                date => $date_n,
                link => qq^$cms?mod=news&rn=$a[0]^,
                text => $txtt,
                head => $a[1]
            );
            @tpl_data = @tpl_data_cache;
            tpl_replace_ant( \%replace, \@tpl_data );
            foreach my $htmlline (@tpl_data) { $BlockContent .= $htmlline }
        }
        my %replace1 = ( news_items => $BlockContent );
        return return_block( \%replace1, "$theme_dir/$theme/newsinf.html" );
    }
}

sub newsinfConfig {
    if ( param('edt') ne 'so' ) { return newsinfConfigForm() }
    elsif ( param('edt') eq 'so' ) {
        GetConfig('newsinf');
        my $mod_id = param('i_id');
        my $view;
        $view = param 'view';
        $view = '2' if $view > 3;
        my $sh = param('sh_dt');
        $sh = '0' if $sh > 1;
        $MOD_CONFIG{'newsinf_txt_len'} = param 'num_symb'         || '45';
        $MOD_CONFIG{'newsinf_num'}     = param 'num_head_on_page' || '6';
        sqlcms(
            qq^update modules_cnf_users set m_config =
               ',newsinf_view=$view,newsinf_num=$MOD_CONFIG{'newsinf_num'},newsinf_txt_len=$MOD_CONFIG{'newsinf_txt_len'},newsinf_sh_date=$sh'
               where i_id = '$mod_id' and owner = '$owner'^
        );
    }
}

sub newsinfConfigForm {
    GetConfig('newsinf');
    my ( $return_data, $chk1, $chk2, $chk3, $chk4 );
    $chk1 = 'checked' if $MOD_CONFIG{'newsinf_view'} eq '1';
    $chk2 = 'checked' if $MOD_CONFIG{'newsinf_view'} eq '2';
    $chk3 = 'checked' if $MOD_CONFIG{'newsinf_view'} eq '3';
    $chk1 = 'checked' unless $chk1 or $chk2 or $chk3;
    $chk4 = 'checked' if $MOD_CONFIG{'newsinf_sh_date'};
    $return_data = qq^<fieldset style="padding: 2">
        <legend>:</legend>
        <input type="radio" name="view" $chk1 value="1">  <br>
        <input type="radio" name="view" $chk2 value="2">     
            <input type="text" align=center name="num_symb" value="$MOD_CONFIG{'newsinf_txt_len'}" size="3"> <br>
        <input type="radio" name="view" $chk3 value="3">    <br>
        </fieldset>
           : <input type="text" align=center name="num_head_on_page" value="$MOD_CONFIG{'newsinf_num'}" size="2"><br>
        <input type="checkbox" name="sh_dt" $chk4 value="1">  
    ^;
    return "$return_data";
}

sub bloginf {
    GetConfig('bloginf');
    unless ( param 'edt' ) {
        my ( @a, $ret_data, %replace, $BlockContent, @tpl_data );
        my $attr           = { ib_timestampformat => '%d.%m.%y' };
        my @tpl_data_cache = open_tpl("$theme_dir/$theme/bloginf_item.html");
        my $q              = sqlpcms(
"select first $MOD_CONFIG{'bloginf_num'} news_id,head,startdate,text,owner from news where published = 1 and owner != 6 order by startdate DESC",
            $attr
        );
        while ( @a = $q->fetchrow_array() ) {
            my $autor = GetNameByUid( $a[4] );

            my $class;

            if ( 4 != sqlff("select gid from sp_users where uid = $a[4]") ) {
                unless (
                    sqlff(
"select f_int from sp_user_settings where uid = $a[4] and id = 6"
                    )
                  )
                {
                    my $staff_name;
                    unless ( $gconf{'light'} ) {
                        $staff_name = sqlff(
                            "select sur.name
from sys_matrix sm
join staff_unit_ref sur on sur.staff_unit_id = sm.staff_unit_ref
where
sm.overlap_type_ref = 0
and
sm.view_class = 3100 and
exists(select 1 from get_node_saldo(sm.node_id, '$gdate', 0) where saldo_sum <> 0)
and
sm.vw_worker = $a[4]"
                        );
                    }
                    $class = ($staff_name) ? $staff_name : '';
                    if ( $gconf{'light'} ) {
                        $class = '';
                    }
                }
            }
            else {
                $class = get_pupil_class( 1, $a[4] );
            }

            my $title = $class ? qq^$autor, $class^ : $autor;

            my $ow_site = sqlff("select log from sp_users where uid = '$a[4]'");
            my $date_n = $a[2] if $MOD_CONFIG{'bloginf_sh_date'} || '';

            if ( $MOD_CONFIG{'bloginf_view'} eq '2' ) {
                strip_tag( \$a[3], 'clear' );
                substr( $a[3], $MOD_CONFIG{'bloginf_txt_len'}, length( $a[3] ) )
                  = '...'
                  if length( $a[3] ) > $MOD_CONFIG{'bloginf_txt_len'};
            }

            elsif ( $MOD_CONFIG{'bloginf_view'} eq '3' ) {
                strip_tag( \$a[3], 'clear' );
            }

            my $txtt = $a[3] if $MOD_CONFIG{'bloginf_view'} ne '1' || '';
            %replace = (
                date  => $date_n,
                link  => qq^$cms?ow=$ow_site&mod=news&rn=$a[0]^,
                text  => $txtt,
                head  => $a[1],
                title => $title
            );
            @tpl_data = @tpl_data_cache;
            tpl_replace_ant( \%replace, \@tpl_data );

            foreach my $htmlline (@tpl_data) { $BlockContent .= $htmlline }
        }
        my %replace1 = ( news_items => $BlockContent );
        return return_block( \%replace1, "$theme_dir/$theme/bloginf.html" );
    };
}

sub bloginfConfig {
    if ( param('edt') ne 'so' ) { return bloginfConfigForm() }
    elsif ( param('edt') eq 'so' ) {
        GetConfig('bloginf');
        my $mod_id = param('i_id');
        my $view;
        $view = param 'view';
        $view = '2' if $view > 3;
        my $sh = param('sh_dt');
        $sh = '0' if $sh > 1;
        $MOD_CONFIG{'bloginf_txt_len'} = param 'num_symb'         || '45';
        $MOD_CONFIG{'bloginf_num'}     = param 'num_head_on_page' || '6';
        sqlcms(
            qq^update modules_cnf_users set m_config =
               ',bloginf_view=$view,bloginf_num=$MOD_CONFIG{'bloginf_num'},bloginf_txt_len=$MOD_CONFIG{'bloginf_txt_len'},bloginf_sh_date=$sh'
               where i_id = '$mod_id' and owner = '$owner'^
        );
    }
}

sub bloginfConfigForm {
    GetConfig('bloginf');
    my ( $return_data, $chk1, $chk2, $chk3, $chk4 );
    $chk1 = 'checked' if $MOD_CONFIG{'bloginf_view'} eq '1';
    $chk2 = 'checked' if $MOD_CONFIG{'bloginf_view'} eq '2';
    $chk3 = 'checked' if $MOD_CONFIG{'bloginf_view'} eq '3';
    $chk1 = 'checked' unless $chk1 or $chk2 or $chk3;
    $chk4 = 'checked' if $MOD_CONFIG{'bloginf_sh_date'};
    $return_data = qq^<fieldset style="padding: 2">
        <legend>:</legend>
        <input type="radio" name="view" $chk1 value="1">  <br>
        <input type="radio" name="view" $chk2 value="2">     
            <input type="text" align=center name="num_symb" value="$MOD_CONFIG{'bloginf_txt_len'}" size="3"> <br>
        <input type="radio" name="view" $chk3 value="3">    <br>
        </fieldset>
           : <input type="text" align=center name="num_head_on_page" value="$MOD_CONFIG{'bloginf_num'}" size="2"><br>
        <input type="checkbox" name="sh_dt" $chk4 value="1">  
    ^;
    return "$return_data";
}

sub pmenu {
    unless ( param 'edt' ) {
        my ( $date, $numou, $return_data );
        if ( param 'date' ) { $date = param 'date'; sec_date($date); }
        if ( $KSHP and !param 'ou' ) { $return_data = PMenuMouList() }
        elsif ( $KSHP and param 'ou' ) {
            $numou = param 'ou';
            $return_data = PMenuGet( $date, $numou );
        }
        elsif ( !$KSHP ) { $return_data = PMenuGet($date) }
        my %replace = ( menu_tables => $return_data );
        return return_block( \%replace, "$theme_dir/$theme/pmenu.html" );
    }
    else {

    }
}

sub PMenuMouList {
    my ( $return_data, @a, $trclass );
    $return_data = qq^<table class="pmenu_moulist" width="100%">
        <tr align=center><th > /</th><th > </th></tr>
    ^;
    my $q = sqlpcms("select * from pmenu_mou_ref order by name_ou");
    my ( %id_num, %id_name );
    my $i  = 1;
    my $i2 = 1;
    while ( @a = $q->fetchrow_array() ) {
        my $mou_name = $a[3] || $a[1];
        $id_name{ $a[0] } = $mou_name;
        $mou_name =~ s/\D+//;
        if   ($mou_name) { $id_num{ $a[0] } = $mou_name }
        else             { $id_num{ $a[0] } = "10000$i2"; $i2++; }
    }
    foreach my $num ( sort { $id_num{$a} <=> $id_num{$b} } keys %id_num ) {
        $trclass = TrClass($i);
        $return_data .=
qq^<tr class=$trclass><td>$i</td><td align=left><a href=$cms?mod=pmenu&ou=$num&date=$gdate>$id_name{$num}</a></td></tr>^;
        $i++;
    }
    $return_data .= "</table>";
    return "$return_data";
}

sub PMenuGet {
    my $datezo = $_[0] || $gdate;
    my $numou = $_[1];
    my $return_data;
    $return_data .= PMenuGetMenu($numou);
    my ( @a, @typezo, %type_zo );
    my $sqlt = qq^and pmenu_data.numou = '$numou'^ if $KSHP;
    my $q = sqlpcms(
"select distinct pmenu_data.type_zo, pmenu_type_ref.type_name from pmenu_data,pmenu_type_ref
                    where pmenu_data.date_zo = '$datezo' $sqlt and pmenu_data.type_zo = pmenu_type_ref.id_type order by pmenu_type_ref.type_name"
    );
    while ( @a = $q->fetchrow_array() ) {
        push @typezo, $a[0];
        $type_zo{ $a[0] } = $a[1];
    }
    foreach my $type (@typezo) {
        $return_data .=
          PMenuGetTable( $type, $datezo, $numou, $type_zo{$type} );
    }
    return $return_data;
}

sub PMenuGetMenu {
    my $numou = $_[0];
    my $menu_html;
    my ( $DateStart, $DateEnd ) = PMenuDateSE($numou);
    my ( @a, @dates, $ou_name );
    my $sqlt = qq^and numou = '$numou'^ if $KSHP;
    if ($KSHP) {
        $ou_name =
          sqlffcms("select name_ou from pmenu_mou_ref where id_ou = '$numou'");
    }
    my $q = sqlpcms(
        "select distinct date_zo from pmenu_data
            where date_zo between '$DateStart' and '$DateEnd' $sqlt order by date_zo"
    );
    while ( @a = $q->fetchrow_array() ) { push @dates, $a[0] }

    $menu_html .= qq^<div class=pmenu_menu_row>^;
    my $txt_num = "&ou=$numou" if $KSHP;
    my $date_curr;
    $menu_html .=
qq^<span class="pmenu_today"><a href=$cms?mod=pmenu$txt_num&date=$gdate></a></span>^
      unless grep /$gdate/, @dates;
    foreach my $da (@dates) {
        my ( $d, $m, $y ) = split /\./, $da;
        $m = $m - 1;
        $da = timelocal( undef, undef, undef, $d, $m, $y, undef, undef, undef );
        my ( undef, undef, undef, undef, undef, undef, $wday, undef, undef ) =
          localtime($da);
        $m = $m + 1;
        $m = sprintf( "%02d", $m );
        my $arrow_stat = 'pmenu_menu_item';
        if (   ( "$d.$m.$y" eq param 'date' )
            or ( !param 'date' and "$d.$m.$y" eq $gdate ) )
        {
            $arrow_stat = 'pmenu-current';
            $date_curr  = "$d.$m.$y";
        }
        if ( $gdate eq "$d.$m.$y" ) { $arrow_stat = 'pmenu-now' }
        if ( $gdate eq "$d.$m.$y"
            and ( "$d.$m.$y" eq param 'date' or !param 'date' ) )
        {
            $arrow_stat = 'pmenu-current pmenu-now';
            $date_curr  = "$d.$m.$y";
        }
        $menu_html .=
qq^<span class="$arrow_stat"><a href=$cms?mod=pmenu&ou=$numou&date=$d.$m.$y>$wdays[$wday-1]</a></span>^
          if $KSHP;
        $menu_html .=
qq^<span class="$arrow_stat"><a href=$cms?mod=pmenu&date=$d.$m.$y>$wdays[$wday-1]</a></span>^
          unless $KSHP;
    }
    $menu_html .= qq^</div>^;
    $menu_html .= qq^<div class=pmenu_ou_name>$ou_name</div>^ if $KSHP;
    $menu_html .= qq^<div class=pmenu-date>: $date_curr</div>^
      if scalar @dates;
    unless ( scalar @dates ) {
        $menu_html .=
"<div class=pmenu-no-data>   $DateStart - $DateEnd  </div>";
    }
    return $menu_html;
}

sub PMenuDateSE {
    my $numou = $_[0];
    my $date;
    $date = param 'date' if param 'date';
    $date = $gdate unless param 'date';
    my ( $d, $m, $y ) = split /\./, $date;
    $m = $m - 1;
    my $da = timelocal( undef, undef, undef, $d, $m, $y, undef, undef, undef );
    my ( undef, undef, undef, undef, undef, undef, $wday, undef, undef ) =
      localtime($da);
    my $dateMin = $wday - 1;
    my $dateMax = 7 - $wday;
    $dateMin = 6, $dateMax = 0 if $wday eq '0';
    my $sutki     = 86400;
    my $timelocal = timelocal( localtime($da) );
    my $DateStart = $timelocal - ( $sutki * $dateMin );
    my $DateEnd   = $timelocal + ( $sutki * $dateMax );
    my ( undef, undef, undef, $Smday, $Smon, $Syear, $Swday, undef, undef ) =
      localtime($DateStart);
    $Syear += 1900;
    $Smon = $Smon + 1;
    my ( undef, undef, undef, $Emday, $Emon, $Eyear, $Ewday, undef, undef ) =
      localtime($DateEnd);
    $Eyear += 1900;
    $Emon      = $Emon + 1;
    $DateStart = "$Smday.$Smon.$Syear";
    $DateEnd   = "$Emday.$Emon.$Eyear";
    return $DateStart, $DateEnd;
}

sub PMenuGetTable {
    my $type      = $_[0];
    my $datezo    = $_[1];
    my $numou     = $_[2];
    my $text_type = $_[3];
    my ( %replace, $startTable, $headTable, $textTable, @a, $priceh );
    $startTable = qq^<table class="pmenu" width="100%">^;
    $priceh     = qq^<th rowspan="2">, .</th>^
      unless grep //i, $text_type || '';
    $headTable = qq^
        <tr align=center>	<th rowspan="2"> </th>
		<th rowspan="2"> </th>
		<th rowspan="2"></th>
		<th rowspan="2"></th>
		$priceh
		<th colspan="4"> </th>
	</tr>
	<tr>	<th></th>
		<th></th>
		<th></th>
		<th></th>
	</tr>
    ^;
    my $sqlt = qq^and pmenu_data.numou = '$numou'^ if $KSHP;
    my $q = sqlpcms(
        "select pmenu_data.*,pmenu_ref.name_b from pmenu_data,pmenu_ref
                where pmenu_data.date_zo = '$datezo' $sqlt
                and pmenu_data.type_zo = '$type' and pmenu_ref.kod = pmenu_data.kod
                order by pmenu_data.sort_order"
    );
    my ( $iprice, $ibelki, $ijiry, $iuglev, $ikkal, $i );
    while ( @a = $q->fetchrow_array() ) {
        my $trclass  = TrClass($i);
        my $recept   = $a[0] if $a[0] ne '0' || '';
        my $belki    = $a[4] if $a[4] ne '0' || '';
        my $jiry     = $a[5] if $a[5] ne '0' || '';
        my $uglev    = $a[6] if $a[6] ne '0' || '';
        my $kkal     = $a[7] if $a[7] ne '0' || '';
        my $pricecol = qq^<td>$a[3]</td>^
          unless grep //i, $text_type || '';
        $textTable .=
qq^<tr class=$trclass><td>$recept</td><td>$a[1]</td><td align=left>$a[12]</td><td>$a[2]</td>$pricecol
		<td>$belki</td><td>$jiry</td><td>$uglev</td><td>$kkal</td></tr>^;
        $iprice += $a[3];
        $ibelki += $a[4];
        $ijiry  += $a[5];
        $iuglev += $a[6];
        $ikkal  += $a[7];
        $i++;
    }

    $textTable .=
qq^<tr class="itogo"><td></td><td></td><td></td><td>:</td><td>$iprice</td>
    <td>$ibelki</td><td>$ijiry</td><td>$iuglev</td><td>$ikkal</td></tr>^
      unless grep //i, $text_type;

    $textTable .=
qq^<tr class="itogo"><td></td><td></td><td></td><td>:</td><td>$iprice&nbsp;.</td>
    <td></td><td></td><td></td></tr>^ if grep //i, $text_type;

    return
"<div class=pmenu_zo>$text_type</div> $startTable $headTable $textTable </table>";
}

sub TrClass {
    my $rows    = $_[0] / 2;
    my $trclass = 'row0';
    unless ( $rows =~ /^-?\d+\/?\d*$/ ) {
        $trclass = 'row1';
    }
    return $trclass;
}

sub pmenuConfig {

}

sub bellsinf {
    my @week_matrix = (0) x 7;
    my ( undef, undef, undef, undef, undef, undef, $wday, undef, undef ) =
      localtime;
    $wday--;
    $week_matrix[$wday] = 1;

    my $week_matrix_sql = join( ',', @week_matrix );
    $week_matrix_sql =~ s/0/%/g;

    my $smena_count = sqlffcms(
        "select	count(1)
		from    bells_ref
		where   use_informer = 1
				and
				days_of_week like '$week_matrix_sql'"
    );

    my @enabled_tabs_today;
    sqlffacms(
        \@enabled_tabs_today,
        "select i_id
		from 	bells_ref
		where	use_informer = 1
				and
				days_of_week like '$week_matrix_sql'"
    );

    unless ( scalar @enabled_tabs_today ) {
        return return_block(
            {
                dates4 => qq|
// dummy data
[ "2000,1,1,1,1,1", ' 1', 1 ],
[ "2000,1,1,1,1,1", ' 1', 1 ]
|,
                smena_count => 1,
            },
            "$theme_dir/$theme/bellsinf.html"
        );
    }

    my ( @a, $dates4 );
    my $q = sqlpcms(
        "select
    		bstart,
    		bend,
    		lesson,
    		(select smena from bells_ref where bells_ref.i_id = bells.tab_id) as smena
    	from
    		bells
    	where
    		tab_id in ( " . join( ',', @enabled_tabs_today ) . " )
    	order by
    		smena,
    		lesson"
    );

    while ( @a = $q->fetchrow_array() ) {

        my ( $h, $min ) = split( /:/, $a[0] );

        $h   = int($h);
        $min = int($min);

        my ( $d, $mon, $y ) = split( /\./, $gdate );
        $mon = $mon - 1;

        $dates4 .= qq^[ "$y,$mon,$d,$h,$min,00", ' $a[2]', $a[3] ],\n^;

        ( $h, $min ) = split( /:/, $a[1] );

        $h   = int($h);
        $min = int($min);

        ( $d, $mon, $y ) = split( /\./, $gdate );
        $mon = $mon - 1;

        $dates4 .= qq^[ "$y,$mon,$d,$h,$min,00", ' $a[2]', $a[3] ],\n\n^;

    }

    $dates4 =~ s/,$//;

    return return_block(
        {
            dates4      => $dates4,
            smena_count => $smena_count,
        },
        "$theme_dir/$theme/bellsinf.html"
    );
}

sub bellsinfConfig {

}

sub bells {
    if ( param 'edt' and ( $owner eq '6' or isadmin() ) ) {
        if ( param('edt') eq 'lst' ) {
            BellsTabList();
        } elsif ( param('edt') eq 'savetab' ) {
            BellsTabEdit();
        } elsif ( param('edt') eq 'del' ) {
            BellsTabDel();
        } elsif ( param('edt') eq 'edit_list' ) {
            BellsTabsEditAll();
        } else {
            BellsTabList();
        }
    }
    else {
        my $t = '';

        $t .= q[
<div id="mod_bells">

	<h1> </h1>];

        my @tabs;

        sqlacms(
            \@tabs,
            "select i_id, name_tab from bells_ref
	    	/* where use_informer = 1 */"
        );

        for my $a (@tabs) {
            $t .= qq[<h2>$$a[1]</h2>
    		<table>
				<tr>
                	<th></th>
                	<th></th>
                	<th></th>
                	<th title="   "></th>
                </tr>
    		];

            my @tab;
            sqlacms(
                \@tab,
                "select lesson, bstart, bend
	    		from bells
	    		where tab_id = $$a[0]
	    		order by lesson", { ib_timeformat => '%H:%M' }
            );

            my $tab_size = scalar(@tab);

            for ( my $i = 0 ; $i < $tab_size ; $i++ ) {
                my $peremena = '';

                if ( $i != $tab_size - 1 ) {
                    $peremena = unix2time(
                        (
                            time2unix( $tab[ $i + 1 ][1] ) -
                              time2unix( $tab[$i][2] )
                        )
                    );
                    $peremena =~ s/^00:|:00$//g;
                    $peremena =~ s/^0//g;
                }

                $t .= qq[
				<tr>
                	<td>$tab[$i][0]</td>
                	<td>$tab[$i][1]</td>
                	<td>$tab[$i][2]</td>
                	<td>$peremena</td>
                </tr>
				];
            }

            unless ($tab_size) {
                $t .= qq[
				<tr>
	            	<td style="padding: 1em 0; text-align: center;" colspan="4">    </td>
	            </tr>
				];
            }

            $t .= '</table>';
        }

        unless ( scalar @tabs ) {
            $t .=
qq[<p style="margin:2em"> . <a href="$cms?mod=bells&edt=lst"></a>.</p>];
        }

        $t .= '</div>';

        return $t;
    }
}

sub BellsTabList {
    print qq^<h1>:   </h1>
<div id="container"></div>

<script src="/sp/jquery/js/jquery-1.4.4.min.js"></script>

<script language="JavaScript"><!--

var bells_add_new_tab_mode = false;

function add_new_tab_mode()
{
	bells_add_new_tab_mode = !bells_add_new_tab_mode;

	// turn_visibility('new_tab_link');
	// turn_visibility('new_tab_tr');

	if ( bells_add_new_tab_mode )
	{
		e('bells_new_tab').value = 1;
		\$('#new_tab_tr').slideDown();
		e('bells_new_tab_name').focus();
	}
	else
	{
		e('bells_new_tab').value = 0;
		\$('#new_tab_tr').slideUp();
	}
}

//--></script>

<!--   -->
<form method="POST" enctype="multipart/form-data">

	<input type="hidden" name="mod" value="bells"/>
	<input type="hidden" name="edt" value="edit_list"/>

	<div style="margin: 16px 24px">
		<a
			id="new_tab_link"
			href="#"
			onclick="add_new_tab_mode()"
		>
			<img src="/sp/img/grp_add.gif" align="absmiddle">&nbsp; ...
		</a>
	</div>

	<div id="new_tab_tr" class="infoblock" style="display:none; margin-left: 5%">
			  :<br>
			<input class="def2" type="text" name="bells_new_tab_name" id="bells_new_tab_name">
			<input type="hidden" id="bells_new_tab" name="bells_new_tab" value="0"><br>
			<a href="#" onclick="add_new_tab_mode()" title="    (      )"></a>
	</div>

	<table align="center" class="adminlist" width="97%">
	<tr>
		<th width="30" rowspan="2"></th>
		<th rowspan="2">/</th>
		<th width="100" rowspan="2"></th>
	    <th rowspan="2">   </th>
	    <th colspan="2"> :</th>
		<th rowspan="2"></th>
	</tr>
	<tr>
	    <th width="150">&nbsp;&nbsp;</th>
	    <th width="150">&nbsp;</th>
	</tr>
^;

    my (@a);

    $gdbcms->{"AutoCommit"} = 0;

    my $q_tabs = sqlpcms(
"select i_id, name_tab, smena, days_of_week, use_informer, use_cron from bells_ref"
    );

    my @days_of_week = split( /,/, $a[3] );

    my $i = 1;

    my $bells_lesson_count = $gconf{'bells_lesson_count'} || 8;

    my $tmp = '';

    while ( @a = $q_tabs->fetchrow_array() ) {
        my $trclass = TrClass($i);
        my $chk     = 'checked';

        my $q_bells = sqlpcms(
qq[select bstart, bend,  lesson      from bells where TAB_ID = $a[0]],
            { ib_timeformat => '%H:%M' }
        );
        my %hash;
        $q_bells->bind_columns( \( @hash{ @{ $q_bells->{NAME_lc} } } ) );

        my $table_rows = '';

        my %existing_lessons;
        while ( $q_bells->fetch ) {
            $existing_lessons{ $hash{lesson} } = [ $hash{bstart}, $hash{bend} ];
        }

        my $j = 1;

        for ( 1 .. $bells_lesson_count ) {
            my ( $start, $end ) = ( '', '' );
            if ( exists( $existing_lessons{$_} ) ) {
                $start = @{ $existing_lessons{$_} }[0];
                $end   = @{ $existing_lessons{$_} }[1];
            }

            if ( exists( $existing_lessons{$_} ) ) {
                $table_rows .= qq[<tr class="] . TrClass($j) . qq[">
					<td align=right>$_</td>
					<td><input align=center type=text size=8 name="lesson_start$_" value="$start"></td>
					<td><input align=center type=text size=8 name="lesson_end$_"   value="$end"></td>
				</tr>];
            }
            else {
                $table_rows .= qq[<tr class="] . TrClass($j) . qq[">
					<td align=right>$_</td>
					<td><input align=center type=text size=8 name="lesson_start$_" value=""></td>
					<td><input align=center type=text size=8 name="lesson_end$_"   value=""></td>
				</tr>];
            }
            $j++;
        }

        my $rest_lesson_counter = $j;
        for (
            my $rest_empty = $j ;
            $rest_empty < $bells_lesson_count ;
            $rest_empty++
          )
        {
            $table_rows .= qq[<tr class="] . TrClass($j) . qq[">
	<td align=right>$rest_lesson_counter</td>
	<td><input align=center type=text size=8 name="lesson_start$rest_lesson_counter" value=""></td>
	<td><input align=center type=text size=8 name="lesson_end$rest_lesson_counter"   value=""></td>
</tr>];
            $rest_lesson_counter++;
        }

        my $WdivBody = tpl_str(
            "tpl/c_tabedit.html",
            {
                WdivName    => 'tabedit' . $i,
                i           => $i,
                i_id        => $a[0],
                TabName     => $a[1],
                tab_content => $table_rows,
            }
        );

        my $EdWin = BellsEditWindow( $i, 'tabedit' . $i, '', $a[1] );

        $tmp .= $WdivBody;

        my @days_of_week = split( /,/, $a[3] );
        for (@days_of_week) {
            if   ($_) { $_ = ' checked '; }
            else      { $_ = ''; }
        }

        my ( $use_informer, $use_cron ) = ( $a[4], $a[5] );
        for ( ( $use_informer, $use_cron ) ) {
            if   ($_) { $_ = ' checked '; }
            else      { $_ = ''; }
        }

        my $smena_html =
          qq[<select name="smena$a[0]" onchange="this.form.submit()">];

        for ( 1 .. 3 ) {
            my $selected = $_ == $a[2] ? 'selected' : '';
            $smena_html .= qq[<option $selected value="$_">$_ </option>];
        }
        $smena_html .= '</select>';

        print qq^<tr class="$trclass" align="center">
			<td align="right">$i.</td>
			<td align="left">$EdWin</td>
			<td>$smena_html</td>
			<td nowrap>^;

        for ( my $i = 0 ; $i < 7 ; $i++ ) {
            print qq[<label for="checkbox_wday\Q$i\E_tab$a[0]">
	        	<input type="checkbox" name="checkbox_wday\Q$i\E_tab$a[0]" id="checkbox_wday\Q$i\E_tab$a[0]" $days_of_week[$i]>
	        	$wdays2_from_monday[$i]
	        </label>&nbsp;&nbsp;];
        }

        print qq^</td>
			<td><input type="checkbox" name="use_informer_tab$a[0]"  $use_informer></td>
			<td><input type="checkbox" name="use_informer_cron$a[0]" $use_cron></td>
		^;

        $a[1] =~ s/"|'//gi;

        my $a0forJavaScript = $a[1];

        print qq^
        	<td>
	        	<a title="" href="$cms?mod=bells&edt=del&i_id=$a[0]"
	            	onClick="return confirm('    $a0forJavaScript?')">
	            	<img src='/sp/img/button_del.gif' width=16 height=16></a>
            </td>
		</tr>
		^;

        $i++;
    }

    my ( $std_selected, $user_selected ) = ( '', '' );
    my $bell_cron_sound =
      sqlff(q[select F_CHAR from SP_SETTINGS where NAME = 'bell_cron_sound']);
    if   ( $bell_cron_sound eq 'std' ) { $std_selected  = 'checked'; }
    else                               { $user_selected = 'checked'; }

    my $bell_user_end_checked =
      sqlff(q[select f_int from SP_SETTINGS where NAME = 'bell_cron_sound_end'])
      ? 'checked'
      : '';

    print qq[
</table>

<div style="margin: 16px 4%">

<h2>   :</h2>

	<script src="/sp/soundmanager2/soundmanager2.js"></script>
	<script language="JavaScript"><!--

		soundManager.url         = '/sp/soundmanager2/soundmanager2.swf';
		soundManager.debugMode   = false;
		soundManager.consoleOnly = false;

		soundManager.onload = function()
		{
			soundManager.createSound('bell',         '/sp/soundmanager2/schoolbell.mp3');
			soundManager.createSound('bell-user',    '/sp/soundmanager2/schoolbell-user.mp3');
			soundManager.createSound('bell-user-end','/sp/soundmanager2/schoolbell-user-end.mp3');
		}

	//--></script>

	<!-- -------------  ------------- -->
	<label for="bell_sound_std">
		<input $std_selected id="bell_sound_std"  type="radio" name="bell_sound" value="std">
	</label>
	<button type="button" onclick="soundManager.play('bell');">
		<img src="/sp/img/play.png" align=absmiddle>&nbsp;
	</button>

	<div style="margin-top:16px">

		<!-- -------------  ------------- -->
		<label for="bell_sound_user">
			<input $user_selected id="bell_sound_user" type="radio" name="bell_sound" value="user">
		</label>

		<div style="margin-top: 6px; margin-left: 32px;">

			<!--   -->
			  MP3-:<br>
		    <input type="file" name="file" onchange="submit();">
    		<button type="button" onclick="soundManager.play('bell-user');">
				<img src="/sp/img/play.png" align="absmiddle">&nbsp;
			</button>

			<!--     -->
			<div style="margin-top: 8px">
				<label for="bell_user_end_check">
					<input id="bell_user_end_check" name="bell_user_end_check" type="checkbox" $bell_user_end_checked>
					     
				</label>
				<div id="input-bell-end-file">
			        <input type="file" name="file-end" onchange="submit();">
					<button type="button" onclick="soundManager.play('bell-user-end');">
						<img src="/sp/img/play.png" align="absmiddle">&nbsp;
					</button>
		        </div>
			</div>

		</div>



	</div>

</div>

<div style="margin: 16px 0" align="center">
	<button type="submit">
		<img src="/sp/img/save.png" align=absmiddle>&nbsp;
	</button>
</div>

</form> <!--   -->

$tmp
];

    $gdbcms->{"AutoCommit"} = 1;

}

sub BellsEditWindow {
    my ( $i, $WdivName, $WdivBody, $textLink, $Ww ) = @_;
    $Ww = "300px" unless $Ww;

    my $returnData = qq^
        $WdivBody
        <script type="text/javascript">

        function showindow$i() { YAHOO.example.container.panel$i.show(); }
        YAHOO.namespace("example.container");
        function init()
        {
            YAHOO.example.container.panel$i = new YAHOO.widget.Panel
		("$WdivName",
			{
				width: "$Ww",
				visible: false,
				constraintoviewport: true,
				modal: true,
				fixedcenter: true
                                //draggable:true
			}
		);
            YAHOO.example.container.panel$i.render();
            YAHOO.util.Event.addListener("hide$i", "click", YAHOO.example.container.panel$i.hide, YAHOO.example.container.panel$i, true);
        }

        YAHOO.util.Event.addListener(window, "load", init);
        </script>
    <a class=small href="javascript:void(0)" onclick="showindow$i();">$textLink</a>^;
    return $returnData;
}

sub BellsTabEdit {

    my $i_id = param('i_id');

    my $tab_name = substr( trim( param('tab_name') ), 0, 512 );
    escape_tag( \$tab_name );
    unless ( length $tab_name ) {
        stop("   .");
    }

    sqlbcms( "update bells_ref set name_tab = ? where i_id = ?",
        $tab_name, $i_id );

    sqlcms("delete from bells where tab_id = $i_id");

    my %lesson_times;
    for ( param() ) {
        if ( param($_) ) {
            if (m/lesson_start(\d+)/) {
                $lesson_times{$1}[0] = sec_time( param($_) );
            }
            elsif (m/lesson_end(\d+)/) {
                $lesson_times{$1}[1] = sec_time( param($_) );
            }
        }
    }

    for ( keys %lesson_times ) {
        unless ( $lesson_times{$_}[0] and $lesson_times{$_}[1] ) {
            stop(
"  $_   .       ."
            );
        }

        sqlcms(
            qq[insert into bells
			(tab_id, bstart,                 bend,                   lesson) values
			($i_id,  '$lesson_times{$_}[0]', '$lesson_times{$_}[1]', $_)]
        );
    }

    BellsGenerateCrondJobs();

    BellsTabList();
}

sub BellsTabDel {
    my $id = param('i_id');
    sqlcms("delete from BELLS_REF where I_ID = $id");
    sqlcms("delete from BELLS where TAB_ID = $id");

    BellsGenerateCrondJobs();

    BellsTabList();
}

sub BellsTabsEditAll() {

    my @affected_ids;
    sqlffacms( \@affected_ids, "select i_id from BELLS_REF" );

    my %DAYS_OF_WEEK;

    my %use_informer;

    my %use_cron;

    my %smena;

    for my $tab_id (@affected_ids) {
        for my $dow ( 0 .. 6 ) {
            $DAYS_OF_WEEK{$tab_id}[$dow] =
              param( 'checkbox_wday' . $dow . '_tab' . $tab_id ) eq 'on'
              ? 1
              : 0;
        }

        $use_informer{$tab_id} =
          param("use_informer_tab$tab_id") eq 'on' ? 1 : 0;

        $use_cron{$tab_id} = param("use_informer_cron$tab_id") eq 'on' ? 1 : 0;

        $smena{$tab_id} = param("smena$tab_id");
        sec_gt0( $smena{$tab_id} );
    }

    for my $tab_id (@affected_ids) {
        sqlcms(
            qq[update
	bells_ref
set
	smena        = $smena{$tab_id},
	use_informer = $use_informer{$tab_id},
	use_cron     = $use_cron{$tab_id},
	days_of_week = '] . join( ',', @{ $DAYS_OF_WEEK{$tab_id} } ) . qq['
where
	i_id = $tab_id]
        );
    }

    if ( param('bells_new_tab') ) {
        my $new_tab_name =
          substr( trim( param('bells_new_tab_name') ), 0, 512 );
        escape_tag( \$new_tab_name );

        unless ( length $new_tab_name ) {
            stop("    .");
        }

        sqlbcms( "insert into bells_ref (name_tab) values (?)", $new_tab_name );
    }

    if (   param('file')
        or param('file-end') )
    {
        my $param_name = 'file';
        if ( param('file-end') ) {
            $param_name = 'file-end';
        }

        my $filename = param($param_name);
        $filename =~ s/.*[\/\\](.*)/$1/;

        if ( $filename =~ /\.mp3$/i ) {
            my $fh = upload($param_name);

            if ( $param_name eq 'file-end' ) {
                open TARGET_FILE, '>',
                  qq[$gconf{'sppath'}/soundmanager2/schoolbell-user-end.mp3]
                  or error($!);
            }
            else {
                open TARGET_FILE, '>',
                  qq[$gconf{'sppath'}/soundmanager2/schoolbell-user.mp3]
                  or error($!);
            }

            binmode TARGET_FILE;

            while (<$fh>) {
                print TARGET_FILE;
            }

            close TARGET_FILE;
        }
        else {
            escape_tag( \$filename );
            stop(
"  MP3-.  :<br><b style='color:red'>$filename</b>"
            );
        }
    }

    my $bell_sound         = param('bell_sound');
    my @bell_sound_allowed = qw|std user|;

    my $bell_user_end = defined param('bell_user_end_check');

    unless ( grep /^\Q$bell_sound\E$/, @bell_sound_allowed ) {
        security_alert( $bell_sound, 'not in (std, user)' );
    }

    sql(
qq[update sp_settings set f_char = '$bell_sound' where name = 'bell_cron_sound']
    );

    sql(qq[delete from sp_settings where name = 'bell_cron_sound_end']);
    if ($bell_user_end) {
        sql(
qq[insert into sp_settings (f_int, name) values (1, 'bell_cron_sound_end')]
        );
    }

    BellsGenerateCrondJobs();

    BellsTabList();

}

sub BellsGenerateCrondJobs() {
    my %tabs;
    sqlhcms( \%tabs,
        'select i_id, days_of_week from bells_ref where use_cron = 1' );

    unless ( keys %tabs ) {
        sphelper_request('<sp_bells_cron></sp_bells_cron>');
        return;
    }

    my @tab_ids;
    for ( keys %tabs ) {
        push @tab_ids, $_;
    }

    unless ( scalar @tab_ids ) {
        sphelper_request('<sp_bells_cron></sp_bells_cron>');
        return;
    }

    my @lessons;
    sqlacms( \@lessons,
            'select distinct bstart, bend, tab_id from bells where tab_id in ('
          . join( ',', @tab_ids )
          . ') order by bstart' );

    my @cron_strings;

    my %cron_wdays_to_rus = (
        0 => 1,
        1 => 2,
        2 => 3,
        3 => 4,
        4 => 5,
        5 => 6,
        6 => 0
    );

    my $mp3file     = 'schoolbell.mp3';
    my $mp3file_end = 'schoolbell.mp3';

    if ( 'user' eq
        sqlff(q[select F_CHAR from SP_SETTINGS where NAME = 'bell_cron_sound'])
      )
    {
        $mp3file     = 'schoolbell-user.mp3';
        $mp3file_end = 'schoolbell-user.mp3';

        if (
            sqlff(
q[select f_int from SP_SETTINGS where NAME = 'bell_cron_sound_end']
            )
          )
        {
            $mp3file_end = 'schoolbell-user-end.mp3';
        }

    }

    for (@lessons) {
        my $min_sta = int( substr( $$_[0], 3, 2 ) );
        my $min_end = int( substr( $$_[1], 3, 2 ) );

        my $hour_sta = int( substr( $$_[0], 0, 2 ) );
        my $hour_end = int( substr( $$_[1], 0, 2 ) );

        my @DOWs = split( /,/, $tabs{ $$_[2] } );
        my @DOWs_enabled;
        for ( my $i = 0 ; $i < @DOWs ; $i++ ) {
            if ( 1 == $DOWs[$i] ) {
                push @DOWs_enabled, $cron_wdays_to_rus{$i};
            }
        }
        my $dow_str = join( ',', @DOWs_enabled );

        push @cron_strings,
qq[$min_sta $hour_sta * * $dow_str root mpg123 -q /var/www/html/sp/soundmanager2/$mp3file];

        push @cron_strings,
qq[$min_end $hour_end * * $dow_str root mpg123 -q /var/www/html/sp/soundmanager2/$mp3file_end];
    }

    sphelper_request( '<sp_bells_cron>' 
          . '<line>'
          . join( '</line><line>', @cron_strings )
          . '</line>'
          . '</sp_bells_cron>' );

}

sub bellsConfig {

}

sub rssLink {
    my $mod  = $_[0];
    my $i_id = $_[1];
    my $link;
    if ($chpu) {
        $link = "http://$ENV{'SERVER_NAME'}/news/rn/$i_id";
        if ( $mod eq 'content' ) {
            $link = "http://$ENV{'SERVER_NAME'}/content/rc/$i_id";
        }
    }
    else {
        $link = "http://$ENV{'SERVER_NAME'}$cms?mod=news&amp;rn=$i_id";
        if ( $mod eq 'content' ) {
            $link = "http://$ENV{'SERVER_NAME'}$cms?mod=content&amp;rc=$i_id";
        }
    }
    return $link;
}

sub rssblockConfig { }

sub rssblock {
    my ( $line, $return_data );
    foreach $line ( open_tpl("$theme_dir/$theme/rssblock.html") ) {
        $return_data .= $line;
    }
    return $return_data;
}

sub rss {
    setlocale( LC_ALL, "ru_RU.CP1251" );
    my $Title = str2unicode(" $ENV{'SERVER_NAME'}");
    my $Descript =
      str2unicode("    $ENV{'SERVER_NAME'}");

    my $lastBuildDate = str2unicode(
        timeRFC822(
            sqlffcms(
"select max(t) from ( select max(news.startdate) as t from news where published=1 and owner=$owner
		union select max(content.startdate) as t from content where published=1 and owner=$owner and c_type=1)",
                { ib_timestampformat => 'ISO' } )
        )
    );

    print qq^<?xml version="1.0"?>
<rss version="2.0" xmlns:atom="http://www.w3.org/2005/Atom">
<channel>
<title>$Title</title>
<link>http://$ENV{'SERVER_NAME'}/rss</link>
<description>$Descript</description>
<language>ru</language>
<lastBuildDate>$lastBuildDate</lastBuildDate>
<docs>http://blogs.law.harvard.edu/tech/rss</docs>
<generator>School Portal</generator>
<atom:link href="http://$ENV{'SERVER_NAME'}/rss" rel="self" type="application/rss+xml" />
^;
    my @a;
    my $q = sqlpcms(
        qq[select first 15 * from (
select news.news_id,news.head,news.text,news.startdate,'news' as data_type from news where published=1 and owner=$owner
union
select content.c_id,content.head,content.text,content.startdate,'content' as data_type from content where published=1 and c_type=1 and owner=$owner
ORDER by 4 desc ) ],
        { ib_timestampformat => 'ISO' } );
    while ( @a = $q->fetchrow_array() ) {
        my $nTitle = str2unicode("$a[1]");
        $a[2] =~ s/<.+?>//ig;
        $a[2] =~ s/&laquo;/"/ig;
        $a[2] =~ s/&raquo;/"/ig;
        $a[2] =~ s/&ndash;/-/ig;
        $a[2] =~ s/&nbsp;/ /ig;
        $a[2] =~ s/&quot;/"/ig;
        $a[2] =~ s/&ldquo;/"/ig;
        $a[2] =~ s/&rdquo;/"/ig;
        $a[2] =~ s/&middot;//ig;
        $a[2] =~ s/&mdash;//ig;
        $a[2] =~ s/&/&amp;/ig;
        $a[2] = substr( $a[2], 0, 130 );
        my $link      = rssLink( $a[4], $a[0] );
        my $nDescript = str2unicode( $a[2] . '...' );
        my $pubDate   = str2unicode( timeRFC822( $a[3] ) );
        $link = str2unicode($link);
        print qq^
	<item>
		<title>$nTitle</title>
		<link>$link</link>
		<description>$nDescript</description>
		<pubDate>$pubDate</pubDate>
		<guid isPermaLink="true">$link</guid>
	</item>^;
    }
    print qq^</channel></rss>^;
}

sub themes {
    if ( defined param('edt') ) {
        my $error_txt;
        if ( param('edt') eq 'lst' ) { ThemesPrintList() }
        elsif ( param('edt') eq 'pub' ) {
            my $t_name = param('tn');
            escape_tag( \$t_name );

            my $zapros = "select i_id, t_name from themes where owner = $owner";
            my $q = $gdbcms->prepare($zapros) or db_error();
            $q->execute() or db_error();
            my ( @a, $activeTheme, $t_id );
            while ( @a = $q->fetchrow_array() ) {
                $t_id        = $a[0];
                $activeTheme = $a[1];
            }
            if ( $activeTheme eq '' ) {
                $zapros =
"INSERT INTO themes (t_name, owner) VALUES ('$t_name','$owner')";
            }
            else {
                $zapros =
"update themes set t_name = '$t_name' where i_id = $t_id and owner = $owner";
            }

            $q = $gdbcms->prepare($zapros) or db_error();
            $q->execute() or db_error();
            ThemesPrintList();
        }
        elsif ( param('edt') eq 'down' ) {
            my $t_name = param('tn');
            if ( ThemesDown($t_name) ) {
                ThemesPrintList();
            }
        }
        elsif ( param('edt') eq 'upl' ) {
            my $tmp_dir = $theme_dir;
            if ( $owner ne '6'
                and ( -d "$theme_dir/Users_Themes/$owner" or die $! ) )
            {
                $tmp_dir = "$theme_dir/Users_Themes/$owner";
            }
            my $theme_zip     = UploadFile("$tmp_dir");
            my $color         = '<font color="#FF0000">';
            my $theme_upl_dir = $theme_zip;
            my $err           = 0;
            if ( $theme_upl_dir =~ (s/\.zip$//i) ) {
                if ( -d $theme_upl_dir ) {
                    $error_txt =
                      "$color      . <br>
                        ,     .</font>";
                    $err = 1;
                }
                if ( $owner != 6 and $theme_upl_dir =~ m/\/pic$/ ) {
                    stop(
" 'pic' ,        ."
                    );
                }
            }
            else {
                $error_txt =
                  "$color     zip. <br>
                ,         .</font>";
                unlink("$theme_zip");
                $err = 1;
            }
            ZipUncompress( "$theme_zip", "$tmp_dir" )
              if defined param('file')
                  and !$err;
            ThemesPrintList($error_txt) if defined param('file');
        }
        elsif ( param('edt') eq 'del' ) {
            my $error_txt;

            if ( defined param('tn') ) {
                my $tmp_dir = $theme_dir;

                my $t_name = param('tn');
                escape_tag( \$t_name );

                if ( $owner ne '6'
                    and
                    ( -d "$theme_dir/Users_Themes/$owner/$t_name" or stop($!) )
                  )
                {
                    $tmp_dir = "$theme_dir/Users_Themes/$owner";
                }

                if ( grep /^\Q$t_name\E$/, @DefaultThemes ) {
                    $error_txt = " @DefaultThemes  ";
                }
                elsif ( -d "$tmp_dir/$t_name" ) {
                    RemoveDir("$tmp_dir/$t_name");
                }
            }
            else {
                $error_txt = "    ";
            }

            ThemesPrintList($error_txt);
        }
    }
}

sub ThemesPrintList {
    my $error_txt = qq^<center><font color="#FF0000">$_[0]</font></center>^;
    my @themes    = ThemesGetArray();
    my $theme;
    my $i = 1;

    print qq^$error_txt<br>
<h1>:  </h1>
<div style="margin-bottom: 8px" align="center">
	<a href=$cms?mod=themes&edt=upl>  &hellip;</a><br>
	<a href="http://wiki.spcms.ru/%D0%A2%D0%B5%D0%BC%D0%B0_%D0%BE%D1%84%D0%BE%D1%80%D0%BC%D0%BB%D0%B5%D0%BD%D0%B8%D1%8F" target="_blank">    </a>
</div>
^;

    my $zapros = "select i_id, t_name from themes where owner = $owner";
    my $q = $gdbcms->prepare($zapros) or db_error();
    $q->execute() or db_error();
    my ( @a, $activeTheme, $t_id );
    while ( @a = $q->fetchrow_array() ) {
        $t_id        = $a[0];
        $activeTheme = $a[1];
    }

    my @required_files = (
        [ 'administration.html',      '  ()' ],
        [ 'administration_item.html', '  ()' ],
        [ 'bdayinfblock.html',        '  ()' ],
        [ 'bdayinfitem.html',         '  ()' ],
        [ 'bellsinf.html',            '' ],
        [ 'bloginf.html',             '    ()' ],
        [ 'bloginf_item.html',        '    ()' ],
        [ 'content.html',             '' ],
        [ 'contentitem.html',         ' ()' ],
        [ 'contentitem2.html',        ' ()' ],
        [ 'feedbackform.html',        ' ' ],

        [ 'graduates.html',          ' ()' ],
        [ 'graduates_all.html',      ' ()' ],
        [ 'graduates_all_item.html', ' ( )' ],
        [ 'graduates_item.html',     ' ( )' ],

        [ 'index.html', '  (  !)' ],

        [ 'lastcontentblock.html', '  ()' ],
        [ 'lastcontentitem.html',  '  ()' ],

        [ 'loginform.html',           ' ' ],
        [ 'loginform_autorized.html', '  ' ],

        [ 'mainmenu.html',      '  ()' ],
        [ 'mainmenublock.html', '  ()' ],

        [ 'namesfull.html',      ' -   ()' ],
        [ 'namesfull_item.html', ' -   ()' ],
        [ 'namesinf.html',       ' - ' ],

        [ 'news.html',         '' ],
        [ 'newsinf.html',      ' -  ()' ],
        [ 'newsinf_item.html', ' -  ()' ],

        [ 'news_comment.html', ' ()' ],
        [
            'news_comment_delete.html',
            ' (,   )'
        ],
        [ 'news_comment_form.html', ' ( )' ],

        [ 'guestbook.html',      '  ()' ],
        [ 'guestbook-item.html', '  ()' ],

        [ 'pmenu.html',      ' - ' ],
        [ 'rssblock.html',   'RSS ()' ],
        [ 'searchform.html', ' ' ]
    );

    my $abuse = '';
    for (@required_files) {
        unless ( -e "$theme_dir/$activeTheme/$$_[0]" ) {
            $abuse .= "<li>$$_[0] &mdash; $$_[1]</li>";
        }
    }

    if ( $abuse and not grep( /^\Q$activeTheme\E$/, @DefaultThemes ) ) {
        print qq[
<script type="text/javascript"><!--
function sp_warn_show()
{
	e('sp_warn_clickable').style.display = 'none';
	e('sp_warn_info').style.display = 'block';
}
//--></script>

<div id="sp_warn_clickable" class="hand" onclick="sp_warn_show()"
style="background:#fff url('/sp/img/info.gif') 8px 50% no-repeat;border:1px solid #999; padding: 8px 32px; width:850px; margin: 6px auto;">
	      . ,   .
</div>

<div id="sp_warn_info"
style="display:none;background-color:white;border:1px solid #999; padding: 8px 16px; width:850px; margin: 4px auto">
	<span style="color:green"> :</span>
	    <b>$activeTheme</b>   :<br>
	         <b>sp-default</b>.<br>
	<ul>$abuse</ul>
	  .  ,      -      &mdash;<br>
	       .  ,   ,    ,  .
</div>];
    }

    print qq^
<table align="center" class="adminlist" style="padding: 6px" width="700">
<tr>
	<th width="20" class="n"></th>
	<th class="l" colspan="2"> </th>
	<th width="100"></th>
	<th width="200" nowrap>  </th>
	<th width="70"></th>
</tr>^;

    @themes = sort {
        grep( /^\Q$b\E$/, @DefaultThemes ) <=>
          grep( /^\Q$a\E$/, @DefaultThemes )
          || $a cmp $b
    } @themes;

    foreach $theme (@themes) {
        next if $owner != 6 and $theme eq 'pic';

        my $rows    = $i / 2;
        my $trclass = 'row0';

        unless ( $rows =~ /^-?\d+\/?\d*$/ ) {
            $trclass = 'row1';
        }

        my $apply =
qq^<a title="  " href=$cms?mod=themes&edt=pub&tn=$theme>^;
        if ( $owner == 6 and $theme eq 'sp-blog' ) {
            $apply = qq[<span class="sc_grey">(  )</span>];
        }

        my $delete =
qq^<a title="  " href=$cms?mod=themes&edt=del&tn=$theme onClick="return confirm('     $theme?')"><img width="16" height="16" src="/sp/img/button_del.gif" align="absmiddle"/>&nbsp;</a>^;

        my $is_default = 0;
        my $theme_name = $theme;

        if ( grep /^\Q$theme\E$/, @DefaultThemes ) {
            $delete     = '&nbsp;';
            $is_default = 1;
        }

        if ( $theme eq $activeTheme
            or ( $activeTheme eq '' and $theme eq $DefaultThemes[0] ) )
        {
            $apply =
'<img src="/sp/img/ok.gif" width="16" height="16" align="absmiddle">&nbsp;&nbsp;';
        }

        $theme_name = qq[<b style="color:#395287">$theme</b>] if $is_default;

        my $theme_thumb = '&nbsp;';
        if ($is_default) {
            $theme_thumb =
qq[<img style="box-shadow: 0 1px 4px rgba(0,0,0, 0.1); background-color: #fff; margin: 6px; padding:3px; border: 1px solid #999" src="/sp/cms/themes/thumb-$theme.png" width="64" height="64" title=" ">];
        }

        print qq^
<tr class="$trclass">
	<td class="r">$i</td>
 	<td class="r" width="96">$theme_thumb</td>
	<td class="l">$theme_name</td>
	<td class="c">$apply</td>
	<td class="c"><a title="   " href=$cms?mod=themes&edt=down&tn=$theme><img src="/sp/img/save.png" width=16 height=16 align=absmiddle>&nbsp;</td>
	<td class="c">$delete</td>
</tr>^;
        $i++;
    }

    print qq^</table>^;

}

sub ThemesGetArray {
    my @themes;
    opendir( DIR, "$rootdirsp/cms/themes" )
      or die "  $rootdirsp/cms/themes: $!";
    my $filename;
    while ( defined( $filename = readdir(DIR) ) ) {
        if (    -d "$rootdirsp/cms/themes/$filename"
            and $filename ne ".."
            and $filename ne "."
            and $filename ne "Users_Themes" )
        {
            if ( $owner eq '6' ) { push( @themes, $filename ) }
            else {
                push( @themes, $filename )
                  if ( grep /^\Q$filename\E$/, @DefaultThemes );
            }
        }
    }
    if ( $owner ne '6' ) {
        if ( !-d "$rootdirsp/cms/themes/Users_Themes/$owner" ) {
            mkdir "$rootdirsp/cms/themes/Users_Themes/$owner" or die $!;
        }
        chdir "$rootdirsp/cms/themes/Users_Themes/$owner" or die $!;
        opendir( DIR, "." )
          or die "   : $!";
        my $filename;
        while ( defined( $filename = readdir(DIR) ) ) {
            if ( -d "$filename" and $filename ne ".." and $filename ne "." ) {
                push( @themes, $filename );
            }
        }
    }
    return @themes;
}

sub aboutou {
    my $about_ou_cache = 1;
    if ( param('gdate') ) {
        $gdate = param('gdate');
        sec_date($gdate);
        $about_ou_cache = 0;
    }

    unless ( $gconf{'light'} ) {
        AboutOUNumPupils($about_ou_cache);
    }

    my @SiteValues =
      qw(ACCREDITATION_GIVEOUT_DATE ACCREDITATION_REG_NO ACCREDITATION_TIMEOUT_DATE
      CLASS_ROOM_AREA CLASS_ROOM_COUNT COMPUTER_COUNT COMPUTER_ROOM DIRECTOR FULL_AREA GARDEN_AREA
      HOTFOOD_PLACES_COUNT HOTFOOD_PRESENT HOTFOOD_PUPIL_COUNT LABOUR_ROOM_COUNT LICENCE_GIVEOUT_DATE
      LICENCE_REG_NO LICENCE_TIMEOUT_DATE LOGOPAEDICS_PRESENT MUSEUM_PRESENT ORGANIZATION_NAME PHONE
      POST_ADDRESS SPORT_HALL_AREA SWIMMING_POOL_PRESENT
    );
    my $zapros = "select name, note, property_value from self_property";
    my $q = $gdb->prepare($zapros) or db_error();
    $q->execute() or db_error();
    my @a;
    my $returnData =
qq^<div class="aboutou_info"><div class="contentheading">    </div>
<div class=filter>
<form method="POST" action="$cms">   :
<input name="gdate" type="text" class="inputbox" alt=" " size="10" value="$gdate">
<input type="hidden" name="mod" value="aboutou">
<button type=submit class="button" value="send"></button>
</form>
</div>
<table class="abouteou">^;

    while ( @a = $q->fetchrow_array() ) {
        $returnData .= "<tr><td>$a[1]</td><td>$a[2]</td>"
          if ( $a[2] ne '0' and $a[2] ne '' )
          and grep /^$a[0]$/, @SiteValues;
        if ( $a[0] eq 'PHONE' ) {
            $returnData .= qq^
<tr><td>  </td><td>$CACHE{'NumPupils'}</td></tr>
<tr><td></td><td>$CACHE{'NumBoys'}</td></tr>
<tr><td></td><td>$CACHE{'NumGirls'}</td></tr>
<tr><td>  </td><td>$CACHE{'NumClasses'}</td></tr>
<tr><td>     ()</td><td>$CACHE{'NumClass01'}</td></tr>
<tr><td>     ()</td><td>$CACHE{'NumClass02'}</td></tr>
<tr><td>     ()</td><td>$CACHE{'NumClass03'}</td></tr>
<tr><td>  </td><td>$CACHE{'NumAVGPupilInClass'} .</td></tr>
$CACHE{'NumLanguageLearn'}
<tr><td>   $CACHE{'NumStartDate'}  $gdate</td>
<td><a href="$cms?mod=graduates" title='...'>$CACHE{'NumAllVypusk'}</a></td></tr>
<tr><td>   $CACHE{'NumStartDate'}  $gdate (//)</td>
<td><a href="$cms?mod=graduates&fio=1&medal=1033,1034" title='...'>
$CACHE{'NumVypuskMedalAll'}/$CACHE{'NumVypuskZoloto'}/$CACHE{'NumVypuskSerebro'}</a></td></tr>
^
              unless $gconf{'light'};
        }
    }
    $returnData .= qq^</table></div>^;
    if ( !$about_ou_cache ) {
        undef %CACHE;
    }
    return $returnData;
}

sub AboutOUNumPupils {
    my $about_ou_cache = $_[0];
    if ( !defined $CACHE{'NumGirls'} or !$about_ou_cache ) {
        ( $CACHE{'NumBoys'}, $CACHE{'NumPupils'} ) = sqlf(
            "select (
			select count(1) from human, sys_matrix
			where human.human_id = sys_matrix.vw_pupil
			and human.sex = 1 and sys_matrix.view_class = 1 and
			exists (select 1 from get_node_saldo(sys_matrix.node_id, '$gdate', 0) where saldo_sum <> 0)
		),(
			select count(1) from sys_matrix
			where sys_matrix.view_class = 1 and
			exists (select 1 from get_node_saldo(sys_matrix.node_id, '$gdate', 0) where saldo_sum <> 0)
		) from dual "
        );
        $CACHE{'NumGirls'} = $CACHE{'NumPupils'} - $CACHE{'NumBoys'};
        ( $CACHE{'NumClass01'}, $CACHE{'NumClass02'}, $CACHE{'NumClass03'} ) =
          sqlf(
            "select
					(select count(1) from sys_matrix where view_class = 7
					and paralel between 1 and 4
					and exists(select 1 from get_node_saldo(sys_matrix.node_id, '$gdate', 0) where saldo_sum <> 0)),
					(select count(1) from sys_matrix where view_class = 7
					and paralel between 5 and 9
					and exists(select 1 from get_node_saldo(sys_matrix.node_id, '$gdate', 0) where saldo_sum <> 0)),
					(select count(1) from sys_matrix where view_class = 7
					and paralel between 10 and 11
					and exists(select 1 from get_node_saldo(sys_matrix.node_id, '$gdate', 0) where saldo_sum <> 0))
					from dual "
          );
        $CACHE{'NumClasses'} =
          $CACHE{'NumClass01'} + $CACHE{'NumClass02'} + $CACHE{'NumClass03'};
        $CACHE{'NumAVGPupilInClass'} =
          $CACHE{'NumClasses'}
          ? sprintf( "%.0f", $CACHE{'NumPupils'} / $CACHE{'NumClasses'} )
          : 0;
        $CACHE{'NumStartDate'} = aboutouStartDate();
        $CACHE{'NumAllVypusk'} = sqlff(
            "select count(1)
					from sys_entry t1, sys_matrix t2
					where t1.credit_node = t2.node_id and
						entry_date between '$CACHE{'NumStartDate'}' and '$gdate' and
						doc_class = 5 and
						exists(select 1 from doc_deduction_order_sp where doc_no = t1.doc and human_id = t2.vw_pupil and
						deduction_type between 1032 and 1034)
					"
        );
        $CACHE{'NumVypuskZoloto'} = sqlff(
            "select count(1)
					from sys_entry t1, sys_matrix t2
					where t1.credit_node = t2.node_id and
						entry_date between '$CACHE{'NumStartDate'}' and '$gdate' and
						doc_class = 5 and
						exists(select 1 from doc_deduction_order_sp where doc_no = t1.doc and human_id = t2.vw_pupil and
						deduction_type = 1034)
					"
        );
        $CACHE{'NumVypuskSerebro'} = sqlff(
            "select count(1)
					from sys_entry t1, sys_matrix t2
					where t1.credit_node = t2.node_id and
						entry_date between '$CACHE{'NumStartDate'}' and '$gdate' and
						doc_class = 5 and
						exists(select 1 from doc_deduction_order_sp where doc_no = t1.doc and human_id = t2.vw_pupil and
						deduction_type = 1033)
					"
        );
        $CACHE{'NumVypuskMedalAll'} =
          $CACHE{'NumVypuskSerebro'} + $CACHE{'NumVypuskZoloto'};
        my $q = sqlp(
            "select name, count(human_language.language_id)
				from sys_matrix, human_language, language_ref
				where
				human_language.human_lang_type = 3
				and human_language.language_id = language_ref.language_id
				and sys_matrix.view_class = 1
				and sys_matrix.vw_pupil = human_language.human_id
				and exists(select 1 from get_node_saldo(sys_matrix.node_id, '$gdate', 0) where saldo_sum <> 0)
				GROUP by human_language.language_id, name
				order by name "
        );
        my ( $a, %LangAll, $lang );
        while ( $a = $q->fetch ) { $LangAll{ $a->[0] } = $a->[1] }
        if ( !$about_ou_cache ) { undef $CACHE{'NumLanguageLearn'} }
        foreach $lang ( keys %LangAll ) {
            $CACHE{'NumLanguageLearn'} .=
"<tr><td>  $lang </td><td>$LangAll{$lang}</td></tr>";
        }
    }
    return %CACHE;
}

sub graduates {
    if ( !defined param('edt') ) {
        if ( param('fio') ) { GraduatesFio() }
        else {
            my @years = reverse GraduatesYear();
            GraduatesAll(@years);
        }
    }
}

sub graduatesConfig {
    my ($return_data);
    if ( $owner eq '6' and param('edt') ne 'so' ) {
        my $text;
        if ( sqlffcms("select 1 from graduates") ) {
            $text =
qq^<p>!   (  )         .<p>^;
        }
        my $text_example =
qq^<p> *.csv : ;; ;;- </p>
            <p>  ;11 "";1996;;67<br>  ;11 "";1996;;</p>^;
        $return_data .= qq^<fieldset style="padding: 2">
                        <legend>  :</legend>
                        <p> ,       ,
                          *.csv ,      .</p>
                        $text
                        <p>  *.csv : <input type="file" name="file"></p>
                        $text_example
                        </fieldset> ^;
        return "$return_data";
    }
    elsif ( $owner eq '6' and param('edt') eq 'so' ) {
        if ( param('file') ) { GraduatesCsv() }
    }
}

sub GraduatesCsv {
    unless ( length( param('file') ) ) { stop("   .") }
    my ( @a, @grad_id );
    my $q = sqlpcms("select id_g from graduates");
    while ( @a = $q->fetchrow_array() ) {
        push @grad_id, $a[0];
    }
    my $fh = upload('file');
    $gdbcms->{AutoCommit} = 0;
    while (<$fh>) {
        chomp;
        my ( $fio, $class, $year_g, $medal, $sum_vyp ) = split /;/;
        my %id_medal = ( '' => '1033', '' => '1034' );
        $fio     = trim($fio);
        $class   = trim($class);
        $year_g  = trim($year_g);
        $medal   = trim($medal);
        $sum_vyp = trim($sum_vyp);

        if (    $fio =~ /^\D+$/
            and $class  =~ /\d+/
            and $year_g =~ /^\d{4}$/
            and ( $medal =~ /^$/ or $medal =~ /^$/ or $medal =~ /""/ )
            and $sum_vyp =~ /\d*/ )
        {
            $sum_vyp = $sum_vyp || '0';
            $id_medal{$medal} = '1032' unless $medal;
            sqlbcms(
"INSERT INTO graduates (FIO, CLASS, YEAR_G, MEDAL, SUM_PUP) values (?,?,'$year_g',$id_medal{$medal},$sum_vyp)",
                $fio, $class
            );
        }
        else {
            stop(
"     :  $fio;$class;$year_g;$medal;$sum_vyp)"
            );
        }
    }
    $gdbcms->commit;
    if ( scalar @grad_id ) {
        foreach my $g_id (@grad_id) {
            sqlbcms("delete from graduates where ID_G = '$g_id'");
        }
        $gdbcms->commit;
    }
    $gdbcms->{AutoCommit} = 1;
}

sub GraduatesMenu {

    my $f_medal     = param('medal') || '1033,1034';
    my $filter_year = param('year')  || '';
    my $arrow_stat = '&rarr;' unless param('fio') || '';
    my $arrow_vyp = '&rarr;' if param('fio') || '';
    my $menu = qq^
        <a href="$cms?mod=graduates&medal=$f_medal&year=$filter_year">&nbsp;$arrow_stat&nbsp;&nbsp;&nbsp;</a>
        <a href="$cms?mod=graduates&fio=1&medal=$f_medal&year=$filter_year">&nbsp;$arrow_vyp&nbsp;&nbsp;&nbsp;</a>
    ^;
    return $menu;
}

sub GraduatesGraph (% @) {
    my $datagraph = $_[0];
    my $years     = $_[1];
    my @data      = ( [@$years] );
    my ( $key, $value, @max );
    my %datagraphm = %$datagraph;
    my $nn         = 1;
    foreach my $item ( sort keys %datagraphm ) {

        my @array = split /;/, $datagraphm{$item};
        for (@array) { s/,/./ }
        push @data, [@array];
        push @max, @array;
        $nn++;
    }
    my $file_graph = join '', @max;
    if ( !-f "$rootdirsp/tmp/$file_graph.png" ) {
        my @max_sorted = sort { $a <=> $b } @max;
        my $max_value;
        if    ( $max_sorted[-1] < 5 )  { $max_value = 5 }
        elsif ( $max_sorted[-1] < 10 ) { $max_value = 10 }
        elsif ( $max_sorted[-1] < 15 ) { $max_value = 15 }
        elsif ( $max_sorted[-1] < 20 ) { $max_value = 20 }
        elsif ( $max_sorted[-1] < 40 ) { $max_value = 40 }
        else                           { $max_value = 100 }
        my @typesMedals = (
            str2unicode(''), str2unicode(''),
            str2unicode(' ')
        );
        my $my_graph = GD::Graph::bars->new( 520, 300 );
        $my_graph->set(
            title                => ' ',
            long_ticks           => 1,
            y_max_value          => $max_value,
            y_tick_number        => 5,
            bar_spacing          => 25,
            bargroup_spacing     => 20,
            bar_width            => 35,
            shadow_depth         => 4,
            show_values          => 1,
            values_space         => 2,
            valuesclr            => 'black',
            boxclr               => '#fbfbfb',
            fgclr                => '#aaaaaa',
            accentclr            => 'black',
            shadowclr            => '#aaaaaa',
            textclr              => 'black',
            axislabelclr         => 'black',
            legendclr            => 'black',
            dclrs                => [ '#E4DD00', '#C0C0C0', '#00ba5e' ],
            legend_spacing       => 10,
            text_space           => 0,
            legend_marker_width  => 10,
            legend_marker_height => 10,
        );
        $my_graph->set_values_font( '../tahoma.ttf', 9 );
        $my_graph->set_x_axis_font( '../tahoma.ttf', 11 );
        $my_graph->set_y_axis_font( '../tahoma.ttf', 8 );
        $my_graph->set_title_font( '../tahoma.ttf', 20 );
        $my_graph->set_legend_font( '../tahoma.ttf', 11 );
        $my_graph->set_legend(@typesMedals);
        $my_graph->plot( \@data );
        my $image_file_abs = "$rootdirsp/tmp/$file_graph.png";
        open( OUT, '>', $image_file_abs );
        binmode OUT;
        print OUT $my_graph->gd->png();
        close OUT;
    }
    return "http://$ENV{HTTP_HOST}/sp/tmp/$file_graph.png";
}

sub GradBaseCust {
    my $f_medal       = $_[0];
    my @filter_params = ( '1033', '1034', '1033,1034', '1032,1033,1034' );
    my %sql_ender     = (
        '1033'           => 'where medal = 1033',
        '1034'           => 'where medal = 1034',
        '1033,1034'      => 'where medal = 1033 or medal = 1034',
        '1032,1033,1034' => 'where medal = 1033 or medal = 1034 or medal = 1032'
    ) if $f_medal;
    my %id_medal = ( 1033 => '', 1034 => '' );
    my $q = sqlpcms(
        "select FIO,YEAR_G,CLASS,MEDAL from graduates $sql_ender{$f_medal}");
    my ( @a, @gradBaseCust );
    while ( @a = $q->fetchrow_array() ) {
        my $id_m = $id_medal{ $a[3] } || '&nbsp;';
        push @gradBaseCust, $a[0] . "|" . $id_m . "|" . $a[2] . "|" . $a[1];
    }
    return @gradBaseCust;
}

sub GraduatesFio {

    my $f_medal = param('medal') || '1032,1033,1034';
    my @filter_params = ( '1033', '1034', '1033,1034', '1032,1033,1034' );
    unless ( grep /^\Q$f_medal\E$/, @filter_params ) {
        error("    ");
    }

    my @gradBase;
    my %replace;
    my @tpl_data;
    my @tpl_data_cache = open_tpl("$theme_dir/$theme/graduates_item.html");
    my $BlockContent;
    my $num = 1;
    my %id_medal = ( 1033 => '', 1034 => '' );

    unless ( $gconf{'light'} ) {
        my $zapros = qq^ select t1.vw_pupil, t1.paralel,
					(select name from class where class_id = t1.class) as class_name,
					last_name, first_name, middle_name,
					t3.deduction_type, t2.entry_date
					from sys_matrix t1, sys_entry t2, doc_deduction_order_sp t3, human
					where
						human_id = t1.vw_pupil and t1.node_id = t2.credit_node and
						t2.doc_class = 5 and
						t2.doc = t3.doc_no and t1.vw_pupil = t3.human_id and t3.deduction_type in ($f_medal)
						order by last_name^;
        my $attr = { ib_timestampformat => '%Y' };

        my $q = sqlp( $zapros, $attr );

        my @a;
        my %filter_medal;
        while ( @a = $q->fetchrow_array() ) {
            my $class = trQ("$a[1] $a[2]");
            my $id_m = $id_medal{ $a[6] } || '&nbsp;';
            push @gradBase,
              "$a[3] $a[4] $a[5]" . "|" . $id_m . "|" . $class . "|" . "$a[7]";
        }
    }

    push @gradBase, GradBaseCust($f_medal);
    foreach my $grad_line ( sort @gradBase ) {
        my ( $gfio, $gmedal, $gclass, $gyear ) = split /\|/, $grad_line;
        %replace = (
            num   => $num . ".",
            fio   => $gfio,
            medal => $gmedal,
            class => $gclass,
            year  => $gyear
        );
        if ( $gyear eq param('year') || param('year') eq "" ) {
            @tpl_data = @tpl_data_cache;
            $BlockContent .= return_item( \%replace, \@tpl_data );
            $num++;
        }
    }
    my @filter_year = GraduatesYear();
    push @filter_year, GraduatesYearCust();
    @filter_year = reverse sort @filter_year;
    my @filter_medal = GraduatesType();
    my $filter_html =
qq^<form class="filter" method="POST" action=$cms> : <select name="year"><option value=""></option>^;
    foreach my $item (@filter_year) {
        my $selected = 'selected' if param('year') eq $item;
        $filter_html .= qq^
            <option $selected value="$item">$item</option>^
    }
    my $selected = 'selected' if param('medal') eq '1033,1034';
    $filter_html .=
qq^</select> : <select name="medal"><option value=""></option>
                            <option $selected value="1033,1034"></option>^;
    foreach my $item (@filter_medal) {
        my $selected = 'selected' if param('medal') eq $item;
        $filter_html .=
          qq^<option $selected value="$item">$id_medal{$item} </option>^;
    }
    $filter_html .= qq^</select>
					<input type="hidden" name="mod" value="graduates">
					<input type="hidden" name="fio" value="1">
					&nbsp;<button type=submit class="button" name="submt"></button>
					</form>^;
    $BlockContent =
qq^<tr><td colspan=5 align=center><font color="#D30101">   .     .</font></td></tr>^
      if !$BlockContent;
    my %replace1 = (
        grad_menu       => GraduatesMenu(),
        filter_html     => "$filter_html",
        medallists_item => "$BlockContent"
    );
    return return_block( \%replace1, "$theme_dir/$theme/graduates.html" );
}

sub GraduatesYear {
    if ( $gconf{'light'} ) { return (); }

    my $attr = { ib_timestampformat => '%Y' };
    my @a;
    my @years;
    my $q = sqlp(
        "select distinct t2.entry_date
				from sys_matrix t1, sys_entry t2, doc_deduction_order_sp t3
				where
						t1.node_id = t2.credit_node and
						t2.doc_class = 5 and
						t2.doc = t3.doc_no and t1.vw_pupil = t3.human_id and t3.deduction_type in (1032, 1033, 1034)
				order by t2.entry_date desc", $attr
    );
    while ( @a = $q->fetchrow_array() ) { push @years, $a[0] }
    return @years;
}

sub GraduatesYearCust {
    my ( $q, @a, @years );
    $q = sqlpcms("select distinct YEAR_G from graduates order by YEAR_G");
    while ( @a = $q->fetchrow_array() ) { push @years, $a[0] }
    return @years;
}

sub GraduatesType {
    if ( $gconf{'light'} ) { return (); }

    my $attr = { ib_timestampformat => '%Y' };
    my @a;
    my @types;
    my $q = sqlp(
        "select distinct t3.deduction_type
				from sys_matrix t1, sys_entry t2, doc_deduction_order_sp t3
				where
					t1.node_id = t2.credit_node and
					t2.doc_class = 5 and
					t2.doc = t3.doc_no and t1.vw_pupil = t3.human_id and t3.deduction_type in (1033, 1034)",
        $attr
    );
    while ( @a = $q->fetchrow_array() ) { push @types, $a[0] }
    return @types;
}

sub GraduatesTypeCust {
    my @a;
    my @types;
    my $q = sqlpcms("select distinct MEDAL from graduates");
    while ( @a = $q->fetchrow_array() ) { push @types, $a[0] }
    return @types;
}

sub GraduatesCustNumVyp {
    my $yea = $_[0];
    my $num;
    my @a;
    my $q = sqlpcms("select sum_pup from graduates where YEAR_G = $yea");
    while ( @a = $q->fetchrow_array() ) { $num = $a[0] if $a[0]; last }
    return $num;
}

sub GraduatesAll {
    my @years        = @_;
    my @years_custom = GraduatesYearCust();
    if ( @years or @years_custom ) {
        my (
            $num_vypusk,   $num_gold,     $num_silver,   $num_medal,
            $BlockContent, $num_vypusk_a, $num_gold_a,   $num_silver_a,
            $num_medal_a,  $num_gold_p,   $num_silver_p, $num_medal_p
        );
        my %datagraph;
        my @tpl_data_cache =
          open_tpl("$theme_dir/$theme/graduates_all_item.html");
        foreach my $item (@years) {
            $num_vypusk = sqlff(
                "select count(1)
						from sys_entry t1, sys_matrix t2
						where t1.credit_node = t2.node_id and
							getdatefield(t1.entry_date, 3) = $item and
							doc_class = 5 and
							exists(select 1 from doc_deduction_order_sp where doc_no = t1.doc and human_id = t2.vw_pupil and
							deduction_type between 1032 and 1034) "
            );
            $num_gold = sqlff(
                "select count(1)
						from sys_entry t1, sys_matrix t2
						where t1.credit_node = t2.node_id and
							getdatefield(t1.entry_date, 3) = $item and
							doc_class = 5 and
							exists(select 1 from doc_deduction_order_sp where doc_no = t1.doc and human_id = t2.vw_pupil and
							deduction_type = '1034') "
            );
            $num_silver = sqlff(
                "select count(1)
						from sys_entry t1, sys_matrix t2
						where t1.credit_node = t2.node_id and
							getdatefield(t1.entry_date, 3) = $item and
							doc_class = 5 and
							exists(select 1 from doc_deduction_order_sp where doc_no = t1.doc and human_id = t2.vw_pupil and
							deduction_type = '1033') "
            );
            $num_medal    = $num_gold + $num_silver;
            $num_gold_p   = sprintf( "%.2f", 100 * $num_gold / $num_vypusk );
            $num_silver_p = sprintf( "%.2f", 100 * $num_silver / $num_vypusk );
            $num_medal_p  = sprintf( "%.2f", 100 * $num_medal / $num_vypusk );
            $num_vypusk_a = $num_vypusk_a + $num_vypusk;
            $num_gold_a   = $num_gold_a + $num_gold;
            $num_silver_a = $num_silver_a + $num_silver;
            $num_medal_a  = $num_medal_a + $num_medal;
            $datagraph{'1'} .= ("$num_gold_p;");
            $datagraph{'2'} .= ("$num_silver_p;");
            $datagraph{'3'} .= ("$num_medal_p;");
            my %replace = (
                year       => $item,
                num_vypusk => $num_vypusk,
                num_gold   => "$num_gold ./$num_gold_p %",
                num_silver => "$num_silver ./$num_silver_p %",
                num_medal  => "$num_medal ./$num_medal_p %"
            );
            my @tpl_data = @tpl_data_cache;
            $BlockContent .= return_item( \%replace, \@tpl_data );
        }
        foreach my $yea (@years_custom) {
            $num_vypusk = GraduatesCustNumVyp($yea);
            $num_gold   = sqlffcms(
"select count(1) from graduates where medal = 1034 and YEAR_G = $yea"
            );
            $num_silver = sqlffcms(
"select count(1) from graduates where medal = 1033 and YEAR_G = $yea"
            );
            $num_medal = $num_gold + $num_silver;
            $num_gold_p = sprintf( "%.2f", 100 * $num_gold / $num_vypusk )
              if $num_vypusk;
            $num_silver_p = sprintf( "%.2f", 100 * $num_silver / $num_vypusk )
              if $num_vypusk;
            $num_medal_p = sprintf( "%.2f", 100 * $num_medal / $num_vypusk )
              if $num_vypusk;
            $num_vypusk_a = $num_vypusk_a + $num_vypusk;
            $num_gold_a   = $num_gold_a + $num_gold;
            $num_silver_a = $num_silver_a + $num_silver;
            $num_medal_a  = $num_medal_a + $num_medal;
            $datagraph{'1'} .= ("$num_gold_p;");
            $datagraph{'2'} .= ("$num_silver_p;");
            $datagraph{'3'} .= ("$num_medal_p;");
            my %replace = (
                year       => $yea,
                num_vypusk => $num_vypusk,
                num_gold   => "$num_gold ./$num_gold_p %",
                num_silver => "$num_silver ./$num_silver_p %",
                num_medal  => "$num_medal ./$num_medal_p %"
            );
            my @tpl_data = @tpl_data_cache;
            $BlockContent .= return_item( \%replace, \@tpl_data );
        }
        push @years, @years_custom;
        @years = sort @years;
        my $grapfHref = GraduatesGraph( \%datagraph, \@years );
        my %replace1 = (
            year       => '<b></b>',
            num_vypusk => "<b>$num_vypusk_a</b>",
            num_gold   => "<b>$num_gold_a ./"
              . sprintf( "%.2f", 100 * $num_gold_a / $num_vypusk_a )
              . " %</b>",
            num_silver => "<b>$num_silver_a ./"
              . sprintf( "%.2f", 100 * $num_silver_a / $num_vypusk_a )
              . " %</b>",
            num_medal => "<b>$num_medal_a ./"
              . sprintf( "%.2f", 100 * $num_medal_a / $num_vypusk_a )
              . " %</b>"
        );
        my @tpl_data = @tpl_data_cache;
        $BlockContent .= return_item( \%replace1, \@tpl_data );
        my %replace = (
            grad_menu           => GraduatesMenu(),
            medallists_all_item => "$BlockContent",
            graph_href          => "$grapfHref"
        );
        return return_block( \%replace,
            "$theme_dir/$theme/graduates_all.html" );
    }
    return ("    ");
}

sub trQ {
    my $class = $_[0];
    $class =~ s/^(\d+\s\".+\").+/$1/;
    $class =~ s/^(\d{1})(&nbsp;.+)/ $1$2/;
    $class =~ s/\"/&quot;/g;
    return $class;
}

sub names {
    if ( $gconf{'light'} ) { return ''; }

    if ( scalar @names_unique eq '0' ) {
        my $q = sqlp(
"select trim(first_name) from sys_matrix, human where sys_matrix.view_class = 1 and vw_pupil = human_id
and exists ( select 1 from get_node_saldo(sys_matrix.node_id, '$gdate', 0) where saldo_sum <> 0 )"
        );
        my ( @a, %names );
        while ( @a = $q->fetchrow_array() ) {
            $names{ $a[0] }++;
        }
        @a = ();
        for ( keys %names ) {
            if ( $names{$_} == 1 ) { push @names_unique, $_ }
        }
    }
    my $t2 = '';
    my $i  = 0;

    if ( scalar(@names_unique) < 4 ) {
        $t2 = join ',', sort { rand() <=> rand() } @names_unique;
    }
    else {
        while ( $i < 4 ) {
            my $nru = $names_unique[ rand(@names_unique) ];
            $t2 .= $nru . ', ', $i++ unless grep /$nru,/, $t2;
        }
    }

    $t2 =~ s/,\s$/ /;
    my %replace = ( name01 => $t2 );
    my @tpl_data = open_tpl("$theme_dir/$theme/namesinf.html");
    tpl_replace_ant( \%replace, \@tpl_data );
    my $return_data;
    my $htmlline;
    foreach $htmlline (@tpl_data) { $return_data .= $htmlline }
    return $return_data;
}

sub namesfull {
    my $q = sqlp(
"select trim(first_name), iif(sex=0,'<span style=color:#b4a></span>','<span style=color:#238></span>')
from sys_matrix, human where vw_pupil = human_id and sys_matrix.view_class = 1 and exists
( select 1 from get_node_saldo(sys_matrix.node_id, '$gdate', 0) where saldo_sum <> 0 )"
    );
    my ( @a, @uniq, %names, %sex );
    while ( @a = $q->fetchrow_array() ) {
        $names{ $a[0] }++;
        $sex{ $a[0] } = $a[1];
    }
    @a = ();
    for ( keys %names ) {
        if ( $names{$_} == 1 ) {
            push @uniq, [ $_, $sex{$_} ];
        }
        else { push @a, [ $_, $names{$_}, $sex{$_} ] }
    }
    my ( $t1, $t2 );
    $t1 = $t2 = '';
    my @tpl_data_cache = open_tpl("$theme_dir/$theme/namesfull_item.html");
    my @tpl_data;
    for ( reverse sort { $$a[1] <=> $$b[1] || $$b[0] cmp $$a[0] } @a ) {
        $t1 .=
qq[<tr><td>&nbsp;$$_[2]&nbsp;</td><td>$$_[0]</td><td align=right>$$_[1]</td></tr>];
    }
    for ( reverse sort { $$b[0] cmp $$a[0] } @uniq ) {
        $t2 .= qq[<tr><td>&nbsp;$$_[1]&nbsp;</td><td>$$_[0]</td></tr>];
    }
    my %replace = ( items => "$t1", itemsuniq => "$t2" );
    return ReturnPage( "$theme_dir/$theme/namesfull.html", \%replace );
}

sub account {
    my @data;
    my $ac_num;
    my $ac_dateb;

    unless ( $gconf{'accountdbname'} ) {
        return
q[ " -  "  . <a href="http://spcms.ru/contact" target="_blank"></a>.];
    }

    ConnectDBac();

    if ( param('num') and param('date') and accountChkPrm() ) {
        $ac_num   = param('num');
        $ac_dateb = param('date');
        @data     = accountGetData( $ac_num, $ac_dateb );
        my $session =
          new CGI::Session( "driver:File", undef, { Directory => '/tmp' } );
        $session->expire('+20m');
        $session->param( 'ac_num',   "$ac_num" );
        $session->param( 'ac_dateb', "$ac_dateb" );
        my $sid = $session->id();
        accountReturn( $ac_num, \@data, $ac_dateb, $sid );
    }
    elsif ( param('mnth') and param('s') and param('mnth') =~ /^\d+$/ ) {
        my $sid = param('s');
        my $session =
          new CGI::Session( "driver:File", $sid, { Directory => '/tmp' } );
        $ac_num   = $session->param('ac_num');
        $ac_dateb = $session->param('ac_dateb');
        if ( $ac_num and $ac_dateb ) {
            @data = accountGetData( $ac_num, $ac_dateb );
            accountReturn( $ac_num, \@data, $ac_dateb, $sid );
        }
        else { accountForm() }
    }
    elsif ( param('s') and param('print') and param('print') == 1 ) {
        my $sid = param('s');
        my $session =
          new CGI::Session( "driver:File", $sid, { Directory => '/tmp' } );
        $ac_num   = $session->param('ac_num');
        $ac_dateb = $session->param('ac_dateb');
        if ( $ac_num and $ac_dateb ) {
            @data = accountGetData( $ac_num, $ac_dateb );
            accountReturn( $ac_num, \@data, $ac_dateb, $sid );
        }
        else { accountForm() }
    }
    else { accountForm() }
}

sub accountReturn {
    my $ac_num   = $_[0];
    my $data     = $_[1];
    my $ac_dateb = $_[2];
    my $sid      = $_[3];
    my ( %replace, $returnData );
    unless ( grep /<h4> <\/h4>/, @$data ) {
        my $mou = @$data[2];
        $mou =~ s/^\d+\.//;
        %replace = (
            account_id => "$ac_num",
            name       => "@$data[1]",
            mou        => "$mou",
            class      => "@$data[3]",
            balans     => "@$data[4]"
        );
        $returnData =
          return_block( \%replace, "$theme_dir/$theme/account_data.html" );

        if ($KSHP) {
            $returnData .= accountDataPay2( $ac_num, $sid );
        }
        else {
            $returnData .= accountDataPay( $ac_num, $sid );
        }

    }
    else { $returnData = @$data[0] }
}

sub accountGetData {
    my $ac_num   = $_[0];
    my $ac_dateb = $_[1];
    my @data;
    if ( $gconf{"db_path"} ne $gconf{"accountdbname"} ) {
        @data = sqlfac(
            "select account_id, full_name,
                        (select name from edu_org_ref where org_id = t1.org_id) edu_org_name,
                        (select class from pay_list_sp where account_id = t1.account_id and doc_no
                      = (select max(doc_no) from pay_list_sp where account_id = t1.account_id)) as class_name,
                        (select cast(saldo_sum as numeric(15,2)) from get_node_saldo((select
                      node_id from sys_matrix where view_class = 1 and vw_pupil = t1.account_id), '$gdate', 0)) as balans
                      from (select account_id, human_id, last_name || ' ' || first_name || ' ' || middle_name as full_name,
                        birth_day, org_id from human where class = 1) t1 where account_id = '$ac_num' and birth_day = '$ac_dateb'"
        );
    }
    elsif ( $gconf{"pay_service"} ) {
        @data = sqlfac(
            "select  human_id as account_id, full_name,
                (select property_value from self_property where name = 'SHORT_ORG_NAME')
                edu_org_name,
                  (select paralel || '\"' || (select word from get_word(2, (select name from class
                    where class_id = t2.class), '\"')) || '\"'
                       from sys_matrix t2
                    where
                        view_class = 1 and vw_pupil = t1.human_id and
                        node_id = (select max(node_id) from sys_matrix where view_class = 1 and
                        vw_pupil = t1.human_id)) as class_name,
                          (select cast(saldo_sum as numeric(15,2)) from get_node_saldo((select
                        node_id from sys_matrix
                       where view_class = 4001 and ae_pay_part_ref = 93 and vw_pupil = t1.human_id), '$gdate', 0)) as balans
                        from
                          (select human_id, last_name || ' ' || first_name || ' ' || middle_name as full_name, birth_day
                            from human t3
                            where class = 1 and exists(select 1 from sys_matrix where view_class =
                            4001 and vw_pupil = t3.human_id)) t1
                            where human_id = '$ac_num' and birth_day = '$ac_dateb'"
        );
    } else {
        @data = sqlfac(
            "select
                human_id as account_id,
                full_name,
                (select property_value from self_property where name = 'SHORT_ORG_NAME')
                edu_org_name,
                (select
                    paralel || '\"' || (select word from get_word(2, (select name from class
                where class_id = t2.class), '\"')) || '\"'
                from sys_matrix t2
                where
                    view_class = 1 and vw_pupil = t1.human_id and
                    node_id = (select max(node_id) from sys_matrix where view_class = 1 and
                vw_pupil = t1.human_id)) as class_name,
                (select cast(saldo_sum as numeric(15,2)) from get_node_saldo((select
                node_id from sys_matrix
                where view_class = 4001 and ae_pay_part_ref = 76 and vw_pupil =
                t1.human_id), '$gdate', 0)) as balans
                from
                (select human_id, last_name || ' ' || first_name || ' ' || middle_name as
                full_name, birth_day
                from human t3
                where
                    class = 1 and
                    exists(select 1 from sys_matrix where view_class = 4001 and vw_pupil =
                t3.human_id)) t1
                where
                human_id = '$ac_num' and birth_day = '$ac_dateb'"
        );
    }
    unless (@data) {
        @data =
qq^<h4> </h4><p> :  - <b>$ac_num</b>,   - <b>$ac_dateb</b>.</p>
                <p>   , ,   :<p>

                <p>1. ,           .
                           .</p>
                <p>2.     ,   <a href="/feedback"></a>.</p>^
    }
    return @data;
}

sub accountBalans {
    my $ac_num = $_[0];
    my @dts    = accountDates();
    my @a;
    my $q;
    my @balans;
    $q = sqlpac(
        "select (select saldo_sum from get_node_saldo(
                (select node_id from sys_matrix where view_class = 1 and vw_pupil = '$ac_num'), '$dts[0]', 0)) as balans_beg,
                (select saldo_sum from get_node_saldo((select node_id from sys_matrix where view_class = 1 and vw_pupil = '$ac_num'), '$dts[1]', 0)) as balans_end
                from dual"
    );
    while ( @a = $q->fetchrow_array() ) {
        $balans[0] = $a[0];
        $balans[1] = $a[1];
    }
    return "$balans[0] $balans[1]";
}

sub accountDatesList {
    my $ac_num = $_[0];
    my $ssid   = $_[1];
    my ( @a, $q, @monthes, $retunData, $nmon, $m_link );
    my $attr = { ib_timestampformat => '%m.%Y' };
    my ( $mnth, $y, $yy, $mn, $m );

    my $procedure_name = (
        sqlff(
q[select 1 from rdb$procedures where rdb$procedure_name = 'GET_ACCOUNT_DETAIL_2']
        )
    ) ? 'get_account_detail_2' : 'get_account_detail';

    $q = sqlpac( "select entry_date from $procedure_name('$ac_num')", $attr );

    while ( @a = $q->fetchrow_array() ) {
        push @monthes, $a[0] unless grep /^$a[0]$/, @monthes;
    }
    my @mnths =
      qw(           );
    $nmon = '1';
    $retunData =
qq^<select name="monthes" onchange='top.location.href = this.options[this.selectedIndex].value'>^;
    foreach $m (@monthes) {
        ( $mnth, $y ) = split /\./, $m;
        $m_link = $mnths[ $mnth - 1 ] . ' ' . $y;
        my $selected;
        if ( param('mnth') eq $nmon ) {
            $selected = 'selected';
            $mn       = $mnth;
            $yy       = $y;
        }
        elsif ( !param('mnth') and $monthes[-1] eq $m ) {
            $selected = 'selected';
            $mn       = $mnth;
            $yy       = $y;
        }
        elsif ( param('mnth') =~ /^-1$/ and $monthes[-1] eq $m ) {
            $selected = 'selected';
            $mn       = $mnth;
            $yy       = $y;
        }
        $retunData .=
qq^<option $selected value="$cms?mod=account&mnth=$nmon&s=$ssid">$m_link</option>^;
        $nmon++;
    }

    my ( $current_month, $current_year ) = ( $mn, $yy );

    return "1.$current_month.$current_year",
      DaysInMonth( $current_month, $current_year )
      . ".$current_month.$current_year"
      unless $ssid;
    $retunData .= qq^</select>^;
    return $retunData if $ssid;
}

sub accountDataPay2 {
    my $ac_num = $_[0];
    my $sid    = $_[1];
    my $i      = 1;
    my @dts    = accountDatesList($ac_num);
    my $attr   = { ib_timestampformat => '%d.%m.%y', };
    my $q;

    if ( param('print') == 1 ) {
        $q = sqlpac( "select * from get_account_detail_2('$ac_num')", $attr );
    }
    else {
        $q = sqlpac(
"select * from get_account_detail_2('$ac_num') where entry_date between '$dts[0]' and '$dts[1]'",
            $attr
        );
    }

    my @a;
    my (
        $sum,       $sum2,      %tab_start, %tab_end, %tab_par6,
        %tab_priv7, %tab_subs8, %tab_sff9,  %tab_cred10
    );
    while ( @a = $q->fetchrow_array() ) {
        my $rows    = $i / 2;
        my $trclass = 'row0';
        unless ( $rows =~ /^-?\d+\/?\d*$/ ) { $trclass = 'row1' }
        $a[0] =~ s/\s00:00:00$//;
        $tab_start{$i} =
qq^<tr class=$trclass><td>$i</td><td>$a[0]</td><td align=left>$a[3]</td><td>$a[5]</td>^;
        $tab_end{$i}    = qq^<td>$a[11]</td></tr>^;
        $tab_par6{$i}   = qq^$a[6]^ if $a[6];
        $tab_priv7{$i}  = qq^$a[7]^ if $a[7];
        $tab_subs8{$i}  = qq^$a[8]^ if $a[8];
        $tab_sff9{$i}   = qq^$a[9]^ if $a[9];
        $tab_cred10{$i} = qq^$a[10]^;
        $i++;
        $sum  = $sum + $a[5];
        $sum2 = $sum2 + $a[10];
    }

    my $returnData;
    if ( param('print') ) {
        $returnData = q^
<style type="text/css">

@media print {
	.dontprint {
		visibility:hidden;
		display:none;
	}
}

* { font: 9pt/1.35em Verdana, sans-serif; }
body { background: #fff none; width: auto; }
a { color: #000 }
p { margin: 0 0 0.5em }

table {
	border-collapse: collapse;
	border: none;
	border-left:   solid 1px #ccc;
	border-top:    solid 1px #ccc;
}

table tr th,
table tr td {
	border: none;
	border-right:  solid 1px #ccc;
	border-bottom: solid 1px #ccc;
}

</style>
^;
    }
    else {
        $returnData = qq^<h4>      ^;
        $returnData .= accountDatesList( $ac_num, $sid );
        $returnData .= qq^</h4>^;
    }

    my $tab_th =
qq^<table width="100%" class="payData"><tr><th> /</th><th></th><th></th><th>, .</th>^;
    my $tab_th_end = qq^<th>, .</th></tr>^;
    if ( %tab_priv7 or %tab_subs8 or %tab_sff9 ) {
        $returnData .=
qq^$tab_th <th class=th_cred>.</th><th class=th_cred>.</th><th class=th_cred>.</th><th class=th_cred></th><th class=th_cred> , .</th> $tab_th_end^;
        foreach my $row ( sort { $a <=> $b } keys %tab_start ) {
            $returnData .=
qq^$tab_start{$row}<td class="prnt">$tab_par6{$row}</td><td>$tab_priv7{$row}</td>
            <td>$tab_subs8{$row}</td><td>$tab_sff9{$row}</td><td class="cred">$tab_cred10{$row}</td> $tab_end{$row}^;
        }
        $returnData .=
qq^<tr><td></td><td></td><td align=right>:</td><td>$sum</td><td></td><td></td><td></td><td></td><td>$sum2</td></tr></table><br>^;
    }
    else {
        $returnData .= qq^$tab_th <th>, .</th> $tab_th_end^;
        foreach my $row ( sort { $a <=> $b } keys %tab_start ) {
            $returnData .=
              qq^$tab_start{$row}<td>$tab_cred10{$row}</td>$tab_end{$row}^;
        }
        $returnData .=
qq^<tr><td></td><td></td><td align=right>:</td><td>$sum</td><td>$sum2</td></tr></table><br>^;
    }

    unless ( param('print') ) {
        $returnData .= qq[<div class="account-print">
<a class="dontprint" href="$cms?mod=account&s=$sid&print=1">  </a>
</div>];
    }

    return $returnData;
}

sub accountDataPay {
    my $ac_num = $_[0];
    my $sid    = $_[1];
    my $i      = 1;
    my @dts    = accountDatesList($ac_num);
    my $attr   = { ib_timestampformat => '%d.%m.%y', };
    my $q;

    my $returnData;
    if ( param('print') ) {
        $returnData = q^
<style type="text/css">

@media print {
	.dontprint {
		visibility:hidden;
		display:none;
	}
}

* { font: 9pt/1.35em Verdana, sans-serif; }
body { background: #fff none; width: auto; }
a { color: #000 }
p { margin: 0 0 0.5em }

table {
	border-collapse: collapse;
	border: none;
	border-left:   solid 1px #ccc;
	border-top:    solid 1px #ccc;
}

table tr th,
table tr td {
	border: none;
	border-right:  solid 1px #ccc;
	border-bottom: solid 1px #ccc;
}

</style>
^;
    }
    else {
        $returnData = qq^<h4>      ^;
        $returnData .= accountDatesList( $ac_num, $sid );
    }

    $returnData .= qq^</h4><table width="100%" class="payData">
        <tr><th> /</th><th></th><th></th><th>, .</th><th>, .</th><th>, .</th></tr>
    ^;

    if ( param('print') == 1 ) {
        $q = sqlpac( "select * from get_account_detail('$ac_num')", $attr );
    }
    else {
        $q = sqlpac(
"select * from get_account_detail('$ac_num') where entry_date between '$dts[0]' and '$dts[1]'",
            $attr
        );
    }

    my @a;
    my ( $sum, $sum2 );
    while ( @a = $q->fetchrow_array() ) {
        my $rows    = $i / 2;
        my $trclass = 'row0';
        unless ( $rows =~ /^-?\d+\/?\d*$/ ) { $trclass = 'row1' }
        $a[0] =~ s/\s00:00:00$//;
        $a[1] = ' . .' if $a[1] =~ /   /;
        $a[2] = sprintf( "%.2f", $a[2] ) if $a[2];
        $a[4] = sprintf( "%.2f", $a[4] );
        $returnData .=
qq^<tr class=$trclass><td>$i</td><td>$a[0]</td><td>$a[1]</td><td>$a[2]</td><td>$a[3]</td><td>$a[4]</td></tr>^;
        $i++;
        $sum  = $sum + $a[2];
        $sum2 = $sum2 + $a[3];
    }
    $sum = sprintf( "%.2f", $sum );

    $returnData .=
qq^<tr><td></td><td></td><td align=right>:</td><td>$sum</td><td>$sum2</td></tr></table><br>^;

    unless ( param('print') ) {
        $returnData .= qq[<div class="account-print">
<a class="dontprint" href="$cms?mod=account&s=$sid&print=1">  </a>
</div>];
    }

    return $returnData;
}

sub accountSumm {
    my $ac_num = $_[0];
    my $summ;
    if ( $gconf{"db_path"} ne $gconf{"accountdbname"} ) {
        $summ = sqlffac(
            "select sum(t1.unit_value) from sys_entry t1, sys_matrix t2
                        where t2.vw_pupil = '$ac_num' and t1.debet_node = t2.node_id and doc_class = 2"
        );
    }
    else {
        $summ = sqlffac(
            "select sum(t1.unit_value) from sys_entry t1, sys_matrix t2
                        where t2.vw_pupil = '$ac_num' and t1.debet_node = t2.node_id and doc_class in (4003, 4004)"
        );
    }
    $summ = sprintf( "%.2f", $summ );
    return "<br><p>    : <b>$summ .</b></p>";
}

sub accountChkPrm {
    if (   param('num') =~ /^\d{9}$/
        && param('date') =~ /^[0-9]{1,2}\.[0-9]{1,2}\.[0-9]{4}$/ )
    {
        return 1;
    }
    else { return 0 }
}

sub accountForm {
    my %replace = ();
    return return_block( \%replace, "$theme_dir/$theme/account_form.html" );
}

sub sqlffac {
    my $sql  = shift;
    my $attr = shift;
    __sql_prolog() if $DEBUG;
    my $q = $gdbac->prepare( $sql, $attr ) or report_sql_error($sql);
    $q->execute() or report_sql_error($sql);
    my $a = ( $q->fetchrow_array() )[0];
    $q->finish;
    __sql_epilog( \$sql ) if $DEBUG;
    return $a;
}

sub sqlpac {
    my $sql  = shift;
    my $attr = shift;
    __sql_prolog() if $DEBUG;
    my $q = $gdbac->prepare( $sql, $attr ) or report_sql_error($sql);
    $q->execute() or report_sql_error($sql);
    __sql_epilog( \$sql ) if $DEBUG;
    return $q;
}

sub sqlhac($$) {
    my $hash_ref = shift;
    my $sql      = shift;
    my ( $id, $value );
    __sql_prolog() if $DEBUG;
    my $q = $gdbac->prepare($sql) or report_sql_error($sql);
    $q->execute() or report_sql_error($sql);
    while ( ( $id, $value ) = $q->fetchrow_array ) {
        ${$hash_ref}{$id} = $value;
    }
    $q->finish;
    __sql_epilog( \$sql ) if $DEBUG;
}

sub sqlfac {
    my $sql  = shift;
    my $attr = shift;
    __sql_prolog() if $DEBUG;
    my $q = $gdbac->prepare( $sql, $attr ) or report_sql_error($sql);
    $q->execute() or report_sql_error($sql);
    my @a = $q->fetchrow_array();
    $q->finish;
    __sql_epilog_cms( \$sql ) if $DEBUG;
    return @a;
}

sub ConnectDBac {
    if ( !defined($gdbac) or !$gdbac->ping ) {
        $gdsnac =
            "DBI:InterBase:db="
          . $gconf{"accountdbname"}
          . ";ib_charset=WIN1251;ib_dialect=1;host="
          . $gconf{"accountdbhost"};
        $gdbac =
          DBI->connect( $gdsnac, $gconf{"cmsdbuser"}, $gconf{"cmsdbpasswd"} )
          or db_error_connect(4);
        $gdbac->{FetchHashKeyName} = 'NAME_lc';
    }
}

sub accountConfig {

}

sub search {
    my $return_data;
    foreach my $line ( open_tpl("$theme_dir/$theme/searchform.html") ) {
        if ( $line =~ /name="mod" value="search"/ ) {
            $line =
              "<input type=\"hidden\" name=\"ow\" value=\"$owner\" />" . $line;
        }
        $return_data .= $line;
    }
    return $return_data;
}

sub searchResults {

    my $query = uc param('inp');

    my $query_for_output = param('inp');

    $query            = SearchEsc($query);
    $query_for_output = SearchEsc($query_for_output);

    my $found_count;
    my $return_data;
    my $title_data;

    if ($query) {
        $return_data .= "<div id='serp'>";

        my @retDataNews = SearchNews( $query, 0 );
        $return_data .= $retDataNews[0];

        my @retDataContent = SearchContent( $query, $retDataNews[1] );
        $return_data .= $retDataContent[0];

        $return_data .= "</div>";

        $found_count = $retDataContent[1];

        $return_data .=
qq^<hr class="serp"> [ <b>$query_for_output</b> ]    :
<a href="http://www.google.com/search?q=$query_for_output" target="_blank">Google</a>,
<a href="http://www.yandex.ru/yandsearch?rpt=rad&text=$query_for_output" target="_blank">Yandex</a>,
<a href="http://ru.wikipedia.org/w/index.php?title=Special%3ASearch&search=$query_for_output" target="_blank">Wikipedia</a>,
<a href="http://search.rambler.ru/cgi-bin/rambler_search?english=0&and=1&words=$query_for_output" target="_blank">Rambler</a>,
<a href="http://sm.aport.ru/scripts/template.dll?That=std&r=$query_for_output" target="_blank">Aport</a>
^;

        $title_data =
          qq^<span class="componentheading"> :</span><br>
<form action="$cms" method="post">
<input type="hidden" name="mod" value="search" />
<input type="hidden" name="ow" value="$owner" />
<input type="text" name="inp" id="search_searchword" size="30" maxlength="30" value="$query_for_output" class="inputbox" x-webkit-speech="" onwebkitspeechchange="this.form.submit();" />
<input type="submit" name="submit" value="" class="button" />
</form>

<table class="searchintro">
<tr>
	<td colspan="3" align="left">
		 : <b>$query_for_output</b>,  : <b>$found_count</b><br/>
	</td>
</tr>
</table><hr class="serp">^;
    }
    else {
        $return_data = "dd";
    }
    return $title_data . $return_data;
}

sub SearchEsc {
    my $query = $_[0];
    if ( $query =~ /^\s*$/ or $query eq '' ) { $query = 0 }
    else {
        $query = substr( $query, 0, 127 );
        $query =~ s/&/&amp;/g;
        $query =~ s/</&lt;/g;
        $query =~ s/>/&gt;/g;
        $query =~ s/'/&ldquo;/g;
    }
    return $query;
}

sub SearchNews {
    my $query       = $_[0];
    my $found_count = $_[1];
    my $ret_data;
    my $found_fragment;
    my @a;
    my $q = sqlpcms(
qq[select news_id,head,text,exttext from news where published=1 and owner=$owner order by startdate desc]
    );
    while ( @a = $q->fetchrow_array() ) {
        my $found = 0;
        $a[1] =~ s/&nbsp;/ /g;
        $a[1] =~ s/<.?[^<>]*>//g;
        if ( $a[1] =~ m/\Q$query\E/i ) { $found = 1 }
        if ( !$found ) {
            $a[2] =~ s/&nbsp;/ /g;
            $a[2] =~ s/<.?[^<>]*>//g;
        }
        if ( !$found and $a[2] =~ m/\Q$query\E/i ) { $found = 2 }
        if ( !$found ) {
            $a[3] =~ s/&nbsp;/ /g;
            $a[3] =~ s/<.?[^<>]*>//g;
        }
        if ( !$found and $a[3] =~ m/\Q$query\E/i ) { $found = 3 }
        if ($found) {
            if ( $found != 1 ) {
                $a[$found] =~ s/<.?[^<>]*>//g;
            }
            if ( $a[$found] =~ m/(\w*.{0,70}$query.{0,70}\w*)/is ) {
                $a[$found] = $1;
            }
            $a[$found] =~ s/&nbsp;/ /g;
            $a[$found] =~ s/\s+/ /g;
            $a[$found] =~ s/($query)/<span class="highlight">$1<\/span>/i;
            my $n = $found_count + 1;
            $found_fragment =
              ( $found == 1 )
              ? qq^<span class='small serp-found-in-header'>  </span>^
              : "... $a[$found] ...";
            $ret_data .= qq^
            <a href='$cms?mod=news&rn=$a[0]'><span class='small serp-position'>$n. </span>$a[1]</a><br>
            <div>$found_fragment
            <br><span class='small serp-url'>$cms?mod=news&rn=$a[0]</span></div><br>^;
            $found_count++;
        }
    }
    return ( $ret_data, $found_count );
}

sub SearchContent {
    my $query       = $_[0];
    my $found_count = $_[1];
    my $ret_data;
    my $found_fragment;
    my @a;
    my $q = sqlpcms(
qq[select c_id,head,text from content where published=1 and owner=$owner order by startdate desc]
    );
    while ( @a = $q->fetchrow_array() ) {
        my $found = 0;
        $a[1] =~ s/&nbsp;/ /g;
        $a[1] =~ s/<.?[^<>]*>//g;
        if ( $a[1] =~ m/\Q$query\E/i ) { $found = 1 }
        if ( !$found ) {
            $a[2] =~ s/&nbsp;/ /g;
            $a[2] =~ s/<.?[^<>]*>//g;
        }
        if ( !$found and $a[2] =~ m/\Q$query\E/i ) { $found = 2 }
        if ($found) {
            if ( $found != 1 ) {
                $a[$found] =~ s/<.?[^<>]*>//g;
            }
            if ( $a[$found] =~ m/(\w*.{0,70}$query.{0,70}\w*)/is ) {
                $a[$found] = $1;
            }
            $a[$found] =~ s/&nbsp;/ /g;
            $a[$found] =~ s/\s+/ /g;
            $a[$found] =~ s/($query)/<span class="highlight">$1<\/span>/i;
            my $n = $found_count + 1;
            $found_fragment =
              ( $found == 1 )
              ? qq^<span class='small serp-found-in-header'>  </span>^
              : "... $a[$found] ...";
            $ret_data .= qq^
            <a href='$cms?mod=content&rc=$a[0]'><span class='small serp-position'>$n. </span>$a[1]</a><br>
            <div>$found_fragment
            <br><span class='small serp-url'>$cms?mod=content&rc=$a[0]</span></div><br>^;
            $found_count++;
        }
    }
    return ( $ret_data, $found_count );
}

sub modules {
    if ( defined param('edt') ) {
        if ( param('edt') eq 'lst' ) { ModulesPrintList() }
        elsif ( param('edt') eq 'pub' ) {
            my $i_id = param('id');
            sec_gteq0($i_id);
            my $gid_o = gid_o();
            my $pub   = sqlffcms(
"SELECT modules_cnf_users.published FROM modules, modules_cnf_users
            WHERE modules_cnf_users.mod_id = modules.i_id and modules_cnf_users.i_id = $i_id
            and modules_cnf_users.owner = '$owner' and modules.access like '%,$gid_o,%'"
            );
            my $published = '0';
            if ( $pub eq '0' ) { $published = '1' }
            sqlcms(
"update modules_cnf_users set PUBLISHED = $published where i_id = $i_id and owner = $owner"
            );
            ModulesPrintList();
        }
        elsif ( param('edt') eq 'mva' ) {
            my $id      = param('id');
            my $m_place = param('place');

            sec_gteq0($id);
            security_alert( $m_place, 'not in @M_Place' )
              unless ( grep /^\Q$m_place\E$/, @M_Place );

            sqlcms(
"update modules_cnf_users set M_PLACE = '$m_place' where I_ID = $id and owner = '$owner'"
            );
            ModulesPrintList();
        }
        elsif ( param('edt') eq 'cnf' ) {
            my $m_place = param('place');

            ModulesPrintConf();
        }
        elsif ( param('edt') eq 'sort' ) {
            Sort_Order_id();
            ModulesPrintList();
        }
        elsif ( param('edt') eq 'so' ) { ModulesSaveOpt(); ModulesPrintList(); }
    }

}

sub ModulesPrintList {
    my $filtr = param('fltm');
    $filtr =~ s/'//g;
    my $access = ",$owner,";
    my $i      = 1;
    print q^<h1>: </h1>
    <p>: <select name=section onchange='top.location.href = this.options[this.selectedIndex].value'>^;
    my $key;
    my $selected = "";
    unless ( param('fltm') =~ /^-?\d+\/?\d*$/ ) { $selected = "selected" }
    print
"<option value=?mod=modules&edt=lst&fltm=$key $selected> </option>";

    foreach $key (@M_Place) {
        my $selected = "";
        if ( $key eq param('fltm') ) { $selected = "selected"; }
        print
"<option value=?mod=modules&edt=lst&fltm=$key $selected>$key</option>";
    }
    print "</select></p>";
    print qq^
<table align="center" class=adminlist width="97%">
<tr>
		<th class="n"></th>
		<th></th>
		<th></th>
		<th></th>
		<th></th>
		<th> </th>
</tr>^;

    my $sec_id = '';
    if ( param('fltm') ne '' ) {
        $sec_id = "and modules_cnf_users.m_place = \'$filtr\'";
    }

    my $zapros =
"select modules_cnf_users.i_id from modules_cnf_users where owner = $owner $sec_id order by I_SORT desc";
    my $q = sqlpcms($zapros);

    my @a;
    my %Next_id;
    my $next_id;
    while ( @a = $q->fetchrow_array() ) {
        $Next_id{ $a[0] } = $next_id;
        $next_id = $a[0];
    }

    my $gid_o = gid_o();

    if ( isadmin() ) {
        $gid_o = 6;
    }

    $zapros =
"SELECT modules_cnf_users.i_id, visible_name, published, modules_cnf_users.m_place, i_sort, modules_cnf_users.Show_on, modulename
FROM modules, modules_cnf_users WHERE modules_cnf_users.mod_id = modules.i_id
and modules_cnf_users.owner = '$owner' $sec_id and modules.access like '%,$gid_o,%' order by modules_cnf_users.I_SORT";

    $q = sqlpcms($zapros);

    my $pred_id;
    while ( @a = $q->fetchrow_array() ) {
        my $published = '';
        my $title     = '';
        my $color     = '<font color="#FF0000">';
        my $rows      = $i / 2;
        my $trclass   = 'row0';
        unless ( $rows =~ /^-?\d+\/?\d*$/ ) { $trclass = 'row1'; }
        if ( $a[2] eq '1' ) {
            $published = '';
            $title     = ' ';
            $color     = '<font color="#00CC00">';
        }
        print qq^<tr class=$trclass>
<td class="r">$i</td>
<td><a href="$cms?mod=modules&edt=cnf&id=$a[0]&fltm=$filtr" title=" ">$a[1]</a></td>^;
        my $moveing =
"<select name=section onchange='top.location.href = this.options[this.selectedIndex].value'>";
        foreach $key (@M_Place) {
            my $selected = "";
            if ( $key eq $a[3] ) { $selected = "selected"; }
            $moveing .=
"<option value=?mod=modules&edt=mva&id=$a[0]&place=$key&fltm=$filtr $selected>$key</option>";
        }
        $moveing .= "</select>";
        print qq^<td class="c">$moveing</td>
<td class="c"><a title="$title" href="$cms?mod=modules&edt=pub&id=$a[0]&fltm=$filtr">$color $published</a></td>
<td class="c"><a href=$cms?mod=modules&edt=sort&what=$a[0]&to=$pred_id&fltm=$filtr>&uarr; </a>&nbsp;&nbsp;<a href=$cms?mod=modules&edt=sort&what=$a[0]&to=$Next_id{$a[0]}&fltm=$filtr>&darr; </a></td>^;
        my @not_add =
          qw(newsinf bloginf mainmenu bdayinf lastcontent names analytics rssblock);
        my $add2menu;
        unless ( grep /$a[6]\b/, @not_add ) {
            $add2menu = qq^<form method="POST" action="$cms">
	<input type="hidden" name="mod" value="mainmenu" />
	<input type="hidden" name="edt" value="add" />
	<input type="hidden" name="mhead" value="$a[1]" />
	<input type="hidden" name="murl" value="$cms?mod=$a[6]" />
	<input type="submit" value="" name="B1"></form>^
        }
        else { $add2menu = '-' }
        print qq^<td class="c">$add2menu</td>^;
        $i++;
        $pred_id = $a[0];
    }
    print "</table>";
}

sub ModulesSaveOpt {
    my $mod_id  = param('i_id');
    my $show_on = param('show_on');
    if    ( $show_on eq 'FP' ) { $show_on = ',FirstPage,' }
    elsif ( $show_on eq 'AP' ) { $show_on = ',AllPage,' }
    elsif ( $show_on eq 'MP' ) { $show_on = '' }
    else { error("     ") }
    sqlcms(
"update modules_cnf_users set show_on = '$show_on' where i_id = '$mod_id' and owner = '$owner'"
    );
    if ( $owner eq '6' ) {
        my ( $gTeach, $gChild );
        if ( param('g2') eq 'ON' ) { $gTeach = ',2,' }
        if ( param('g4') eq 'ON' ) { $gChild = ',4,' }
        sqlcms(
            "update modules set modules.access = ',6,$gTeach$gChild'
					where modules.i_id in
					( select mod_id from modules_cnf_users where i_id = '$mod_id' )
        "
        );
    }
    if (
        sqlffcms(
            "select m_config from modules_cnf_users where i_id = '$mod_id'") ne
        ''
      )
    {
        my $mod_name = sqlffcms(
            qq^SELECT modules.modulename
					FROM modules, modules_cnf_users WHERE modules_cnf_users.mod_id = modules.i_id
					and modules_cnf_users.i_id = '$mod_id'
				^
        );
        my %tmpHash;
        $tmpHash{mod} = $mod_name . 'Config';
        no strict 'refs';
        $tmpHash{'mod'}();
    }
}

sub loginform {
    SchoolID();

    if ( session_check(1) ) {
        $HEAD .= qq^
        <script type="text/javascript" src="/sp/yui/yahoo-dom-event/yahoo-dom-event.js"></script>
        <script type="text/javascript" src="/sp/yui/container/container_core.js"></script>
        <script type="text/javascript" src="/sp/yui/container/container.js"></script>
        <link rel="stylesheet" type="text/css" href="/sp/yui/assets/skins/sam/sp.css?4.3-dev.0">
        ^ unless $HEAD =~ m|sp/yui/container/container_core.js|;

        my $uid = uid();
        my ( @a, @last, @Uids );
        push @Uids, $uid;
        my $q = sqlpcms(
"select first 2 Date_s from logs_session where uid = '$uid' order by date_s DESC"
        );
        while ( @a = $q->fetchrow_array() ) { push @last, $a[0] }
        my %photo_links = Users_Photos( \@Uids, 1 );

        my %replace = (
            foto    => $photo_links{$uid},
            name    => GetNameByUid($uid),
            lastlog => '<span id="lastlog">' . $last[-1] . '</span>'
        );

        return return_block( \%replace,
            "$theme_dir/$theme/loginform_autorized.html" );
    }
    else {
        my %replace = ( redirect_to => "$cms?$ENV{'QUERY_STRING'}" );
        return return_block( \%replace, "$theme_dir/$theme/loginform.html" );
    }
}

sub UserFotoDel {
    my ( $uid, $dir ) = @_;
    if ($uid) {
        opendir( DIR, "$dir" ) or die $!;
        my @file = grep { /--av$uid\./i } readdir(DIR);
        for (@file) { unlink "$dir/$_" }
        close(DIR);
    }
}

sub UserFotoResize {
    my $file  = $_[0];
    my $image = Image::Magick->new;
    my ( $old_width, $old_height, undef, $format ) = $image->Ping("$file")
      if -f "$file"
          or stop(' ');
    my $new_width  = '64';
    my $new_height = ( $new_width * $old_height ) / $old_width;
    ImgResize( $new_width, $new_height, "$file" );
}

sub UserFotoUpload {
    my $uid = $_[0];
    my $gid = gid();
    my $dir;
    if ( $gid == 2 or $gid == 1 or $gid == 0 ) {
        $dir = "$rootdirsp/cms/users_photos/teachers";
    }
    elsif ( $gid == 4 ) { $dir = "$rootdirsp/cms/users_photos/students" }
    unless ( -d "$dir" ) { mkdir "$rootdirsp/cms/users_photos"; mkdir "$dir"; }
    UserFotoDel( $uid, "$dir" );
    my $nnn  = int( rand(999) );
    my $name = "$nnn" . "_--av$uid.jpg";
    my $fh   = upload('file');
    open UPLOADFILE, ">$dir/$name" or die $!;
    binmode UPLOADFILE;
    while (<$fh>) { print UPLOADFILE }
    close UPLOADFILE;
    UserFotoResize("$dir/$name");
    exit print redirect("$cms");
}

sub actions {
    ActionsInformer();
}

sub actionsConfig {
    GetConfig('actions');
}

sub ActionsInformer {
    GetConfig('actions');
    $MOD_CONFIG{'actions_item'} = '7';
    $MOD_CONFIG{'actions_next'} = '1';
    my ( %replace, @a, $BlockContent );
    my @tpl_data_cache = open_tpl("$theme_dir/$theme/actions_item.html");
    my $attr           = {
        ib_timestampformat => '%d %B %Y %H:%M',
        ib_dateformat      => '%d.%m.%y',
        ib_timeformat      => '%H:%M',
    };
    my $q = sqlpcms(
"select theme,start_date,end_date from actions_themat where owner = $owner and pub =1 and current_date between start_date and end_date order by start_date",
        $attr
    );
    $BlockContent .= "<div class=bday_header>:</div>";

    while ( @a = $q->fetchrow_array() ) {
        $replace{'action'} = "$a[0]<br>", $replace{'date'} = "$a[1] - $a[2]";
        my @tpl_data = @tpl_data_cache;
        $BlockContent .= return_item( \%replace, \@tpl_data );
    }
    if ( $MOD_CONFIG{'actions_next'} ) {
        my $q = sqlpcms(
"select first 3 theme,start_date,end_date from actions_themat where owner = 6 and pub =1 and current_date < start_date order by start_date",
            $attr
        );
        $BlockContent .= "<div class=bday_header>:</div>";
        while ( @a = $q->fetchrow_array() ) {
            $replace{'action'} = "$a[0]<br>",
              $replace{'date'} = "$a[1] - $a[2]";
            my @tpl_data = @tpl_data_cache;
            $BlockContent .= return_item( \%replace, \@tpl_data );
        }
    }
    my %replace1 = ( items => $BlockContent );
    return return_block( \%replace1, "$theme_dir/$theme/actions.html" );
}

sub ChkShowOn {
    my $a3       = $_[1];
    my $a0       = $_[0];
    my $mod_name = ',' . param('mod') . ',';
       if ($a3 =~ /$mod_name/
        or $a3 eq ',AllPage,'
        or ( param('mod') eq '' and $a3 =~ /,FirstPage,/ )
        or param('mod') eq $a0 )
    {
        return 1;
    }
    else { return 0 }
}

sub GetConfig {
    my $module = $_[0];
    my $zapros =
"select modules_cnf_users.m_config from modules, modules_cnf_users WHERE modules_cnf_users.mod_id = modules.i_id
									and modules.modulename = '$module' and modules_cnf_users.owner = '$owner'";
    my $q = $gdbcms->prepare($zapros) or db_error();
    $q->execute() or db_error();
    my @a;
    my @b;
    while ( @a = $q->fetchrow_array() ) {
        @b = split( /,/, $a[0] );
        foreach my $item (@b) {
            my ( $perem, $znach ) = split( /=/, $item );
            $perem ||= '';
            $MOD_CONFIG{$perem} = $znach;
        }
    }
}

sub news {
    GetConfig('news');
    my $empty = 'empty';
    if ( param('mod') eq 'news' ) {
        if ( param('rn') ) { NewsCall( param('rn'), $empty ) } elsif (
            param('nb') )
        {
            NewsCall( $empty, param('nb') );
        } elsif ( param('act') ) {
            NewsActs();
        }
        elsif ( param('edt') ) { NewsEdit() }
        elsif ( param('arc') ) { NewsArc() }

        else {
            NewsCall( $empty, '0' );
        };
    }
    else { NewsCall( $empty, '0' ); };
}

sub NewsActs {
    my $curr_uid = uid();
    if    ( param('act') eq 'dc' )     { NewsCommentDel($curr_uid) }
    elsif ( param('act') eq 'comadd' ) { NewsCommentAdd($curr_uid) }
    elsif ( param('act') eq 'upl' )    { UserFotoUpload($curr_uid) }
}

sub NewsCommentDel {
    my $cn_id   = param 'n_c';
    my $cur_uid = $_[0];
    my $aut_fr_base =
      sqlffcms("select autor from news_comment where cn_id='$cn_id'");
    my $n_id = sqlffcms("select n_id from news_comment where cn_id='$cn_id'");
    if ( $aut_fr_base eq $cur_uid or gid( $cur_uid, 6 ) or $cur_uid eq $owner )
    {
        sqlcms(
            "delete from news_comment where cn_id='$cn_id' and owner = $owner");
    }
    exit print redirect("$cms?ow=$owner&mod=news&rn=$n_id");
}

sub NewsComment {
    my $n_id = $_[0];
    my ( @a, $ret_data, $s_ok, $curr_uid );

    if ( session_check(1) ) {
        $s_ok     = 1;
        $curr_uid = uid();
    }

    $ret_data = '<div id="comments">';

    my $q = sqlpcms(
"select * from news_comment where owner = '$owner' and n_id = '$n_id' order by date_cn"
    );
    while ( @a = $q->fetchrow_array() ) {
        $ret_data .=
          NewsCommentHtml( $a[0], $a[1], $a[2], $a[3], $a[5], $curr_uid,
            $s_ok );
    }

    $ret_data .= '</div>';

    $ret_data .= NewsCommentEditForm( $n_id, $s_ok );
    return $ret_data;
}

sub NewsCommentHtml {
    my ( $cn_id, $n_id, $txt, $autor, $date, $curr_uid, $s_ok ) = @_;

    my (@Uids);

    push @Uids, $autor;

    my %photo_links = Users_Photos( \@Uids );

    my @tpl_comment_delete =
      open_tpl("$theme_dir/$theme/news_comment_delete.html");

    my $delete;

    if ($s_ok) {
        if ( $autor eq $curr_uid or gid( $curr_uid, 6 ) or $curr_uid eq $owner )
        {
            $delete = join(
                '',
                tpl_replace_ant(
                    { delete_link => qq[$cms?mod=news&act=dc&n_c=$cn_id] },
                    \@tpl_comment_delete
                )
            );

        }
    }
    my %replace = (
        delete     => $delete,
        foto       => $photo_links{$autor},
        text       => $txt,
        autor      => GetNameByUid($autor),
        date       => $date,
        comment_id => $cn_id
    );
    return return_block( \%replace, "$theme_dir/$theme/news_comment.html" );
}

sub NewsCommentEditForm {
    my $ret_data;

    my $n_id = $_[0];
    my $s_ok = $_[1];

    foreach my $line ( open_tpl("$theme_dir/$theme/news_comment_form.html") ) {
        if ( $line =~ /form id="commentform"/igm ) {
            $line = $line
              . "<input type=\"hidden\" name=\"ow\" value=\"$owner\" />\n";
            $line = $line
              . "<input type=\"hidden\" name=\"n_id\" value=\"$n_id\" />\n";
        }
        elsif ( $line =~ /\$text_head/ ) {
            if ($s_ok) {
                $line =~ s/\$text_head/ :/i;
            }
            else {
                $line =~
s/\$text_head/  ,     /i;
            }
        }

        unless ($s_ok) {
            $line =~ s/<input /<input disabled /;
        }

        $ret_data .= $line;
    }

    return $ret_data;
}

sub NewsCommentAdd {
    my $n_id  = param 'n_id';
    my $autor = $_[0];
    my $text  = param('comments');

    escape_tag( \$text );

    $text = substr( $text, 0, 2049 ) if length($text) > 2049;

    sqlbcms(
        "insert into news_comment (text,autor,owner,n_id,date_cn)
        values (?,'$autor','$owner','$n_id','now')", $text
    );

    exit print redirect ( "$cms?ow=$owner&mod=news&rn=$n_id#comment-"
          . sqlffcms( "select max(cn_id) from news_comment where n_id = $n_id" )
    );
}

sub newsConfig {
    if ( param('edt') ne 'so' ) {
        GetConfig('news');
        my $chk;
        $chk = 'checked' if $MOD_CONFIG{'news_comment'};
        my $return_data = qq^
                 :
            <input type="text" align="center" name="news_on_page" value="$MOD_CONFIG{'news_on_page'}" size="2"><br>
                ,      "":
            <input type="text" align="center" name="news_num_arc" value="$MOD_CONFIG{'news_num_arc'}" size="2"><br>
            <input type="checkbox" name="n_c" $chk value="1">   
        ^;
        if ($CS) {
            $return_data .= qq^
                <fieldset style="padding: 2">
                <legend>    :</legend>
                <input type="radio" name="only_name" value="ON" >   <br>
                <input type="radio" name="name_fio" value="NF">      <br>
                </fieldset>^;
        }
        return "$return_data";
    }
    else {
        my ( $nop, $nna );
        my $mod_id = param('i_id');
        if ( param('news_on_page') =~ /^\d+$/ ) { $nop = param('news_on_page') }
        else                                    { $nop = '5' }
        if ( param('news_num_arc') =~ /^\d+$/ ) { $nna = param('news_num_arc') }
        else                                    { $nna = '10' }
        my $ConfigData = sqlffcms(
            "select modules_cnf_users.m_config from modules_cnf_users
            WHERE modules_cnf_users.i_id = '$mod_id' and modules_cnf_users.owner = '$owner'"
        );
        if ( $ConfigData =~ /news_item_on_page=(\d+),/ ) {
            $ConfigData = ",news_item_on_page=$1";
        }
        else { $ConfigData = ",news_item_on_page=30" }
        my $newscom = param 'n_c' || 1;
        sqlcms(
qq^update modules_cnf_users set m_config = ',news_on_page=$nop,news_num_arc=$nna$ConfigData,news_comment=$newscom' where i_id = '$mod_id' and owner = '$owner'^
        );
    }
}

sub NewsEdit {
    if ( param('edt') eq 'an' and !defined param('newshead') ) {
        NewsAddForm("an");
    }
    elsif ( param('edt') eq 'an' and defined param('newshead') ) {
        my $newshead = escapeHTML( param('newshead') );
        $newshead = substr( $newshead, 0, 257 );
        my $text    = param('text');
        my $exttext = param('exttext');
        my $date =
          ( param('R1') eq 'special' )
          ? "'" . param('startdate') . ":00'"
          : "'NOW'";
        my $published = '0';
        if ( param('C1') eq 'on' ) { $published = '1' }
        my $pubon_CS = '0';
        if ( param('C2') eq 'on' ) { $pubon_CS = '1' }
        my $permalink = param('permalink') || 'NULL';
        $permalink = cms_uniq_permalink($permalink);

        sqlbcms(
"INSERT INTO NEWS (HEAD, STARTDATE, ENDDATE, TEXT, EXTTEXT, PUBLISHED, PUB_CS, AUTOR, OWNER, PERMALINK)
		values (?, $date, $date, ?, ?, $published, $pubon_CS, $autor_insert, $owner, ?)",
            $newshead, $text, $exttext, $permalink
        );

        if ( !$CS and $owner eq '6' ) {
            if ( param('C2') eq 'on' ) {
                my $CS_ID = sqlffcms(
"select max(news_id) from news where AUTOR = $autor_insert and OWNER = $owner"
                );
                NewsAdd2CS($CS_ID);
            }
        }
        NewsPrintList();
    }
    elsif ( param('edt') eq 'lst' ) { NewsPrintList() }
    elsif ( param('edt') eq 'ajax_pub' ) {
        my $news_id   = param('ni');
        my $published = '0';
        if (
            sqlffcms(
"select published from news where news_id = $news_id and owner = $owner"
            ) eq '0'
          )
        {
            $published = '1';
        }
        sqlcms(
"update NEWS set PUBLISHED = $published where news_id = $news_id and owner = $owner"
        );
        aj_print('');
    }
    elsif ( param('edt') eq 'ajax_pubcs' and !$CS and $owner eq '6' ) {
        my $news_id = param('ni');
        my $publishedOnCS;
        my @news_id_CS = sqlfcms(
"select CS_ID, AUTOR from news where news_id = $news_id and owner = $owner"
        );
        if ( $news_id_CS[0] ) {
            ConnectDBCS();
            substr( $news_id_CS[1], 4 ) = '';
            my $realPubOnCS = sqlffCS(
"select published from news where news_id = $news_id_CS[0] and owner = $owner and autor like '$news_id_CS[1]%'"
            );
            if    ( $realPubOnCS eq '1' ) { $publishedOnCS = 0 }
            elsif ( $realPubOnCS eq '0' ) { $publishedOnCS = 1 }
            else                          { NewsAdd2CS($news_id) }
            if ( $publishedOnCS eq '1' or $publishedOnCS eq '0' ) {
                sqlCS(
"update NEWS set PUBLISHED = $publishedOnCS where news_id = $news_id_CS[0] and owner = $owner and autor like '$news_id_CS[1]%'"
                );
                sqlcms(
"update NEWS set PUB_CS = $publishedOnCS where news_id = $news_id and owner = $owner"
                );
            }
        }
        else { NewsAdd2CS($news_id) }
        aj_print('');
    }
    elsif ( param('edt') eq 'del' ) {
        my $news_id = param('ni');
        my @cs_id   = sqlfcms(
"select CS_ID, PUB_CS from NEWS where news_id = $news_id and owner = $owner"
        ) if !$CS and $owner eq '6';
        sqlcms("delete from NEWS where news_id = $news_id and owner = $owner");
        if ( !$CS and $owner eq '6' and $cs_id[0] and $cs_id[1] ) {
            ConnectDBCS();
            sqlCS(
                "delete from NEWS where news_id = $cs_id[0] and owner = $owner"
            );
        }
        NewsPrintList();
    }
    elsif ( param('edt') eq 'en' ) {
        my $news_id = param('ni');
        my @a       = sqlfcms(
"select HEAD, TEXT, EXTTEXT, PUBLISHED, PUB_CS, PERMALINK from NEWS where news_id = $news_id"
        );
        my ( $newshead, $text, $exttext, $published, $pub_cs );
        $newshead  = $a[0];
        $text      = $a[1];
        $exttext   = $a[2];
        $published = $a[3];
        $pub_cs    = $a[4];
        NewsAddForm( "sn", $news_id, "$newshead", $text, $published, $pub_cs,
            $exttext, $a[5] );
    }
    elsif ( param('edt') eq 'sn' and defined param('newshead') ) {
        my $news_id  = param('ni');
        my $newshead = substr( escapeHTML( param('newshead') ), 0, 257 );
        my $text     = param('text');
        my $exttext  = param('exttext');
        my $date     = "STARTDATE='NOW',";
        if ( param('R1') eq 'V2' ) { $date = '' }
        elsif ( param('R1') eq 'special' ) {
            $date = "STARTDATE='" . param('startdate') . ":00',";
        }
        my $published = ( param('C1') eq 'on' ) ? '1' : '0';
        my $permalink = param('permalink') || 'NULL';
        $permalink = cms_uniq_permalink( $permalink, 'news', $news_id );

        sqlbcms(
"update NEWS set HEAD=?,$date TEXT=?, EXTTEXT=?, PUBLISHED=$published, PERMALINK=?
		where news_id = '$news_id' and owner = '$owner'", $newshead, $text, $exttext,
            $permalink
        );

        if ( !$CS and $owner eq '6' ) {
            my $news_idCS =
              sqlffcms("select CS_ID from news where news_id = $news_id");
            if ($news_idCS) {
                my $pubCS = '0';
                if ( param('C2') eq 'on' ) { $pubCS = '1' }
                ConnectDBCS();
                if ( $gconf{'optimize_user_jpeg'} eq "1" ) {
                    $text =~
s/(<img .*?style="WIDTH: (\d+)px; HEIGHT: (\d+)px".+?src="(.+?\.jpg)".*?\/>)|(<img .*?height="(\d+)".+?width="(\d+)".+?src="?(.+?\.jpg)".+?\/>)|(<img .*?width="(\d+)".*?height="(\d+)".+?src="?(.+?\.jpg)".+?\/>)/ImgAdd2CS($1|$5|$9)/gemi;
                }
                my $queryText = 'STARTDATE=?, ';
                if ( param('R1') eq 'V2' ) { $queryText = '' }
                elsif ( param('R1') eq 'special' ) {
                    $date = param('startdate') . ':00';
                }

                $text =~
                  s|(<img\s+.*?src=")(/.+?/>)|$1http://$ENV{'SERVER_NAME'}$2|ig;
                $exttext =~
                  s|(<img\s+.*?src=")(/.+?/>)|$1http://$ENV{'SERVER_NAME'}$2|ig;
                my $q = $gdbCS->prepare(
qq{update NEWS set HEAD = ?, $queryText TEXT = ?, EXTTEXT = ?, PUBLISHED = ? where news_id = '$news_idCS' and owner = '$owner'}
                ) or db_error();
                if ( param('R1') eq 'V2' ) {
                    $q->execute( $newshead, $text, $exttext, $published )
                      or db_error();
                }
                else {
                    $q->execute( $newshead, $date, $text, $exttext, $published )
                      or db_error();
                }
                sqlCS(
"update NEWS set PUBLISHED = $pubCS where news_id = $news_idCS and owner = $owner"
                );
                sqlcms(
"update NEWS set PUB_CS = $pubCS where news_id = $news_id and owner = $owner"
                );
            }
        }
        NewsPrintList();
    }
    elsif ( param('edt') eq 'mva' and param('ai') ) { NewsCatMove() }
    elsif ( param('edt') eq 'a_ct' )          { NewsCatAdd() }
    elsif ( param('edt') eq 'del_cat' )       { NewsCatDel() }
    elsif ( param('edt') eq 'ajax_cat_save' ) { NewsCatRnSave() }
}

sub NewsCatRnSave {
    my $cat    = param('ni');
    my $cat2rn = param('cat2rn');
    Encode::from_to( $cat2rn, 'utf-8', 'windows-1251' );
    strip_tag( \$cat2rn, 'clear' );
    sqlbcms( "update news_cat set cat=? where id_n=? and owner=$owner",
        $cat2rn, $cat );
    print
"X-Powered-By: School Portal - www.spcms.ru\nContent-type: text/html; charset=windows-1251\n\n";
    exit print "$cat2rn";
}

sub NewsCatDel {
    my $cat = param('ni');
    sqlcms("delete from news_cat where id_n = '$cat' and owner = '$owner'")
      if $cat;
    NewsPrintList();
}

sub NewsCatAdd {
    my $cat = param('c_name');
    if ($cat) {
        sqlbcms( "INSERT INTO news_cat (cat,OWNER) values (?, $owner)", $cat );
    }
    NewsPrintList();
}

sub NewsAdd2CS {
    my $news_id   = $_[0];
    my $published = '1';
    my @a         = sqlfcms(
        "select HEAD, TEXT, EXTTEXT, AUTOR from NEWS where news_id = $news_id");
    ConnectDBCS();
    my $date = 'NOW';
    if ( $gconf{'optimize_user_jpeg'} eq "1" ) {
        $a[1] =~ s/(<img\s+.*?\/>)/ImgAdd2CS($1)/gemi;
        $a[2] =~ s/(<img\s+.*?\/>)/ImgAdd2CS($1)/gemi;
    }
    $a[1] =~ s|(<img\s+.*?src=")(/.+?/>)|$1http://$ENV{'SERVER_NAME'}$2|ig;
    $a[2] =~ s|(<img\s+.*?src=")(/.+?/>)|$1http://$ENV{'SERVER_NAME'}$2|ig;
    $a[1] =~
s|((<a.*?href=")(.+?\..{1,4})(">.*?\/a>))|$2http://$ENV{'SERVER_NAME'}$3$4|ig;
    $a[2] =~
s|((<a.*?href=")(.+?\..{1,4})(">.*?\/a>))|$2http://$ENV{'SERVER_NAME'}$3$4|ig;

    my $q = $gdbCS->prepare(
qq{INSERT INTO NEWS (HEAD, STARTDATE, TEXT, EXTTEXT, PUBLISHED, AUTOR, OWNER, CS_ID) VALUES (?, ?, ?, ?, ?, ?, ?, ?)}
    ) or db_error();
    $q->execute( $a[0], $date, $a[1], $a[2], $published, $a[3], $owner,
        $news_id )
      or db_error();
    my $CS_ID2 = sqlffCS(
        "select max(news_id) from news where AUTOR = $a[3] and OWNER = $owner");
    sqlcms(
"update NEWS set CS_ID = $CS_ID2, PUB_CS = $published where news_id = $news_id and owner = $owner"
    );
    my $ou_id = SchoolID();

    unless ( sqlffCS("select count(1) from CS_OU_NAMES where OU_ID = $ou_id") )
    {
        my $ou_short_name = MOUName('short');
        my $ou_full_name  = MOUName('full');
        sqlCS(
"insert into CS_OU_NAMES (OU_ID,OU_NAME_SHORT,OU_NAME_FULL) VALUES ($ou_id,'$ou_short_name','$ou_full_name')"
        );
    }
    unless ( sqlffCS("select count(1) from CS_USERS where U_ID = $a[3]") ) {
        my $name = GetNameByUid( $a[3] );
        sqlCS(
"insert into CS_USERS (U_ID,NAME,OU_ID) VALUES ($a[3],'$name',$ou_id)"
        );
    }
}

sub NewsCatMove {
    my $id_n = param('ai');
    my $id_c = param('si') || '0';
    sqlcms(
"update news set cat = '$id_c' where news_id = '$id_n' and owner = '$owner'"
    );
    NewsPrintList();
}

sub NewsPrnLstAddCatFrm {
    my @newscatlst = NewsCatList();
    my $html       = qq^
        <script src="/sp/jquery/js/jquery-1.4.4.min.js"></script>
        <script language="JavaScript">
        function e(id) { return document.getElementById(id); }
        var bells_add_new_tab_mode = false;

        function add_new_tab_mode()
        {
                bells_add_new_tab_mode = !bells_add_new_tab_mode;
                // turn_visibility('new_tab_link');
                // turn_visibility('new_tab_tr');

                if ( bells_add_new_tab_mode )
                {
                        e('bells_new_tab').value = 1;
                        \$('#new_tab_tr').slideDown();
                        e('bells_new_tab_name').focus();
                }
                else
                {
                        e('bells_new_tab').value = 0;
                        \$('#new_tab_tr').slideUp();
                }
        }
        </script>
        <form method="POST" enctype="multipart/form-data">
	<input type="hidden" name="mod" value="news"/>
	<input type="hidden" name="edt" value="a_ct"/>
	<div style="margin: 16px 24px">
        <a class="img i_news_add" href=$cms?mod=news&edt=an> ...</a>&nbsp;&nbsp;&nbsp;
		<a
			id="new_tab_link" title="/ "
			href="#"
			onclick="add_new_tab_mode()"
		>
			<img src="/sp/img/grp_add.gif" align="absmiddle">&nbsp;...
		</a>
	</div>
	<div id="new_tab_tr" class="infoblock" style="display:none; margin-left: 2%">
			 :<br>
			<input class="def2" type="text" name="c_name" id="bells_new_tab_name">
			<input type="hidden" id="bells_new_tab" name="bells_new_tab" value="0"><br>
			<a href="#" onclick="add_new_tab_mode()"></a>
        </form>$newscatlst[0]</div>
    ^;
    return $html, $newscatlst[1];
}

sub NewsCatList {
    my $pg = param('pg') || '1';
    my $qq = sqlpcms("select * from news_cat where owner = '$owner'");
    my @b;
    my %id_cat;
    my $html;
    while ( @b = $qq->fetchrow_array() ) { $id_cat{ $b[0] } = $b[1] }
    if ( scalar %id_cat ) {
        my $i = 1;
        $html = qq^<fieldset style="padding: 2">
                <legend> :</legend><table >^;
        $html .=
qq^<script type="text/javascript" src="/sp/jquery/js/jquery.jeditable.mini.js"></script>
	    <script type="text/javascript">
	     \$(document).ready(function() {
	     \$('.edit').editable('$cms', {
		 placeholder	: '<span style="font-size:8pt;color:#999999;">  ...</span>',
                 width		: '180',
		 height		: '18',
		 name		: 'cat2rn',
		 id		: 'ni',
	         submitdata	: {mod: "news", edt: "ajax_cat_save"},
		 indicator	: '...',
	         tooltip	: '  ...'
	     });
	    });
	    </script>^;
        foreach my $itm ( sort { $a <=> $b } keys %id_cat ) {
            my $onclc =
qq^"return confirm('     <$id_cat{$itm}>?')"^;
            $html .=
qq^<tr><td>$i.</td><td><span class="edit" width="100%" id="$itm">$id_cat{$itm}</span></td><td>
            <a title=" " href="$cms?mod=news&edt=del_cat&ni=$itm&pg=$pg" onclick=$onclc>
            <img src="/sp/img/button_del_cat.gif" width="16" height="16">
            </td></tr>^;
            $i++;
        }
        $html .= qq^</table></fieldset>^;
        </a>;
    }
    return $html, \%id_cat;
}

sub NewsPrintList {
    GetNameByUid('GetAll') if $CS;
    my $sqlPubCS;
    my $pg = param('pg') || '1';
    my $module = param('mod');

    print qq^<h1>:  </h1>^;
    my ( $catlst, $cat_ref ) = NewsPrnLstAddCatFrm();
    print $catlst;
    my %cat_ref = %$cat_ref;
    print
q^<table style="margin-top:4px" align="center" class=adminlist width="97%"><tr>
	<th class="n" title=" "></th>
	<th> /</th>
        <th>/</th>
	<th title=" "></th>^;
    if ( $owner eq '6' and !$CS ) {
        print qq[<th title=" "></th>];
    }
    print q^<th></th>
	<th></th>
	<th></th>
	</tr>^;

    if ( param('pgnum') ) { PageNumUpdate() }

    my $q = sqlpcms2page(
"select startdate, head, published, news_id, autor, permalink, pub_cs, cat from news where owner = $owner order by startdate DESC"
    );
    my @a;
    my $i = 0;

    while ( @a = $q->fetchrow_array() ) {
        my $rows  = $i / 2;
        my $autor = GetNameByUid( $a[4] );
        ( my $a1forJava = $a[1] ) =~ s/"|'//gi;

        my $trclass = 'row0';
        unless ( $rows =~ /^-?\d+\/?\d*$/ ) { $trclass = 'row1' }
        print qq^<tr class=$trclass>
		<td class="n"><a href="^
          . ( $a[5] ? "/$a[5]" : "/news/rn/$a[3]" )
          . qq^" title="" target="_blank"><img src="/sp/img/eye.png"></a></td>
		<td><a title=" " href=$cms?mod=news&edt=en&ni=$a[3]&pg=$pg>$a[1]</td>^;

        my $moveing =
qq^<select name=section onchange='top.location.href = this.options[this.selectedIndex].value'>^;
        my $selected = ' selected' unless $a[7];
        my ( $key, $filtr );
        $moveing .=
qq^<option value="$cms?mod=news&edt=mva&ai=$a[3]&si=$key&filter=$filtr&pg=$pg"$selected> </option>^;

        foreach $key ( sort { $a <=> $b } keys %cat_ref ) {
            $selected = ( $key eq $a[7] ) ? ' selected' : '';
            $moveing .=
qq^<option value="$cms?mod=news&edt=mva&ai=$a[3]&si=$key&filter=$filtr&pg=$pg"$selected>$cat_ref{$key}</option>^;
        }
        $moveing .= "</select>";

        print qq^<td class="c">$moveing</td><td class="c">^;

        print qq[<input type="checkbox" onClick="pubnewsh('$a[3]')"]
          . ( $a[2] eq '1' ? ' checked' : '' )
          . ' title="   ">';

        if ( $owner eq '6' and !$CS ) {
            print
qq[</td><td class="c"><input type="checkbox" onClick="pubnewcs('$a[3]')"]
              . ( $a[6] eq '1' ? ' checked' : '' )
              . ' title="   ">';
        }

        print qq^</td>
		<td class="c d-a">$a[0]</td>
		<td class="c d-a">$autor</td>
		<td class="c"><a title=" " href=$cms?mod=news&edt=del&ni=$a[3]&pg=$pg onClick="return confirm('    $a1forJava?')\"><img src='/sp/img/button_del.gif' width=16 height=16></a></td>
		</tr>^;
        $i++;
    }
    print "</table>";
    print PageNext();
}

sub NewsAddForm {
    my $hiddenedt = $_[0];
    my $news_id   = $_[1];
    my $newshead  = $_[2];
    my $pg        = param('pg') || 1;
    my $text      = $_[3];
    my $published = $_[4];
    my $pub_cs    = $_[5];
    my $exttext   = $_[6];
    my %NEdit     = ( en => '', an => '' );
    my $permalink = $_[7];

    $text =~ s|</textarea>|&lt;/textarea&gt;|g;
    $exttext =~ s|</textarea>|&lt;/textarea&gt;|g if defined $exttext;

    print qq^
	<h1>: $NEdit{param 'edt'} </h1>
	<table class=adminform width="100%">
	<tr><td>
	<form method="POST" action="$cms" name="textForm" onsubmit="return validateForm(this)">
	<p>*  :<br>
	<input type="text" name="newshead" class="def2" maxlength="256" value='$newshead'></p>
	<p>*  :<br>
	<textarea name="text" id="FCKeditor1" rows=30 cols="71" style="width:100%;height:422px;">$text</textarea></p>
		<input type="hidden" name="mod" value="news" />
		<input type="hidden" name="edt" value="$hiddenedt" />
		<input type="hidden" name="ni" value="$news_id" />
		<p> .     &laquo; ....&raquo; ():<br>
	<textarea name="exttext" id="ExtTxt" rows=30 cols="71" style="width:100%;height:422px;">^;

    print "$exttext" if defined $exttext;
    print qq^</textarea></p></td><td valign="top" style="width:168px">
	<fieldset style="padding: 2">
	<legend> : </legend>^;
    my $dateText;
    my $Cheked = 'checked';
    if ( param('edt') eq 'en' ) {
        $dateText =
qq^<label><input type="radio" value="V2" checked name="R1" onclick="e('ustartdate').style.display='none'"> </label><br>^;
        $Cheked = '';
    }
    my $chkPub = 'checked' if $published eq 1 || $published eq '';
    print qq^$dateText
<label><input type="radio" value="V1" $Cheked name="R1" onclick="e('ustartdate').style.display='none'"> </label></br>

<label><input type="radio" name="R1" value="special" onclick="e('ustartdate').style.display=''"> </label>
<div id="ustartdate" style="display:none">
  <input type="text" name="startdate" size="20" value="^
      . date("d.m.Y H:s")
      . qq^" style="text-align: center">
</div>
</fieldset>

<fieldset style="padding: 2">
<legend>:</legend>
<label><input type="checkbox" name="C1" value="on" $chkPub>  </label><br>^;

    if ( !$CS and $owner eq '6' ) {
        my $chkPubCS = 'checked' if $pub_cs eq 1;
        print
qq^<label><input type="checkbox" name="C2" value="on" $chkPubCS>  </label><br>^;
    }
    print qq^</fieldset>

<fieldset style="padding: 2">
<legend> :</legend>
<input type="text" value="$permalink" name="permalink" size="27" maxlength="256">
 
</fieldset>

<p class="c">
<button type=submit name="B1"><img src='/sp/img/ok.gif' width=16 height=16 align=absmiddle> </button>
</p><p class="c">
<button type=button onClick="redir('$cms?mod=news&edt=lst');"><img src='/sp/img/button_stop.gif' width=16 height=16 align=absmiddle> </button>
</p>
</form>

<div class=hr></div>
<p class="c"><button type=button onclick="if(confirm('   ?')){redir('?mod=news&edt=del&ni=$news_id');}"><img src='/sp/img/button_del.gif' width=16 height=16 align=absmiddle> </button></p>
<div class=hr></div>
<span class="bred">*</span>  

</td></tr></table>^;
}

sub NewsArc {
    my $keyY = param('arc') || 1;
    my %years = NewsArcYear();
    my ( $startY, $endY ) = split( /-/, $years{$keyY} );
    my $month = NewsArcMonth( $startY, $endY );
    my %monthes = NewsArcGetMonthes( $startY, $endY );
    my %cat = NewsArcCat( $startY, $endY, $month );
    my $htmldata = NewsArcMenu( \%years, \%monthes, \%cat );
    $htmldata .= NewsArcPrint($month);
    return $htmldata;
}

sub NewsArcCat {
    my ( $sY, $eY, $mon ) = @_;
    my $cat = param('cat') || '0';
    my ( $M, $Y ) = split /\./, $mon;
    my $sqlDate;
    $sqlDate = qq^startdate between '01.09.$sY' and '31.08.$eY'^
      if param('m') eq '0';
    $sqlDate = qq^cast(startdate as varchar(24)) like '$Y-$M-%'^
      if param('m') ne '0';
    my %ref_cat;
    my $q = sqlpcms(
        "select id_n,cat from news_cat where id_n in
                    ( select cat from news where owner = '$owner'
                    and $sqlDate ) and owner = '$owner'
                    "
    );
    my @b;
    while ( @b = $q->fetchrow_array() ) { $ref_cat{ $b[0] } = $b[1] }
    return %ref_cat;
}

sub NewsArcPrint {
    my $mon = $_[0];
    my $zapros;
    my $cat = param('cat') || '0';
    unless ( $mon =~ /^qqq/ ) {
        my ( $M, $Y ) = split /\./, $mon;
        my $sqlCat = '';
        $sqlCat = qq^and cat = '$cat'^ if $cat ne '0';
        $zapros = "select startdate, head, text, exttext, news_id, autor,
        (select count(1) FROM news_comment where news.news_id = news_comment.n_id and news.owner = news_comment.owner),
        (select cat from news_cat where news.cat = news_cat.id_n)
        from news where cast(startdate as varchar(24)) like '$Y-$M-%' $sqlCat and published = 1 and owner = $owner order by startdate";
    }
    else {
        my ( undef, $sY, $eY ) = split /\s/, $mon;
        my $sqlCat = '';
        $sqlCat = qq^and cat = '$cat'^ if $cat ne '0';
        $zapros = "select startdate, head, text, exttext, news_id, autor,
        (select count(1) FROM news_comment where news.news_id = news_comment.n_id and news.owner = news_comment.owner),
        (select cat from news_cat where news.cat = news_cat.id_n)
        from news where startdate between '01.09.$sY' and '31.08.$eY' $sqlCat and published = 1 and owner = $owner order by startdate";
    }
    my $tmpdata = NewsGetData( $zapros, "$theme_dir/$theme/news.html" );
    $tmpdata = "<p align='center'>    </p>"
      unless $tmpdata;
    return $tmpdata;
}

sub NewsArcMenu {
    my $ref_year = $_[0];
    my $ref_mon  = $_[1];
    my $ref_cat  = $_[2];
    my $p_arc    = param('arc');
    my $m        = param('m');
    my $cat      = param('cat') || 0;

    my $filter_html =
      qq^<div align=right style="background-color: #F2F2F2;margin-top: 0px;">
         : <select name="arc" onchange='top.location.href = this.options[this.selectedIndex].value'>^;
    foreach my $key ( sort { $a <=> $b } keys %$ref_year ) {
        my $selected = 'selected', if param('arc') eq $key;
        $filter_html .= qq^
            <option $selected value="$cms?mod=news&arc=$key&m=1&cat=0">$$ref_year{$key}</option>^
    }
    my $selected = 'selected' if $m eq '0';
    $filter_html .=
qq^</select> : <select name="m" onchange='top.location.href = this.options[this.selectedIndex].value'>
            <option $selected value="$cms?mod=news&arc=$p_arc&m=0&cat=$cat"></option>^;
    foreach my $key ( sort { $a <=> $b } keys %$ref_mon ) {
        my $selected = 'selected' if param('m') eq $key;
        $filter_html .= qq^
            <option $selected value="$cms?mod=news&arc=$p_arc&m=$key&cat=0">$$ref_mon{$key}</option>^
    }
    $filter_html .=
qq^</select> : <select name="cat" onchange='top.location.href = this.options[this.selectedIndex].value'>
            <option $selected value="$cms?mod=news&arc=$p_arc&m=$m&cat=0"> </option>^;
    foreach my $key ( sort { $a <=> $b } keys %$ref_cat ) {
        my $selected = 'selected' if param('cat') eq $key;
        $filter_html .= qq^
            <option $selected value="$cms?mod=news&arc=$p_arc&m=$m&cat=$key">$$ref_cat{$key}</option>^
    }
    $filter_html .= qq^</select></div>^;
    return $filter_html;
}

sub NewsArcGetMonthes {
    my $startY = $_[0];
    my $endY   = $_[1];
    my @a;
    my $attr = { ib_timestampformat => '%B %Y' };
    my @mon;
    my $q = sqlpcms(
        "select startdate from news
                    where owner = $owner and published=1
                    and startdate between '01.09.$startY' and '31.08.$endY'
                    order by startdate", $attr
    );
    while ( @a = $q->fetchrow_array() ) { push @mon, $a[0] }
    my %seen = ();
    @mon = grep { !$seen{$_}++ } @mon;
    my %monthes;
    my $n = 1;
    foreach my $item (@mon) { $monthes{$n} = $item, $n++ }
    return %monthes;
}

sub NewsArcMonth {
    my $startY = $_[0];
    my $endY   = $_[1];
    if ( param('m') ne '0' ) {
        my $keyM = param('m') - 1 || 0;
        my @a;
        my $attr = { ib_timestampformat => '%m.%Y' };
        my @mon;
        my $q = sqlpcms(
            "select startdate from news
                            where owner = $owner and published=1
                            and startdate between '01.09.$startY' and '31.08.$endY'
                            order by startdate", $attr
        );
        while ( @a = $q->fetchrow_array() ) { push @mon, $a[0] }
        my %seen = ();
        @mon = grep { !$seen{$_}++ } @mon;
        return $mon[$keyM];
    }
    else { return "qqq $startY $endY" }

}

sub NewsArcYear {
    my $attr = { ib_timestampformat => '%m.%Y' };
    my @a;
    my @years;
    my $q = sqlpcms(
"select startdate from news where owner = $owner and published = 1 order by startdate",
        $attr
    );
    while ( @a = $q->fetchrow_array() ) {
        my ( $y, $tm_month, @year );
        $a[0] =~ /^(\d+)\.(\d+)/;
        ( $tm_month, $y ) = ( $1, $2 );
        if ( $tm_month > 8 ) {
            $year[0] = $y;
            $year[1] = $y + 1;
            push( @years, "$year[0]-$year[1]" );
        }
        else {
            $year[0] = $y - 1;
            $year[1] = $y;
            push( @years, "$year[0]-$year[1]" );
        }
    }
    my %seen = ();
    @years = grep { !$seen{$_}++ } @years;
    my %years;
    my $n = 1;
    foreach my $item (@years) {
        $years{$n} = $item;
        $n++;
    }
    return %years;
}

sub administration {
    unless ( param('edt') ) { AdminList() }
    elsif ( param('edt') eq 'lst' and $owner eq '6' ) { AdminListEdt() }
    elsif ( param('edt') eq 'upl' and $owner eq '6' ) {
        my $path = UploadFile("$rootdirsp/tmp");
        PhotoOptim("$path");
        AdminListEdt();
    }
    elsif ( param('edt') eq 'del' and $owner eq '6' ) {
        my $uid = param('uid');
        AdminListDelPhoto($uid);
        AdminListEdt();
    }
}

sub AdminListEdt {
    my @adminUids = AdminListSql();
    my $in = join ',', @adminUids;
    my $BlockContent;
    my @a;
    my %photo_links = Users_Photos( \@adminUids );

    my $q = sqlp(
        "select
	h.last_name,
	h.first_name,
	h.middle_name,
	( select name from staff_unit_ref where staff_unit_id = t1.staff_unit ) as staff_name,
	h.human_id
from
  rik83pr_form1_template('$gdate') t1,
  human h
where
  rik83_unit_id in (26,27)
  and
  h.human_id = t1.human_id
order by
  t1.staff_unit,1,2,3"
    );

    my $n = 1;
    print qq^
    <h1>:  </h1>^;
    print qq^<table align="center" class=adminlist width="97%">
<tr>
	<th class="n"></th>
	<th></th>
	<th></th>
	<th> </th>
</tr>^;

    unless ( scalar @adminUids ) {
        print qq[<tr>
        <td align="center" colspan="4" style="padding: 1em">
             .
        </td>
        </tr>];
    }

    my $trclass;
    my $rows;
    while ( @a = $q->fetchrow_array() ) {
        $rows    = $n / 2;
        $trclass = 'row0';
        unless ( $rows =~ /^-?\d+\/?\d*$/ ) { $trclass = 'row1' }
        print qq^<tr class=$trclass><td align="right">$n.</td>
<td class="l">$a[0] $a[1] $a[2]</td>
<td class="c">$a[3]</td>
<td class="c">^;
        if ( $photo_links{ $a[4] } ) {
            print $photo_links{ $a[4] }, "<br>",
              AdminListUpForm( $n, $a[4], $photo_links{ $a[4] } ),
              AdminListMenu( $a[4] );
        }
        else { print AdminListUpForm( $n, $a[4] ) }
        $n++;
    }

    print qq^</table><div id="container"></div>
<script type="text/javascript">
function isNotEmpty(elem)
{
	var str = elem.value;
	var re = /.+\.jpg|.+\.jpeg/i;
	if (!str.match(re))
	{
		alert("     JPEG \(*.jpg, *.jpeg\)");
		setTimeout("focusElement('" + elem.form.name + "', '" + elem.name + "')", 0);
		return false;
	}
	else { return true; }
}

function focusElement (formName, elemName)
{
	var elem = document.forms[formName].elements[elemName];
	elem.focus();
	elem.select();
}

function validateForm(form)
{
	if (isNotEmpty(form.file)){
	return true; }
	else { return false; }
}
</script>
^;
}

sub AdminListUpForm {
    my $num   = $_[0];
    my $uid   = $_[1];
    my $texts = $_[2];

    my $text = "";
    $text = " " unless $texts;

    GetConfig('administration');
    my $returnData = qq^
<script type="text/javascript">
	YAHOO.namespace("example.container");
	function init() {
		YAHOO.example.container.panel$num = new YAHOO.widget.Panel("panel$num", { width:"400px", visible:false, constraintoviewport:true, modal:true, fixedcenter:true } );
		YAHOO.example.container.panel$num.setHeader("      ");
		YAHOO.example.container.panel$num.setBody('<p>     JPEG (*.jpg, *.jpeg).   web   <br>(  - $MOD_CONFIG{"administration_ph_width"} px).</p>            <form name="textForm" action=$cms enctype="multipart/form-data" method="post" onsubmit="return validateForm(this)">            <input type="hidden" name="mod" value="administration" />            <input type="hidden" name="edt" value="upl" />            <input type="hidden" name="id" value="$uid" />            <input type="file" name="file">&nbsp;<input type="submit" value=""></form>');
		YAHOO.example.container.panel$num.render("container");
		YAHOO.util.Event.addListener("show$num", "click", YAHOO.example.container.panel$num.show, YAHOO.example.container.panel$num, true);
	}
	YAHOO.util.Event.addListener(window, "load", init);
</script>
<a href=# id="show$num">$text</a>^;
    return $returnData;
}

sub AdminListMenu {
    my $uid        = $_[0];
    my $returnData = qq^
			<a href=$cms?mod=administration&edt=del&uid=$uid onClick="return confirm('     ?')"></a>
	^;
    return $returnData;
}

sub administrationConfig { }

sub AdminListSql {
    my @admin_uids;

    sqlffa(
        \@admin_uids,
        "select h.human_id
from sys_matrix sm,
     vw_tab_no vtn,
     human h,
     staff_unit_ref sur
where vtn.tab_no = sm.vw_tab_no
  and sm.overlap_type_ref = 0
  and h.human_id = vtn.human_id
  and sur.staff_unit_id = sm.staff_unit_ref
  and sm.view_class = 3100
  and sur.rik83_unit_id in (26,27)
  and exists(select 1 from get_node_saldo(sm.node_id, '$gdate', 0) where saldo_sum <> 0)
order by sur.staff_unit_id"
    );

    return @admin_uids;
}

sub AdminListDelPhoto {
    my $uid = $_[0];
    if ($uid) {
        my $dir = "$rootdirsp/cms/users_photos/teachers";
        opendir( DIR, "$dir" ) or die $!;
        my @file = grep { /--$uid\.jpg$/i } readdir(DIR);
        if ( -f "$dir/$file[0]" and $owner eq '6' ) { unlink "$dir/$file[0]" }
        else { error(" "); }
        close(DIR);
    }
}

sub AdminList {
    my @adminUids = AdminListSql();

    unless ( scalar @adminUids ) {
        return ("      .");
    }

    my $BlockContent;
    my @a;

    my $n = 1;

    my %photo_links = Users_Photos( \@adminUids );

    my $q = sqlp(
        qq|select
  t1.last_name,
  t1.first_name,
  t1.middle_name,
  (select name from staff_unit_ref where staff_unit_id = p1.staff_unit) as staff_unit_name,
  t1.birth_day,
  idecode(p1.edu_high_ended,1,cast('' as varchar(32)),
  idecode(p1.edu_middle_prof,1,cast(' ' as varchar(32)),
  idecode(p1.edu_middle_gen,1,cast(' ' as varchar(32)),'' ) ) )
	as education,
  idecode(p1.is_1st_cathegory,1,cast('' as varchar(32)),
  idecode(p1.is_2nd_cathegory,1,cast('' as varchar(32)),
  idecode(p1.is_3rd_cathegory,1,cast('' as varchar(32)),'' ) ) ) as
	cathegory,
/*
  idecode(p1.labour_betwen_1_3,1,cast('1-3 ' as varchar(32)),
  idecode(p1.labour_betwen_3_10,1,cast('3-10 ' as varchar(32)),
  idecode(p1.labour_betwen_10_20,1,cast('10-20 ' as varchar(32)),
  idecode(p1.labour_betwen_20_i,1,cast(' 20 ' as varchar(32)),'' ) ) ) )
	as labour,
*/
/*  dja version */
(SELECT sum(labour_years) from
(
  SELECT
  cast (
    ( iif (
      l.exit_date is null,
      cast('NOW' as date),
      l.exit_date
    ) - l.entry_date ) / 365.25
    as integer
  ) as labour_years
  FROM labour l
  WHERE l.human_id = p1.human_id
) as labour),
  (select wage_grade from worker_data where human_id = p1.human_id) as wage_grade,
  p1.human_id
from
  rik83pr_form1_template('$gdate') p1,
  human t1
where
  rik83_unit_id in (26,27)
  and
  p1.human_id = t1.human_id
order by
  p1.staff_unit,
  t1.last_name,
  t1.first_name,
  t1.middle_name|
    );

    my @tpl_data_cache = open_tpl("$theme_dir/$theme/administration_item.html");

    while ( @a = $q->fetchrow_array() ) {
        my %replace = (
            n          => $n . '.',
            photo_link => $photo_links{ $a[9] },
            fio        => "$a[0] $a[1] $a[2]",
            staffunit  => $a[3],
            education  => $a[5],
            cathegory  => $a[6],
            labour     => $a[7] . ' '
              . declension( $a[7], [ '', '', '' ] ),
            wage_grade => $a[8]
        );
        my @tpl_data = @tpl_data_cache;
        $BlockContent .= return_item( \%replace, \@tpl_data );
        $n++;
    }

    my %replace = ( items => $BlockContent );

    return return_block( \%replace, "$theme_dir/$theme/administration.html" );
}

sub Users_Photos {
    my $ref_array_uids = $_[0];

    my $force_author_photo = $_[1];

    my $uid = @$ref_array_uids[0];

    my $human_class =
      sqlff(qq[select class from human where human_id = @$ref_array_uids[0]]);

    my $dir;
    my $gid_dir;

    if ( $human_class == 0 or $human_class == 10 or $human_class == 2 ) {
        $dir     = "$rootdirsp/cms/users_photos/teachers";
        $gid_dir = 'teachers';
    }
    elsif ( $human_class == 1 ) {
        $dir     = "$rootdirsp/cms/users_photos/students";
        $gid_dir = 'students';
    }

    if ( param('mod') eq 'administration' ) {
        $dir     = "$rootdirsp/cms/users_photos/teachers";
        $gid_dir = 'teachers';
    }

    unless ( -d "$dir" ) {
        mkdir "$rootdirsp/cms/users_photos";
        mkdir "$dir";
    }

    opendir( DIR, "$dir" ) or die "$! - $dir -";

    my %uid_link;
    my @photos_files;

    if ( param('mod') eq 'administration' and !$force_author_photo ) {
        @photos_files = grep { /--\d+\.jpg$/i } readdir(DIR);
    }
    else {
        @photos_files = grep { /--av\d+\.jpg$/i } readdir(DIR);
    }

    chomp @photos_files;

    foreach my $uid (@$ref_array_uids) {
        if ( grep( /.*--\D*$uid\.jpg$/i, @photos_files ) ) {
            my @fil = grep /^.*--\D*$uid\.jpg$/i, @photos_files;
            $uid_link{$uid} =
qq[<img class="user-photo" src="$sp_url/users_photos/$gid_dir/$fil[0]">];
        }
        else {

            $uid_link{$uid} =
              qq^<img src="/sp/cms/themes/sp-default/images/no-photo.png"/>^;

        }
    }

    close(DIR);
    return %uid_link;
}

sub PhotoOptim {
    my $file  = $_[0];
    my $uid   = param('id');
    my $login = sqlff("select log from sp_users where uid = '$uid'");
    $file =~ s|(^.*/)||;
    my $path    = $1;
    my $newfile = $login . '--' . $uid . '.jpg';
    my $dir     = "$rootdirsp/cms/users_photos/teachers";
    opendir( DIR, "$dir" ) or die $!;
    my @photos_files = grep { /--$uid\.jpg$/i } readdir(DIR);
    chomp @photos_files;
    foreach (@photos_files) { unlink "$dir/$_" }
    my $nnn = int( rand(999) );
    $newfile = $nnn . '_' . $newfile;
    unlink "$path/$file" if copy( "$path/$file", "$dir/$newfile" ) or die $!;
    GetConfig('administration');
    my $image = Image::Magick->new;
    my ( $old_width, $old_height, undef, $format ) =
      $image->Ping("$rootdirsp/cms/users_photos/teachers/$newfile")
      if -f "$rootdirsp/cms/users_photos/teachers/$newfile"
          or stop(' ');
    my $new_width  = $MOD_CONFIG{'administration_ph_width'};
    my $new_height = ( $new_width * $old_height ) / $old_width;
    ImgResize( $new_width, $new_height,
        "$rootdirsp/cms/users_photos/teachers/$newfile" );
}

sub User_site {
    my $login = $_[0];
    my @site;
    if ( $login =~ /^\d+$/ ) {
        unless ( grep /^$login$/, @modules ) {
            @site = sqlf(
                "select log, uid from sp_users where sp_users.uid = '$login'");
        }
    }
    else {
        unless ( grep /^\Q$login\E$/, @modules ) {
            $login = substr( $login, 0, 63 );
            $login ||= '';
            @site =
              sqlfb( "select log, uid from sp_users where sp_users.log = ?",
                $login );
        }
    }

    return ( $site[0], $site[1] );
}

sub ModulesPrintConf {
    my $mod_id = param('id');
    sec_gteq0($mod_id);
    my $filtr = param('fltm');
    my $zapros =
"select modules.visible_name, modules.modulename from modules, modules_cnf_users
			where modules_cnf_users.i_id = '$mod_id'
			and modules.i_id = modules_cnf_users.mod_id and modules_cnf_users.owner = '$owner'";
    my $q = $gdbcms->prepare($zapros) or db_error();
    $q->execute() or db_error();
    my @a;
    my ( $mod_vname, $mod_name );

    while ( @a = $q->fetchrow_array() ) {
        $mod_vname = $a[0];
        $mod_name  = $a[1];
    }
    @a = ();
    @a = sqlfcms(
"select mod_id, show_on, m_config from modules_cnf_users where i_id = '$mod_id' and owner = '$owner'"
    );
    my ( $sho_fp, $sho_ap, $sho_mp );
    if    ( $a[1] =~ /,FirstPage,/ ) { $sho_fp = "checked" }
    elsif ( $a[1] =~ /,AllPage,/ )   { $sho_ap = "checked" }
    else                             { $sho_mp = "checked" }
    print qq^
<h1>:   &quot;$mod_vname&quot;</h1>
<form name="dataentry" method="POST" action="$cms" enctype="multipart/form-data">
<input type="hidden" name="mod" value="modules" >
<input type="hidden" name="i_id" value="$mod_id" >
<input type="hidden" name="edt" value="so" >
<table width="100%" class=adminform>
<tr>
<td valign="top">
<fieldset style="padding: 2">
<legend>  :</legend>
<input type="radio" name="show_on" $sho_fp value="FP" >   <br>
<input type="radio" name="show_on" $sho_ap value="AP">  <br>
<input type="radio" name="show_on" $sho_mp value="MP">      <br>
</fieldset>^;

    if ( $owner eq '6' ) {
        my $zapros = "select access from modules,modules_cnf_users
				where modules_cnf_users.i_id = '$mod_id' and modules.i_id = modules_cnf_users.mod_id";
        my $q = $gdbcms->prepare($zapros) or db_error();
        $q->execute() or db_error();
        my @a;
        my ( $g2, $g4 );
        while ( @a = $q->fetchrow_array() ) {
            if ( $a[0] =~ /,2,/ ) { $g2 = "checked" }
            if ( $a[0] =~ /,4,/ ) { $g4 = "checked" }
        }
        print qq^
		<fieldset style="padding: 2">
		<legend>      
		:</legend>
		<input type="checkbox" name="g2" $g2 value="ON"> <br>
		<input type="checkbox" name="g4" $g4 value="ON"> </fieldset>&nbsp;</td>^;
    }
    if (
        sqlffcms(
            "select m_config from modules_cnf_users where i_id = '$mod_id'") ne
        ''
      )
    {
        my %tmpHash;
        $tmpHash{mod} = $mod_name . 'Config';
        no strict 'refs';
        my $SelfConf = $tmpHash{'mod'}();
        print qq^<td valign="top" >$SelfConf</td>^;
    }

    print qq^<input type=hidden name="fltm" value="$filtr"></tr></table>
<p align="center"><input type="submit" value="" name="B1" >&nbsp;&nbsp;&nbsp;
<input type="button" value="" name="B2" OnClick=document.location.href="$cms?mod=modules&edt=lst&fltm=$filtr"></p>
</form>^;

}

sub bdayinf {
    GetConfig('bdayinf');
    my ( $bd_day, $bd_mon ) =
      ( substr( $gdate, 0, 2 ), substr( $gdate, 3, 2 ) );
    my ( @result, %p_names, $res_p, $res_t );
    my @tpl_data_cache = open_tpl("$theme_dir/$theme/bdayinfitem.html");
    my ( @tpl_data, %replace, $BlockContent );
    if (
        (
            $MOD_CONFIG{'data_source'} eq 'xxibase'
            or !$MOD_CONFIG{'data_source'}
        )
        and !$gconf{'light'}
      )
    {
        my $q = sqlp(
            qq[
					select distinct
						last_name || ' ' || first_name || ' ' || middle_name, human_id
					from
						human, sys_matrix
					where
						human_id = vw_teacher
						and
                        GetDateField(birth_day, 1) = $bd_day
                        and
						GetDateField(birth_day, 2) = $bd_mon
						and
						exists
						(
							select 1
							from get_node_saldo (sys_matrix.node_id, '$gdate', 0)
							where saldo_sum <> 0
						)
					]
        );
        my @result_t;
        my %t_names;
        while ( @result_t = $q->fetchrow_array() ) {
            $t_names{ $result_t[1] } = $result_t[0];
            $res_t = @result_t;
        }
        $q->finish();
        my $row;
        my $key;
        if ($res_t) {
            $BlockContent =
              "<div class=bday_header></div><ul class=bday>";
            foreach $key ( keys %t_names ) {
                @tpl_data = @tpl_data_cache;
                %replace = ( bdayitem => "$t_names{$key}" );
                $BlockContent .= return_item( \%replace, \@tpl_data );
            }
            $BlockContent .= "</ul>";
        }
        $q = sqlp(
            qq[
       select
       	last_name||' '||first_name,human_id
		from human, sys_matrix
		where human_id = vw_pupil and
		view_class = 1 and
		GetDateField(birth_day, 1) = $bd_day and
		GetDateField(birth_day, 2) = $bd_mon and
		exists ( select 1 from get_node_saldo (sys_matrix.node_id, '$gdate', 0) where saldo_sum <> 0 )
		]
        );

        while ( @result = $q->fetchrow_array() ) {
            $p_names{ $result[1] } = $result[0];
            $res_p = @result;
        }
        $q->finish();
        if ($res_p) {
            $BlockContent .=
              "<div class=bday_header></div><ul class=bday>"
              unless $mdou;
            $BlockContent .=
              "<div class=bday_header>:</div><ul class=bday>"
              if $mdou;
            foreach $key ( sort { $p_names{$a} cmp $p_names{$b} }
                keys %p_names )
            {
                @tpl_data = @tpl_data_cache;
                %replace =
                  (     bdayitem => "$p_names{$key} ("
                      . get_pupil_class( 1, $key )
                      . ")" );
                $BlockContent .= return_item( \%replace, \@tpl_data );
            }
            $BlockContent .= "</ul>";
        }
        elsif ($mdou) {
            my $attr = { ib_timestampformat => '%d.%m' };
            my %datebirth;
            my $q = sqlp(
                qq[select last_name||' '||first_name,human_id,birth_day
							from human, sys_matrix
							where human_id = vw_pupil and
							view_class = 1 and
							GetDateField(birth_day, 2) = $bd_mon and
							exists ( select 1 from get_node_saldo (sys_matrix.node_id, '$gdate', 0) where saldo_sum <> 0 )],
                $attr
            );
            while ( @result = $q->fetchrow_array() ) {
                $p_names{ $result[1] }   = $result[0];
                $datebirth{ $result[1] } = $result[2];
                $res_p                   = @result;
            }
            if ($res_p) {
                my $row;
                my $key;
                $BlockContent .=
"<div class=bday_header> :</div><ul class=bday>";
                foreach $key ( keys %p_names ) {
                    @tpl_data = @tpl_data_cache;
                    %replace =
                      (     bdayitem => "$datebirth{$key} $p_names{$key} ("
                          . get_pupil_class( 1, $key )
                          . ")" );
                    $BlockContent .= return_item( \%replace, \@tpl_data );
                }
                $BlockContent .= "</ul>";
            }
        }
    }
    elsif ( $MOD_CONFIG{'data_source'} eq 'csv' or $gconf{'light'} ) {
        my $csv_file = $rootdirsp . '/cms/data_csv_from_asu_rso.csv';
        open( CSV, '<', $csv_file ) or die "   $csv_file: $!";
        my @lines = <CSV>;
        close(CSV);
        $bd_day =~ s/^0//;
        my @bd_names = grep /\;$bd_day\.$bd_mon\./, @lines;
        $res_p = @bd_names;
        my ( $name, $bday, $class );

        if ($res_p) {
            $BlockContent .=
              "<div class=bday_header></div><ul class=bday>";
            foreach my $line (@bd_names) {
                my ( $name, $bday, $class ) = split /;/, $line;
                if ( $name and $bday and $class ) {
                    $res_p = '1';
                    $class =~ s/\s*$//;
                    $name  =~ s/^(\S+\s\S+)\s\S*/$1/;
                    @tpl_data = @tpl_data_cache;
                    %replace = ( bdayitem => "$name ($class)" );
                    $BlockContent .= return_item( \%replace, \@tpl_data );
                }
            }
            $BlockContent .= "</ul>";
        }
    }

    %replace = ( bdayitems => "$BlockContent" );
    $BlockContent =
      return_block( \%replace, "$theme_dir/$theme/bdayinfblock.html" );
    if ( $MOD_CONFIG{'bd_show'} eq 'checked' and !$res_p and !$res_t ) {
        return '';
    }
    else { return $BlockContent }
}

sub bdayinfCsvReMaster {
    my $csv_file = $_[0];
    my $csv_new  = $rootdirsp . '/cms/data_csv_from_asu_rso.csv';
    open( CSV, "<$csv_file" ) or die "   $csv_file: $!";

    my @lines;
    {
        my $size = -s $csv_file;
        my $full_csv_file;
        unless ( $size == read( CSV, $full_csv_file, $size ) ) {
            stop("  .CSV-.");
        }
        $full_csv_file =~ s/([^\x0D])\x0A/$1/go;
        @lines = split( /\x0d\x0a/, $full_csv_file );
    }

    close(CSV);
    open( CSV, ">$csv_new" ) or die "   $csv_new: $!";
    foreach my $line (@lines) {
        my ( undef, $name, $bday, undef, $class ) = split /;/, $line;
        if ( $name and $bday and $class ) {
            print CSV "$name;$bday;$class\n";
        }
    }
    close(CSV);
    unlink $csv_file;
}

sub bdayinfConfig {
    GetConfig('bdayinf');
    if ( param('edt') ne 'so' ) { return bdayinfConfigList() }
    elsif ( param('edt') eq 'so' ) {
        my ($show);
        my $mod_id = param('i_id');
        my $data_from;
        if ( param('bd_show') eq 'ON' ) { $show = 'checked' }
        if (   param('data_source') eq 'csv'
            or param('data_source') eq 'xxibase' )
        {
            $data_from = param('data_source') if $owner eq '6';
        }
        if (    param('data_source') eq 'csv'
            and param('file') =~ /\.csv$/i
            and $owner eq '6' )
        {
            my $csvFile = UploadFile("$rootdirsp/cms");
            bdayinfCsvReMaster("$csvFile");
        }
        if ( !-f $rootdirsp . '/cms/data_csv_from_asu_rso.csv'
            and $data_from eq 'csv' )
        {
            $data_from = 'xxibase';
        }
        sqlcms(
qq^update modules_cnf_users set m_config = ',bd_show=$show,data_source=$data_from' where i_id = '$mod_id' and owner = '$owner'^
        );
    }
}

sub bdayinfConfigList {
    GetConfig('bdayinf');
    my $sho_csv;
    my $sho_local;
    my $InUseCSVText = '';
    my $timeLastModifed;
    if ( $MOD_CONFIG{'data_source'} eq 'csv' ) {
        $sho_local = '';
        $sho_csv   = 'checked';
    }
    elsif ( $MOD_CONFIG{'data_source'} eq 'xxibase' ) {
        $sho_local = 'checked';
        $sho_csv   = '';
    }
    my $csvFile = $rootdirsp . '/cms/data_csv_from_asu_rso.csv';
    if ( -f $csvFile and $sho_csv eq 'checked' ) {
        $timeLastModifed = stat($csvFile)->mtime;
        $timeLastModifed =
          strftime( "%d %B %Y %H:%M", localtime($timeLastModifed) );
        $timeLastModifed =~ s/, 0/, /;
        $timeLastModifed = MonthYa($timeLastModifed);
        $InUseCSVText = qq^<p>  *.csv  $timeLastModifed</p>^;
    }
    my $return_data = qq^
            <input type="checkbox" name="bd_show" $MOD_CONFIG{'bd_show'} value="ON">   ,   <br>
        ^;
    if ( $owner eq '6' ) {
        $return_data .= qq^<fieldset style="padding: 2">
<legend> :</legend>
<input type="radio" name="data_source" $sho_local value="xxibase">   <br>
<input type="radio" name="data_source" $sho_csv value="csv"> *.csv  (  , Net)<br>
$InUseCSVText
<input type="file" name="file">
</fieldset> ^;
    }
    return "$return_data";
}

sub lastcontent {
    if ( !defined param('edt') ) {
        GetConfig('lastcontent');
        my %id2ou = MouShortNameForCS() if $CS;
        my %id2ouShort;
        %id2ouShort = MouShortNameForCS('short') if $CS;
        my $q;
        my $sqlDays;
        my $el;
        if ( $MOD_CONFIG{'lc_num_days'} ) {
            $el      = 'and ';
            $sqlDays = "startdate>current_date-$MOD_CONFIG{'lc_num_days'}";
        }
        $q = sqlpcms(
"select pub_date, sh_id, header, link from cs_last_content $sqlDays order by i_id DESC"
        ) if ($CS);
        $q = sqlpcms(
            "select startdate, autor, head, c_id from content
										where owner = $owner and published = 1 and c_type = 1 $el $sqlDays
										order by startdate DESC"
        ) if ( !$CS );
        my @tpl_data_cache = open_tpl("$theme_dir/$theme/lastcontentitem.html");
        my @tpl_data;
        my $BlockContent;
        my @a;
        my %replace;
        my $i = 0;
         while ($i < $MOD_CONFIG{'lc_num_on_page'}
            and @a = $q->fetchrow_array() )
        {
            my $itemtitle;
            my $autorr = GetNameByUid( $a[1] ) if !$CS;
            $itemtitle =
qq^ :   $id2ouShort{$a[1]} \n :   $a[0] \n :   $a[2]^
              if $CS;
            $itemtitle =
              qq^ :  $autorr  \n :   $a[0] \n :   $a[2]^
              if !$CS;
            if ( length( $a[2] ) > $MOD_CONFIG{'lc_header_length'} ) {
                substr(
                    $a[2],
                    $MOD_CONFIG{'lc_header_length'},
                    length( $a[2] ) - $MOD_CONFIG{'lc_header_length'}
                ) = '...';
            }
            $a[3] = "$cms?mod=content&rc=$a[3]" if !$CS;
            %replace = (
                date     => $a[0],
                menuitem => $a[2],
                link     => $a[3],
                title    => $itemtitle
            );
            $replace{'menuitem'} =
              '<i>' . $id2ou{ $a[1] } . '</i>' . ' - ' . $a[2]
              if ($CS);
            $i++;
            @tpl_data = @tpl_data_cache;
            tpl_replace_ant( \%replace, \@tpl_data );
            my $htmlline;
            foreach $htmlline (@tpl_data) { $BlockContent .= $htmlline }
        }
        $q->finish();

        $BlockContent =
          qq[<div class="lastcontent-articles"></div>$BlockContent]
          if $BlockContent;

        my $glc_filename = $gconf{'sppath'} . '/tmp/gallery-lastcontent';
        if ( -e $glc_filename ) {
            my $converter =
              Text::Iconv->new( get_server_encoding(), "windows-1251" );

            my @glc_files;
            open GLC, '<', $glc_filename
              or error(
"    :<br>$glc_filename<br> :<br>$!"
              );
            while (<GLC>) {
                chop;
                push( @glc_files, $_ ) unless m|/var/www/html/sp/pic/gallery$|;
            }
            close GLC;

            @glc_files = reverse sort @glc_files;
            @glc_files = splice( @glc_files, 0, 5 );

            foreach (@glc_files) {
                s/[^\/]+\//\//;
                s/\Q$gconf{'sppath'}\E\/pic\/gallery\///;
            }

            if (@glc_files) {
                $BlockContent .=
                  qq[<div class="lastcontent-gallery"></div>];
                for (@glc_files) {
                    my $link = $_;
                    $link =~ s/\//*/g;
                    $link = uri_escape($link);

                    my $text = $_;
                    $text =~ s|.*\/([^\/]+)$|$1|;
                    $text = $converter->convert($text);

                    my $title = $_;
                    $title = $converter->convert($title);

                    my %replace = (
                        date     => '-',
                        menuitem => $text,
                        link     => "$cms?mod=gallery&folder=$link",
                        title    => qq[ "$title"]
                    );

                    @tpl_data = @tpl_data_cache;
                    tpl_replace_ant( \%replace, \@tpl_data );
                    $BlockContent .= join '', @tpl_data;
                    $i++;
                }
            }
        }

        %replace = ( menuitems => "$BlockContent" );
        @tpl_data = open_tpl("$theme_dir/$theme/lastcontentblock.html");
        tpl_replace_ant( \%replace, \@tpl_data );
        $BlockContent = '';
        foreach my $htmlline (@tpl_data) { $BlockContent .= $htmlline; }

        if ( $MOD_CONFIG{'lc_show'} eq 'checked' and !$i ) { return ''; }
        else { return $BlockContent; }
    }
}

sub lastcontentConfig {
    GetConfig('lastcontent');
    if ( param('edt') ne 'so' ) {
        my $return_data = qq^
    :
<input type="text" align="center" name="lc_num_on_page" value=$MOD_CONFIG{'lc_num_on_page'} size="2"><br>
    :
<input type="text" align="center" name="lc_header_length" value=$MOD_CONFIG{'lc_header_length'} size="3"><br>
        (0 - ):
<input type="text" align="center" name="lc_num_days" value=$MOD_CONFIG{'lc_num_days'} size="2"><br>
<input type="checkbox" name="lc_show" $MOD_CONFIG{'lc_show'} value="ON">   ,   <br>
^;
        return "$return_data";
    }
    else {
        my ( $nop, $hl, $nd, $show );
        my $mod_id = param('i_id');
        if ( param('lc_num_on_page') =~ /^\d+$/ ) {
            $nop = param('lc_num_on_page');
        }
        else { $nop = $MOD_CONFIG{'lc_num_on_page'} }
        if ( param('lc_header_length') =~ /^\d+$/ ) {
            $hl = param('lc_header_length');
        }
        else { $hl = $MOD_CONFIG{'lc_header_length'} }
        if ( param('lc_num_days') =~ /^\d+$/ ) { $nd = param('lc_num_days') }
        else { $nd = $MOD_CONFIG{'lc_num_days'} }
        if ( param('lc_show') eq 'ON' ) { $show = 'checked' }
        sqlcms(
qq^update modules_cnf_users set m_config = ',lc_num_on_page=$nop,lc_header_length=$hl,lc_num_days=$nd,lc_show=$show,' where i_id = '$mod_id' and owner = '$owner'^
        );
    }
}

sub LastContentAdd2CS {
    my $i_id   = $_[0];
    my $sh_id  = SchoolID();
    my @header = sqlfcms(
        "select head, c_type from content where c_id = $i_id and owner = 6");
    my %type_c = ( '0' => 'ls', '1' => 'rc' );
    my $link =
        'http://'
      . "$ENV{'HTTP_HOST'}"
      . "$cms?mod=content&$type_c{$header[1]}=" . "$i_id";
    sqlCS(
"INSERT INTO cs_last_content (pub_date, sh_id, header, link) VALUES ('NOW','$sh_id','$header[0]', '$link')"
    );
    return sqlffCS(
"select i_id from cs_last_content where header = '$header[0]' and sh_id = '$sh_id'"
    );
}

sub MouShortNameForCS {
    my ( @a, %id2ou );
    if ( !$_[0] ) {
        my $q = sqlpcms("select OU_NAME_FULL,OU_ID from CS_OU_NAMES");
        while ( @a = $q->fetchrow_array() ) {
            if ( $a[0] =~ // ) {
                $a[0] =~ s/\D*//gi;
                $id2ou{ $a[1] } = ' ' . $a[0];
            }
            elsif ( $a[0] =~ // ) {
                $a[0] =~ s/\D*//gi;
                $id2ou{ $a[1] } = ' ' . $a[0];
            }
            elsif ( $a[0] =~ // ) {
                $a[0] =~ s/\D*//gi;
                $id2ou{ $a[1] } = ' ' . $a[0];
            }
            elsif ( $a[0] =~ // ) {
                $a[0] =~ s/\D*//gi;
                $id2ou{ $a[1] } = ' ' . $a[0];
            }
            elsif ( $a[0] =~ // ) {
                $a[0] =~ s/\D*//gi;
                $id2ou{ $a[1] } = ' ' . $a[0];
            }
        }
        $q->finish();
    }
    elsif ( $_[0] eq 'short' ) {
        my $q = sqlpcms("select OU_NAME_SHORT,OU_ID from CS_OU_NAMES");
        while ( @a = $q->fetchrow_array() ) {
            $id2ou{ $a[1] } = $a[0];
        }
        $q->finish();
    }
    return %id2ou;
}

sub mainmenu {

    if ( !defined param('edt') ) {

        if (
            sqlffcms(
"select first 1 1 from mainmenu where i_level > 1 and published = 1 and owner = $owner"
            )
          )
        {

            my $items;
            my $q = sqlpcms(
"select i_id, i_parent, i_name, i_link from mainmenu where published = 1 and owner = $owner order by i_sort"
            );

            my $js_menu .= qq[<script type="text/javascript">];
            $js_menu .= qq[var sp_menu = new TMainMenu('sp_menu','vertical');];

            my @a;

            my %created_id;

            while ( @a = $q->fetchrow_array ) {
                $a[2] =~ s/"/\\"/g;
                if ( $a[1] == 0 ) {
                    $js_menu .=
qq[var sp_menu_$a[0] = new TPopMenu("$a[2]",'0','a',"$a[3]",'');\n];
                    $js_menu .= qq[sp_menu.Add(sp_menu_$a[0]);\n];
                    $created_id{ $a[0] }++;
                }
                else {
                    if ( $created_id{ $a[1] } ) {
                        $js_menu .=
qq[var sp_menu_$a[0] = new TPopMenu("$a[2]",'0','a',"$a[3]",'');\n];
                        $js_menu .= qq[sp_menu_$a[1].Add(sp_menu_$a[0]);\n];
                        $created_id{ $a[0] }++;
                    }
                }
            }

            if ( -f "$theme_dir/$theme/menu-settings.js" ) {
                open F, "<$theme_dir/$theme/menu-settings.js";
                my @js = <F>;
                close F;
                $js_menu .= join '', @js;
                $js_menu .= "\n";
            }

            $js_menu .= qq[
sp_menu.SetExpandIcon(true,'','6');
sp_menu.Build();
</script>
];

            my @mainmenublock =
              open_tpl("$theme_dir/$theme/mainmenublock.html");
            tpl_replace_ant( { menuitems => $js_menu }, \@mainmenublock );

            my $html;
            foreach (@mainmenublock) { $html .= $_; }
            return $html;

        }
        else {
            my ( @a, %replace, @tpl_data, $BlockContent );

            my $q = sqlpcms(
                "SELECT i_name, i_link, i_level, i_id FROM mainmenu
									 WHERE published = 1 and owner = $owner	and i_parent = 0 order by i_sort"
            );
            my @tpl_data_cache = open_tpl("$theme_dir/$theme/mainmenu.html");

            while ( @a = $q->fetchrow_array() ) {
                %replace = (
                    menuitem    => $a[0],
                    link        => $a[1],
                    level       => $a[2] - 1,
                    link_action => ''
                );

                @tpl_data = @tpl_data_cache;
                tpl_replace_ant( \%replace, \@tpl_data );
                foreach my $htmlline (@tpl_data) {
                    $BlockContent .= $htmlline;
                }
            }

            %replace = ( menuitems => "$BlockContent" );
            @tpl_data = open_tpl("$theme_dir/$theme/mainmenublock.html");
            tpl_replace_ant( \%replace, \@tpl_data );
            $BlockContent = '';
            foreach my $htmlline (@tpl_data) { $BlockContent .= $htmlline; }
            return $BlockContent;

        }

    }

    elsif ( defined param('edt') ) {
        MMenuEdit();
    }
}

sub level_down(@) {
    my @children;
    for (@_) {
        sqlcms(
"update mainmenu set i_level = i_level - 1 where i_id = $_ and owner = $owner"
        );
        sqlffacms( \@children,
            "select i_id from mainmenu where i_parent = $_ and owner = $owner"
        );
    }
    if (@children) {
        level_down(@children);
    }
}

sub recurse_MMenuScanLevel {
    my $arr_ref     = shift;
    my $find_parent = shift;
    my $level       = shift || 1;

    for ( @{$arr_ref} ) {
        if ( $$_[1] == $find_parent ) {
            if ( $$_[0] != 0 ) {
                return recurse_MMenuScanLevel( $arr_ref, $$_[0], ++$level );
            }
            else {
                return $level + 1;
            }
        }
    }
}

sub MMenuEdit {
    if ( param('edt') eq 'lst' ) {
        MMenuPrintList();
    }

    elsif ( param('edt') eq 'ajax_pub' ) {
        my $id = param('mi');
        sec_gteq0($id);
        sqlcms(
"update mainmenu set published = iif(published=0,1,0) where i_id = $id"
        );
        aj_print('ok');
    }

    elsif ( param('edt') eq 'ajax_rename' ) {
        my $id = param('mi');
        use Text::Iconv;
        my $converter = Text::Iconv->new( "utf-8", "windows-1251" );
        my $name = trim( $converter->convert( param('name') ) );
        $name =~ s/\xA0//g;
           if ( length($name) > 100 ) {
            substr( $name, 97, length($name) - 97 ) = '...';
        }
        strip_tag( \$name, 'clear' );
        sqlbcms( "update mainmenu set i_name=? where i_id=?", $name, $id );
        aj_print('ok');
    }

    elsif ( param('edt') eq 'ajax_delete' ) {
        print
"X-Powered-By: School Portal - www.spcms.ru\nContent-type: text/html;\n\n";

        $g_http_headers_sent = 1;

        if ( param('id') ) {
            my $i_id = param('id');
            sec_gteq0($i_id);
            sqlcms(
                "delete from mainmenu where i_id = $i_id and owner = $owner");
            my @children;
            sqlffacms( \@children,
"select i_id from mainmenu where i_parent = $i_id and owner = $owner"
            );
            if (@children) { level_down(@children); }
            exit print "ok";
        }
        else {
            exit print "error";
        }
    }

    elsif ( param('edt') eq 'create_folder' ) {
        my $i_name = utf8_to_win( param('name') );
        if ( length($i_name) > 100 ) {
            substr( $i_name, 97, length($i_name) - 97 ) = '...';
        }
        strip_tag( \$i_name, 'clear' );
        sqlbcms(
            "insert into mainmenu (i_name, i_link, owner, i_level)
								values (?, '', ?, 1)",
            $i_name, $owner
        );

        MMenuPrintList();

    }

    elsif ( param('edt') eq 'add_custom_link' ) {
        my $name = trim( param('name') );
        escape_tag( \$name );
        $name = substr( $name, 0, 100 );
        my $url = trim( param('url') );
        escape_tag( \$url );
        $url = substr( $url, 0, 300 );

        if ( $name eq '' or $url eq '' ) {
            stop("     .");
        }

        sqlbcms(
            "insert into mainmenu
				(i_name, i_link, i_parent, i_level, i_sort, published, owner)
				values (?, ?, 0, 1, 0, 1, $owner)",
            $name, $url
        );

        MMenuPrintList();
    }

    elsif ( param('edt') eq 'arr2' ) {
        my $xml_data = param('xml_data');
        my @tmp;
        my $counter = 0;
        my $level;
        while ( $xml_data =~
m/<item\s+id="sp_menu_item_(\d+)"[^>]+parent_id="(sp_menu_item_)?(\d+)"/ig
          )
        {
            my ( $_item_id, $_parent_id ) = ( $1, $3 );
            $counter++;
            $level =
              ( int($_parent_id) == 0 )
              ? 1
              : recurse_MMenuScanLevel( \@tmp, int($_parent_id) );
            push @tmp, [ int($_parent_id), int($_item_id) ];
            sqlcms(
qq[update mainmenu set i_sort = $counter, i_parent = $_parent_id, i_level = $level where i_id = $_item_id and owner = $owner]
            );

        }

        MMenuPrintList();
    }

    elsif ( param('edt') eq 'add' ) {
        my $i_name = param('mhead');
        my $i_link = param('murl');

        if ( length($i_name) > 100 ) {
            substr( $i_name, 97, length($i_name) - 97 ) = '...';
        }

        strip_tag( \$i_name, 'clear' );

        $i_link =~ s/</&lt;/go;
        $i_link =~ s/>/&gt;/go;
        $i_link =~ s/'/&ldquo;/go;
        $i_link =~ s/"/&quot;/go;

        sqlbcms(
"insert into mainmenu (i_name, i_link, owner, i_level) values (?,?,?,?)",
            $i_name, $i_link, $owner, 1
        );

        MMenuPrintList();
    }

}

sub MMenuPrintList {
    my @a;
    my @tmp;
    my $q;

    $q = sqlpcms(
        "select i_name, i_level, i_link from mainmenu
where published = 1 and owner = $owner order by I_SORT"
    );
    while ( @tmp = $q->fetchrow_array() ) {
        push @a, [@tmp];
    }

    my $abuse = '';
    {
        unless ( scalar @a ) {
            $abuse .=
"<br><br>   .<br>   ,      .<br>   , <a href=\"$cms?mod=modules&edt=lst\"> </a>.";
        }

        elsif ( scalar @a == 1 and $a[0][2] eq "" ) {
            $abuse .= "<br><br>       .";
        }
        else {
            my $level_old = $a[0][1];
            my $link_old  = $a[0][2];
            for ( my $i = 0 ; $i < @a ; $i++ ) {
                if ( $i < scalar(@a) - 1 ) {
                    if (
                        (
                               $a[$i][1] > $a[ $i + 1 ][1]
                            or $a[$i][1] == $a[ $i + 1 ][1]
                        )
                        and $a[$i][2] eq ""
                      )
                    {
                        $abuse .=
qq[<br><br>&laquo;<font color="#264baf"><b>$a[$i][0]</b></font>&raquo; &mdash;<br> ];
                    }
                    if (    $a[$i][1] < $a[ $i + 1 ][1]
                        and $a[$i][2]
                        and $a[ $i + 1 ][2] )
                    {
                        $abuse .=
"<br><br>&laquo;<b>$a[$i][0]</b>&raquo; &mdash;<br>   ,    .     ,    .";
                    }
                }
                $level_old = $a[$i][1];
            }

            if ( $a[$#a][2] eq "" ) {
                $abuse .=
qq[<br><br>&laquo;<font color="#264baf"><b>$a[$#a][0]</font></b>&raquo; &mdash;<br> ];
            }

        }

        if ($abuse) {
            $abuse =
qq[<br><div class="abuse"><span class="bred">    .<br>   ,      .</span>$abuse<div style="margin-top:4px"><button onclick="redir('$cms?mod=mainmenu&edt=lst')"></button></div></div>];
        }

    }

    @a = ();

    my $component;

    $gdbcms->{"AutoCommit"} = 0;
    $q = sqlpcms(
        "select i_id, i_name, published, i_link from mainmenu
    where owner = $owner and i_level = 1 order by i_sort"
    );
    my $menu = '';
    while ( @a = $q->fetchrow_array() ) {
        my $class   = $a[3] ? 'default' : 'folder';
        my $checked = $a[2] ? 'checked' : '';

        my ( $title, $class ) = MMenuPrintList_get_title_and_class( $a[3] );

        $menu .=
qq{<li $title rel="$class" class="$class" id="sp_menu_item_$a[0]"><input $checked type=checkbox onclick="pub($a[0])" title=""><a>$a[1]</a>};
        $menu .= recurse_MMenuPrintList( $a[0] );
        $menu .= qq{</li>\n};
    }
    $gdbcms->{"AutoCommit"} = 1;

    print tpl_str(
        'tpl/MMenuPrintList.html',
        {
            abuse     => $abuse,
            menu      => $menu,
            cms       => $cms,
            panel_top => ( exists $ACL{'6'} ) ? '100px' : '77px',
        }
    );

}

sub recurse_MMenuPrintList($) {
    my $q = sqlpcms(
        "select i_id, i_name, published, i_link from mainmenu
					where owner = $owner and i_parent = $_[0] order by i_sort"
    );
    my @a;
    my $t = '';
    while ( @a = $q->fetchrow_array() ) {
        my $checked = $a[2] ? 'checked' : '';
        my ( $title, $class ) = MMenuPrintList_get_title_and_class( $a[3] );
        $t .=
qq{<li $title rel="$class" class="$class" id="sp_menu_item_$a[0]"><input $checked type=checkbox onclick="pub($a[0])" id="published_$a[0]"><a>$a[1]</a>\n};
        $t .= recurse_MMenuPrintList( $a[0] );
        $t .= qq{</li>\n};
    }
    return $t ? "<ul>$t</ul>\n" : '';
}

sub MMenuPrintList_get_title_and_class {
    my $url = shift;

    my $class = $url ? 'default' : 'folder';
    my $title;

    if ( defined($url) and $url =~ m/\bmod=(\w+)/ ) {
        if ( grep( /^\Q$1\E$/, @modules ) ) {
            if ( $1 ne 'content' ) {
                $title = qq[title=": $1"];
                $class = 'module';
            }
            else {
                if ( $url =~ m/\brc=/ ) {
                    $title = qq[title=""];
                }
                else {
                    $title = qq[title=""];
                }
            }
        }
        else {
            $title = qq[title=""];
        }
    }
    $title = qq[title=""] unless $url;
    unless ( defined $title ) {
        $title = qq[title=""];
        $class = 'link';
    }

    return ( $title, $class );

}

sub NewsCall {

    my $rn = $_[0];
    my $nb = $_[1];

    GetNameByUid('GetAll') if $CS;
    my $tmpdata;

    my $message_no_news_yet = "  ...";

    if ( $rn ne 'empty' ) {
        my $zapros = "select startdate, head, text, exttext, news_id, autor,
        (select count(1) FROM news_comment where news.news_id = news_comment.n_id and news.owner = news_comment.owner),
        (select cat from news_cat where news.cat = news_cat.id_n)
        from news where published = 1 and news_id = $rn and owner = $owner";
        $tmpdata = NewsGetData( $zapros, "$theme_dir/$theme/news.html", "$rn" );
    }
    elsif ( $nb ne 'empty' and $nb < $MOD_CONFIG{'news_num_arc'} ) {
        my $zapros =
"select news_id from news where published = 1 and owner = '$owner' order by startdate DESC";
        my $num_all_on_page = my @id_data = NewsGetData( $zapros, '0' );
        if ( !@id_data == 0 and $nb < @id_data / $MOD_CONFIG{'news_on_page'} ) {
            if ( $num_all_on_page > $MOD_CONFIG{'news_on_page'} )
            { my $first_item = $MOD_CONFIG{'news_on_page'} * $nb;
                my $count = '0';
                my $Qnews_id;
                my $tmpOR = '';
                while (
                    $count < $MOD_CONFIG{'news_on_page'}
                    and (  $id_data[ $first_item + $count ]
                        or $id_data[ $first_item + $count ] eq '0' )
                  )
                {
                    $Qnews_id .=
                      "$tmpOR news_id = $id_data[$first_item+$count]";
                    $count++;
                    $tmpOR = ' or ';
                }
                my $zapros =
                  "select startdate, head, text, exttext, news_id, autor,
                (select count(1) FROM news_comment where news.news_id = news_comment.n_id and news.owner = news_comment.owner),
                (select cat from news_cat where news.cat = news_cat.id_n)
                from news where published = 1 and "
                  . " $Qnews_id "
                  . "and owner = $owner order by startdate DESC";
                $tmpdata =
                  NewsGetData( $zapros, "$theme_dir/$theme/news.html" );
                my $HrefNext =
                  NewsNext( $num_all_on_page, $MOD_CONFIG{'news_on_page'} );
                $tmpdata .= $HrefNext;
            }
            else {
                my $first_item = '0';
                my $count      = '0';
                my $item;
                my $Qnews_id;
                my $tmpOR = '';
                foreach $item (@id_data) {
                    $Qnews_id .=
                      "$tmpOR news_id = $id_data[$first_item+$count]";
                    $count++;
                    $tmpOR = ' or ';
                }
                my $zapros =
                  "select startdate, head, text, exttext, news_id, autor,
            (select count(1) FROM news_comment where news.news_id = news_comment.n_id and news.owner = news_comment.owner),
            (select cat from news_cat where news.cat = news_cat.id_n)
            from news where published = 1 and "
                  . " $Qnews_id "
                  . "and owner = $owner order by startdate DESC";
                $tmpdata =
                  NewsGetData( $zapros, "$theme_dir/$theme/news.html" );
            }
        }
        elsif ( @id_data == 0 and param('mod') ne 'news' and $owner eq '6' ) {
            if (
                sqlffcms(
                    "select PUBLISHED from modules_cnf_users
        		where
        			owner = 6
        			and
        			MOD_ID = (select i_id from modules where modulename = 'aboutou')"
                )
              )
            {
                $tmpdata = aboutou();
            }
            else {
                $tmpdata = $message_no_news_yet;
            }
        }
        else {
            $tmpdata = $message_no_news_yet;
        }

    }
    return $tmpdata;
}

sub NewsNext { my $num_all_on_page = $_[0];
    my $nextnb = $num_all_on_page / $MOD_CONFIG{'news_on_page'};
    unless ( $nextnb =~ /^-?\d+\/?\d*$/ ) {
        $nextnb = int( $num_all_on_page / $MOD_CONFIG{'news_on_page'} ) + 1;
    }
    my $i        = 0;
    my $hrefi    = 1;
    my $HrefNext = '<div class=news_next>';
    if ( param('nb') > 0 ) {
        my $iii = param('nb') - 1;
        $HrefNext .=
          qq^<a href="$cms?mod=news&nb=0" title=" ">&lt;&lt;</a>^;
        $HrefNext .=
          qq^<a href="$cms?mod=news&nb=$iii" title=''>&lt;&nbsp;</a>^;
    }
    while ( $i < $nextnb ) {
        my $iii = $i + 1;
        if ( param('nb') == $i ) {
            $HrefNext .=
              qq^&nbsp;<span class="news_next_caren_pg"><b>$iii</b></span>^;
        }
        else {
            $HrefNext .=
              qq^<a title=" $iii" href="$cms?mod=news&nb=$i">$hrefi</a>^
              if $i < $MOD_CONFIG{'news_num_arc'};
        }
        $i++;
        $hrefi++;
    }
    if (    param('nb') < ( $MOD_CONFIG{'news_num_arc'} - 1 )
        and param('nb') < ( $i - 1 ) )
    {
        my $iii     = param('nb') + 1;
        my $endpage = $i - 1;
        if ( $endpage < $MOD_CONFIG{'news_num_arc'} ) { $endpage = $i - 1 }
        else { $endpage = $MOD_CONFIG{'news_num_arc'} - 1 }
        $HrefNext .=
          qq^<a href="$cms?mod=news&nb=$iii" title=''>&nbsp;&gt;</a>^;
        $HrefNext .=
qq^<a href="$cms?mod=news&nb=$endpage" title=" ">&gt;&gt;</a>^;
    }
    if ( $nextnb > $MOD_CONFIG{'news_num_arc'} ) {
        $HrefNext .=
          qq^<a href="$cms?mod=news&arc=1&m=1" title=" "></a>^;
    }
    $HrefNext .= '</div>' . "\n";
    return $HrefNext;
}

sub NewsGetData {
    my $zapros   = $_[0];
    my $tpl_file = $_[1];
    my $rn       = $_[2];
    my $attr     = {
        ib_timestampformat => '%d %B %Y %H:%M',
        ib_dateformat      => '%m-%d-%Y',
        ib_timeformat      => '%H:%M'
    };
    my $q = $gdbcms->prepare( $zapros, $attr ) or db_error();
    $q->execute() or db_error();
    my @a;
    if ( $tpl_file ne '0' )
    { my @tpl_data_cache = open_tpl("$theme_dir/$theme/news.html");
        my @tpl_data;
        my %replace;
        my $BlockContent;
        while ( @a = $q->fetchrow_array() ) {
            my $textt;
            if   ($CS) { $textt = NewsFltrHtml( $a[2] ) }
            else       { $textt = $a[2] }
            my $cat = $a[7] || '';
            %replace = (
                autor => GetNameByUid( $a[5] ),
                data  => MonthYa( $a[0] ),
                edit =>
qq[<a href="$cms?mod=news&edt=en&ni=375&pg=1">id = $a[5] TODO-edit</a>],
                head     => $a[1],
                text     => $textt,
                category => $cat
            );
            if ( $a[3] and !defined $rn ) {
                $replace{fullnews} =
                    '<a class="read-more" title="..." href="'
                  . "$cms?mod=news&rn=$a[4]"
                  . '"> ...</a>';
            }
            else { $replace{fullnews} = ''; }
            if   ( defined $rn ) { $replace{exttext} = $a[3] }
            else                 { $replace{exttext} = '' }
            if ( $MOD_CONFIG{'news_comment'} ) {
                $replace{'addcomment'} =
qq^<a title="       ,      "
                    href="$cms?mod=news&rn=$a[4]"> : $a[6]</a>^
            }
            else { $replace{'addcomment'} = '' }
            $title_head = $a[1];
            @tpl_data   = @tpl_data_cache;
            tpl_replace_ant( \%replace, \@tpl_data );
            foreach my $htmlline (@tpl_data) { $BlockContent .= $htmlline }
        }
        $BlockContent .= NewsComment($rn)
          if $rn and $MOD_CONFIG{'news_comment'};
        return $BlockContent;
    }
    else {
        my @id_data;
        while ( @a = $q->fetchrow_array() ) { push( @id_data, $a[0] ) }
        return @id_data;
    }
}

sub NewsFltrHtml {
    my $text = $_[0];
    $text =~ s/<font[^>]+>//gi;
    $text =~ s/<\/font>//gi;
    $text =~ s/FONT-SIZE: \d+\.?\d+?pt;?//gi;
    $text =~ s|(<span style="font-size:.+?">)(.+?)(</span>)|$2|gi;
    $text =~ s|(<span style="font-family:.+?">)(.+?)(</span>)|$2|gi;
    return $text;
}

sub feedback {
    my $return_data;
    unless ( param('comments') and param('email') ) {
        $return_data = FeedbackPrintForm();
    }
    else {
        my $error = FeedbackCheckParam();
        if ( $error eq "   :<br>" ) {
            $return_data = FeedbackPostForm();
        }
        else { $return_data = "$error" . "<br>" . FeedbackPrintForm() }
    }

    return $return_data;
}

sub FeedbackCheckParam {
    my $error    = "   :<br>";
    my $name     = escapeHTML( param('name') );
    my $email    = escapeHTML( param('email') );
    my $city     = escapeHTML( param('city') );
    my $comments = escapeHTML( param('comments') );
    if ( $name eq "" or $name =~ /\d/ ) {
        $error .= '   ""';
    }
    unless ( $email =~
/^[a-z0-9]+([_\.\-]{1}[a-z0-9]+)*@[a-z0-9]+([_\.\-]{1}[a-z0-9]+)*\.[a-z]{2,4}$/i
      )
    {
        $error .= '   " e-mail  "';
    }
    unless ($KSHP) {
        if ( $city eq "" or $city =~ m/^\s+$/ ) {
            $error .= '   ""';
        }
    }
    if ( length($comments) > 1500 ) {
        $error .=
          '     - 1500 ';
    }
    return $error;
}

sub FeedbackPostForm {
    if (   $ENV{'HTTP_REFERER'} =~ /$ENV{'SERVER_NAME'}/
        or $ENV{'HTTP_REFERER'} eq "" )
    {
        my $name     = escapeHTML( param('name') );
        my $email    = escapeHTML( param('email') );
        my $city     = escapeHTML( param('city') );
        my $comments = escapeHTML( param('comments') );
        my $ip_sql   = $ENV{'REMOTE_ADDR'};
        $ip_sql .= " or ip = " . $ENV{'HTTP_X_FORWARDED_FOR'}
          if $ENV{'HTTP_X_FORWARDED_FOR'};
        my $q = sqlpcms(
            qq[select distinct uid from logs_session where ip = '$ip_sql']);
        my @uids;

        while ( my @a = $q->fetchrow_array() ) {
            push @uids, GetNameByUid( $a[0] ) . "\n               " if $a[0];
        }
        my $avtorize =
" ip- $ENV{'REMOTE_ADDR'}      ";
        if ( scalar @uids ) {
            $avtorize = "
				 ip- $ENV{'REMOTE_ADDR'}       :
						@uids\n";
        }
        my ( $sec, $min, $hour, $mday, $mon, $year, $wday, undef, undef ) =
          localtime;
        $year += 1900;
        my $time = "$mday $mnths[$mon] $year, $wdays[$wday-1], "
          . sprintf( "%02d:%02d", $hour, $min );
        my $text = "
             !
                 .

          :
            : $name
            E-mail  : $email
";
        if ($KSHP) {
            my $feedback_ou_num = param('ou_num');
            sec_gteq0($feedback_ou_num) if $feedback_ou_num;
            my $human_id_or_class_and_lastname =
              param('human_id_or_class_and_lastname');
            if ($human_id_or_class_and_lastname) {
                $human_id_or_class_and_lastname =
                  trim($human_id_or_class_and_lastname);
                $human_id_or_class_and_lastname =
                  substr( $human_id_or_class_and_lastname, 0, 64 );
            }
            $text .= "            : $feedback_ou_num
              /: $human_id_or_class_and_lastname
";
        }
        else {
            $text .= "            : $city
";
        }

        $text .= "

         :
        ------------------------------------------------------------------------
        $comments
        ------------------------------------------------------------------------

           \" \":
            :      $time
            IP-:  $ENV{'REMOTE_ADDR'}  $ENV{'HTTP_X_FORWARDED_FOR'}
            UserAgent: $ENV{'HTTP_USER_AGENT'}
            Referer:   $ENV{'HTTP_REFERER'}
            $avtorize

";
        GetConfig('feedback');
        if ( $owner eq '6' ) {
            $MOD_CONFIG{'feedback_email'} = sqlff(
"select property_value from self_property where name='E-MAIL_FROM_ADDRES'"
            ) unless $MOD_CONFIG{'feedback_email'};
        }
        $MOD_CONFIG{'feedback_email'} = ""
          if $MOD_CONFIG{'feedback_email'} eq "reserved";
        FeedbackSendEMail( "$text", "$email", "$MOD_CONFIG{'feedback_email'}" )
          if $MOD_CONFIG{'feedback_email'};
        my @uid;
        if ( $owner ne '6' ) { $uid[0] = $owner }
        else {
            my $q = sqlp(
                "select uid from sp_users where log = 'root' or log = 'admin'");
            while ( my @a = $q->fetchrow_array() ) { push @uid, $a[0] }
            my @saved_uids = split /;/, $MOD_CONFIG{'feedback_in_msg'};
            unless ( grep /checked/, @saved_uids ) {
                @uid = ( @uid, @saved_uids );
            }
        }
        foreach my $u (@uid) {
            msg_send(
                "$u",
"C      http://$ENV{'SERVER_NAME'}",
                "$text"
                ) if $MOD_CONFIG{'feedback_in_msg'};
        }
        return "   !";
    }
    else { error404() }
}

sub FeedbackSendEMail {
    my $comments    = $_[0];
    my $email_reply = $_[1];
    my $email_ou    = $_[2];
    my $MailSubject =
      "      http://$ENV{'SERVER_NAME'}";
    my $sender = new Mail::Sender {
        smtp    => $gconf{'smtp'},
        from    => 'xxibasequery@' . $ENV{'SERVER_NAME'},
        charset => 'Windows-1251',
        replyto => $email_reply
    };
    my $errors;
    if (
        ref(
            $sender->MailMsg(
                {
                    to      => "$email_ou",
                    subject => "$MailSubject",
                    msg     => "$comments"
                }
            )
        )
      )
    {
        $errors = "   !";
    }
    else { $errors = "  : " . $sender->{'error'} . "\n" }
    return $errors;
}

sub FeedbackPrintForm {
    my $return_data;
    my $feedback_file = 'feedbackform.html';
    if ($KSHP) {
        $feedback_file = 'feedbackform-kshp.html';
    }
    foreach my $line ( open_tpl("$theme_dir/$theme/$feedback_file") ) {
        if ( $line =~ /name="mod" value="feedback"/ ) {
            $line =
              "<input type=\"hidden\" name=\"ow\" value=\"$owner\" />" . $line;
        }
        $return_data .= $line;
    }
    return $return_data;
}

sub feedbackConfig {
    GetConfig('feedback');
    my $return_data;
    if ( $owner eq '6' ) {
        $MOD_CONFIG{'feedback_email'} = sqlff(
"select property_value from self_property where name='E-MAIL_FROM_ADDRES'"
        ) unless $MOD_CONFIG{'feedback_email'};
    }
    $MOD_CONFIG{'feedback_email'} = ""
      if $MOD_CONFIG{'feedback_email'} eq "reserved";
    if ( param('edt') ne 'so' ) {
        $return_data = qq^
            E-mail       :
            <input type="text" align="center" name="feedback_email" value="$MOD_CONFIG{'feedback_email'}" size="20"><br>
        ^;
        if ( $owner eq '6' ) {
            $return_data .= qq^
                <fieldset style="padding: 2">
                <legend>:</legend>
                          :<br>
                ^;
            my %names = FeedbackConfigGetMsgUids();
            my @saved_uids = split /;/, $MOD_CONFIG{'feedback_in_msg'};
            foreach my $uid ( sort { $names{$a} cmp $names{$b} } keys %names ) {
                my $on = 'checked' if grep /^$uid$/, @saved_uids;
                $return_data .=
qq^<input type="checkbox" name="uid-$uid" $on value="ON"> $names{$uid}<br>^;
            }
            $return_data .= qq^</fieldset>^;
        }
        else {
            $return_data .=
qq^<input type="checkbox" name="feedback_in_msg" $MOD_CONFIG{'feedback_in_msg'} value="ON">         <br>^;
        }

    }
    else { my ( $femail, $fmsg );
        my $mod_id = param('i_id');
        if ( param('feedback_email') =~
/^[a-z0-9]+([_\.\-]{1}[a-z0-9]+)*@[a-z0-9]+([_\.\-]{1}[a-z0-9]+)*\.[a-z]{2,4}$/i
          )
        {
            $femail = param('feedback_email');
        }
        elsif ( param('feedback_email') eq "" ) { $femail = "reserved" }
        else { $femail = $MOD_CONFIG{'feedback_email'} || "reserved" }
        if ( param('feedback_in_msg') eq "ON" and $owner ne '6' ) {
            $fmsg = "checked";
        }
        my @fmsgs;
        my %names = FeedbackConfigGetMsgUids() if $owner eq '6';
        foreach my $p (param) {
            if (    $p =~ /uid-(\d+)/
                and param("uid-$1") eq 'ON'
                and $owner eq '6' )
            {
                push @fmsgs, $1 if defined $names{$1};
            }
        }
        $fmsg = join ';', @fmsgs if $owner eq '6';
        sqlcms(
qq^update modules_cnf_users set m_config = ',feedback_email=$femail,feedback_in_msg=$fmsg,' where i_id = '$mod_id' and owner = '$owner'^
        );
    }
    return "$return_data";
}

sub FeedbackConfigGetMsgUids {
    my $q = sqlp(
        "select distinct uid from sp_users_acl where gid = '1' or gid = '6'");
    my @gid_adm_school;
    my $name;
    my %names;
    while ( my @a = $q->fetchrow_array() ) { push @gid_adm_school, $a[0] }
    foreach my $uid (@gid_adm_school) {
        $name = GetNameByUid($uid);
        $names{$uid} = $name
          unless $name =~ /^ \(root\)/
              or $name =~ /^_$/;
    }
    return %names;
}

sub settings() {
    if ( param('edt') eq 'settings_print' ) {
        settings_print();
    }
    elsif ( param('edt') eq 'settings_save' ) {
        settings_save();
        settings_print();
    }
    elsif ( param('edt') eq 'ajax_edit_self_property' ) {
        if ( isadmin() ) {
            settings_aj_update_self_property();
        }
        else { deny(); }
    }
}

sub settings_aj_update_self_property() {
    my $name = param('name');
    $name =~ s/^self_property_//o;
    my $value = substr( utf8_to_win( param('value') ), 0, 255 );

    if ( grep( /^\Q$name\E$/, @editable_self_property_names ) ) {
        sqlb( 'update self_property set property_value = ? where name = ?',
            $value, $name );
        aj_print($value);
    }
    aj_print('');
}

sub settings_print() {
    my $sp_blog_swtiched_on =
      sqlff("select f_int from sp_user_settings where uid = $guid and id = 5");

    if ( ( isadmin() or exists $ACL{'6'} ) and !$sp_blog_swtiched_on ) {
        my $jeditable = '';

        my @editable_self_property_names_quotes = @editable_self_property_names;
        $_ = "'$_'" for @editable_self_property_names_quotes;

        my @properties;
        sqla( \@properties,
"select NAME, NOTE, PROPERTY_VALUE from SELF_PROPERTY where NAME in ("
              . join( ',', @editable_self_property_names_quotes )
              . ")" );
        for (@properties) {
            $jeditable .= qq[
<tr>
    <td>$$_[1]</td>
    <td><span class="jeditable" id="self_property_$$_[0]">$$_[2]</span></td>
</tr>
];
        }
        print tpl_str(
            "./tpl/settings-school.html",
            {
                jeditable_items => $jeditable,
                cms             => $cms,
            }
        );
    }
    else {
        my $show_staff_checked = sqlff(
            "select f_int from sp_user_settings where uid = $guid and id = 6");
        print tpl_str(
            "./tpl/settings.html",
            {
                site_title => sqlff(
qq[select f_int from sp_user_settings where id = 3 and uid = $guid]
                ),
                site_subtitle => sqlff(
qq[select f_int from sp_user_settings where id = 4 and uid = $guid]
                ),
                show_staff_checked => $show_staff_checked
            }
        );
    }
}

sub settings_save() {

    my $site_title = substr( param('site_title'), 0, 64 );

    my $site_subtitle = substr( param('site_subtitle'), 0, 512 );

    strip_tag( \$site_title,    'html' );
    strip_tag( \$site_subtitle, 'html' );

    sql(qq[delete from SP_USER_SETTINGS where uid = $guid and id = 3]);
    sql(qq[delete from SP_USER_SETTINGS where uid = $guid and id = 4]);
    sql(qq[delete from SP_USER_SETTINGS where uid = $guid and id = 6]);

    if ($site_title) {
        sqlb(
qq[INSERT INTO SP_USER_SETTINGS (UID, ID, F_INT) VALUES ($guid, 3, ?)],
            $site_title
        );
    }

    my $site_subtitle_whitespace_removed = $site_subtitle;
    $site_subtitle_whitespace_removed =~ s/\s*//g;
    $site_subtitle_whitespace_removed =~ s/(<br>){1,}//g;
    $site_subtitle_whitespace_removed =~ s/(<br ?\/>){1,}//g;
    $site_subtitle_whitespace_removed =~ s/(&nbsp;){1,}//g;

    if ( $site_subtitle and $site_subtitle_whitespace_removed !~
        m|^(<p></p>){1,}$| )
    {
        sqlb(
qq[INSERT INTO SP_USER_SETTINGS (UID, ID, F_INT) VALUES ($guid, 4, ?)],
            $site_subtitle
        );
    }

    if ( param('show_staff') ) {
        sql(
"INSERT INTO SP_USER_SETTINGS (UID, ID, F_INT) VALUES ($guid, 6, 'checked')"
        );
    }
}

sub GetNameByUid {
    my $uid = $_[0];
    if ( $uid ne 'GetAll' ) {
        if ( !defined $NewsAutors{$uid} ) {
            my @a;
            if ( !$CS ) {
                @a = sqlf(
"select last_name, first_name, middle_name from human where human_id = '$uid'"
                );
            }
            else {
                @a = sqlfcms(
                    "select ou_name_short, name from cs_ou_names, cs_users
												where cs_users.u_id = $uid
												and cs_users.ou_id = cs_ou_names.ou_id"
                );
                if ( @a == 0 ) {
                    @a = sqlf(
"select last_name, first_name, middle_name from human where human_id = $uid"
                    );
                }
                else { $a[0] = $a[0] . ',' }
            }
            if ( @a == 0 ) { push @a, "_" }
            $NewsAutors{$uid} .= join ' ', @a;
        }

        $NewsAutors{$uid} =~ s/\s+$//, $NewsAutors{$uid};

        return $NewsAutors{$uid};
    }
    else {
        my $q = sqlpcms("select distinct autor from news where owner = $owner");
        my ( $a, @uids );
        while ( $a = $q->fetch ) { push @uids, $a->[0]; }
        foreach my $uid (@uids) { GetNameByUid($uid); }
        return %NewsAutors;
    }
}

sub Sort_Order_id {
    my $module = param('mod');
    if ( $module eq 'modules' ) { $module = 'modules_cnf_users'; }
    my $what = param('what');
    sec_gteq0($what);
    my $to = param('to');
    sec_gteq0($to) if $to;
    if ( $to =~ /^-?\d+\/?\d*$/ ) {
        my $zapros =
"select i_id, i_sort from $module where (I_ID = '$what' or I_ID = '$to') and owner = $owner";
        my $q = $gdbcms->prepare($zapros) or db_error();
        $q->execute() or db_error();
        my @a;
        my @Items;
        while ( @a = $q->fetchrow_array() ) {
            push( @Items, $a[0] );
            push( @Items, $a[1] );
        }
        $zapros =
"update $module set I_SORT = '$Items[3]' where I_ID = '$Items[0]' and owner = '$owner'";
        $q = $gdbcms->prepare($zapros) or db_error();
        $q->execute() or db_error();
        $zapros =
"update $module set I_SORT = '$Items[1]' where I_ID = '$Items[2]' and owner = '$owner'";
        $q = $gdbcms->prepare($zapros) or db_error();
        $q->execute() or db_error();
    }
}

sub ConnectDBCS {
    $gdsnCS =
        "DBI:InterBase:db="
      . $gconf{"central_site_dbname"}
      . ";ib_charset=WIN1251;ib_dialect=3;host="
      . $gconf{"central_site_dbhost"};
    $gdbCS = DBI->connect(
        $gdsnCS,
        $gconf{"central_site_dbuser"},
        $gconf{"central_site_dbpasswd"}
    ) or db_error_connect(3);
    $gdbCS->{LongReadLen} = '100000';
}

sub tpl_replace_ant ( % @ ) {
    my $ref      = $_[0];
    my $tpl_data = $_[1];
    if ($ref) {
        my $key;
        my $value;
        my $line;
        foreach $line (@$tpl_data) {
            while ( ( $key, $value ) = each(%$ref) ) {
                $line =~ s/\$$key\b/$value/gi;
            }
        }
    }
    return @$tpl_data;
}

sub open_tpl ( $ ) {
    my @tpl_dat;
    my $file;
    my @file_name = split /\//, $_[0];

    my $est = '0';

    if ( $Cache_block{ $_[0] } ) {
        @tpl_dat = split( /\n/im, $Cache_block{ $_[0] } );
    }
    else {

        if ( -f $_[0] ) {
            $file = $_[0];
            $est  = 1;
        }
        elsif ( -f "$theme_dir/sp-default/$file_name[-1]" ) {
            $file = "$theme_dir/sp-default/$file_name[-1]";
            $est  = 1;
            $est  = 1;
        }
        else {
            push @tpl_dat,
"          ($_[0])      sp-default.";
            delete $Cache_block{ $_[0] };
        }

        if ($est) {
            open FILE, "$file";
            @tpl_dat = <FILE>;
            close FILE;

            my $p;
            for (@tpl_dat) { $p .= $_ }
            $Cache_block{ $_[0] } = $p;
        }
    }

    return @tpl_dat;
}

sub return_block ($$) {
    my $ref          = $_[0];
    my $tpl_dat      = $_[1];
    my @tpl_data     = open_tpl($tpl_dat);
    my $BlockContent = '';
    if ($ref) {
        my $key;
        my $value;
        my $line;
        foreach $line (@tpl_data) {
            while ( ( $key, $value ) = each(%$ref) ) {
                $line =~ s/\$$key\b/$value/gi;
            }
            $BlockContent .= $line;
        }
    }
    return $BlockContent;
}

sub return_item (% @) {
    my $ref          = $_[0];
    my $tpl_data     = $_[1];
    my $BlockContent = '';
    if ($ref) {
        my $key;
        my $value;
        my $line;
        foreach $line (@$tpl_data) {
            while ( ( $key, $value ) = each(%$ref) ) {
                $line =~ s/\$$key\b/$value/gi;
            }
            $BlockContent .= $line;
        }
    }
    return $BlockContent;
}

sub ConnectDBXxi {
    if ( !defined($gdb) or !$gdb->ping ) {
        if ( $gconf{'light'} ) {
            $gdsnxxi =
                "DBI:InterBase:db="
              . $gconf{"cmsdbname"}
              . ";ib_charset=WIN1251;ib_dialect=3;host="
              . $gconf{"cmsdbhost"};
            $gdb =
              DBI->connect( $gdsn, $gconf{"cmsdbuser"}, $gconf{"cmsdbpasswd"} )
              or db_error_connect(2);
        }
        else {
            $gdsnxxi =
                "DBI:InterBase:db="
              . $gconf{"db_path"}
              . ";ib_charset=WIN1251;host="
              . $gconf{"db_server"};
            $gdb =
              DBI->connect( $gdsnxxi, $gconf{"db_user"}, $gconf{"db_pass"} )
              or db_error_connect(1);
        }

        $connected = 1;

    }
}

sub Chpu {
    my $c = $_[0];
    $c =~ s/=|&/\//g;
    $c =~ s/$cms\?//g;
    if ( $c =~ /ow\/6\//g ) { $c =~ s/ow\/6\///g; }
    elsif ( $c =~ /ow\/(\d+)/ ) {
        my @sites = User_site($1);
        $c =~ s/ow\/\d+/$sites[0]/g;
        $c =~ s#/mod/#/#g;
    }
    if ( $c =~ m|\S+/ow/| ) {
        $c =~ s|\S+/ow/||;
    }
    $c =~ s#^mod/##g;
    $c =~ s#/mod/#/#g;
    $c =~ s#^ow/##g;
    my @qs = split /\//, $c;
    $c =~ s|$qs[0]/|| if $qs[0] eq $qs[1];
    $c = "http://$ENV{SERVER_NAME}/$c";
    return $c;
}

sub ChpuUn {

    my $QString = $ENV{'QUERY_STRING'};

    unless ( $QString =~ /=/ && param("edt")
        or $QString eq 'mod' )
    {
        if ($chpu) {
            my @q = split m|/|, $QString;
            my @add_prm;
            my @sites = User_site( $q[0] );
            if ( $sites[1] ) {
                $q[0] = "ow";
                if ( $q[1] ) { splice @q, 1, 0, "$sites[1]", "mod" }
                else         { splice @q, 1, 0, "$sites[1]" }
            }
            elsif ( $QString =~ /ow\/(\d+)/ ) {
                @add_prm = /"ow", "$1", "mod"/;
            }
            else {
                unless ( grep /^$QString$/, @modules ) {
                    my $QString_cut_tmp = substr( $QString, 0, 127 );

                    my @SQL = sqlbfcms(
"SELECT c_id, 'content', c_type FROM content WHERE published = 1 AND permalink = ?
					union SELECT news_id, trim('news'), 0 FROM news WHERE published = 1 AND permalink = ?",
                        $QString_cut_tmp, $QString_cut_tmp
                    );

                    if (@SQL) {
                        if ( $SQL[1] eq 'content' ) {

                            if ( $SQL[2] == 0 ) {
                                $ENV{'QUERY_STRING'} = "mod=content&ls=$SQL[0]";
                            }
                            else {
                                $ENV{'QUERY_STRING'} = "mod=content&rc=$SQL[0]";
                            }

                            return;
                        }
                        elsif ( $SQL[1] eq 'news' ) {
                            $ENV{'QUERY_STRING'} = "mod=news&rn=$SQL[0]";
                            return;
                        }
                    }
                }
                @add_prm = qw/mod/;
            }

            push( @add_prm, @q );
            my $q_s;
            my $n = 0;
            foreach my $item (@add_prm) {
                my $rows = $n / 2;
                unless ( $rows =~ /^-?\d+\/?\d*$/ ) {
                    $q_s .= "=" . $item;
                }
                else { $q_s .= "&" . $item }
                $n++;
            }

            $q_s =~ s/^&//;
            $ENV{'QUERY_STRING'} = "$q_s";
        }
    }
}

sub MOUNameLocal {
    my ( $mou_s, $mou_f, $mou_l, $tlt );
    if ( $Cache_block{ 'mou_name_short' . $owner } ) {
        $mou_s = $Cache_block{ 'mou_name_short' . $owner };
        $mou_f = $Cache_block{ 'mou_name_num' . $owner };
        $mou_l = $Cache_block{ 'mou_name_long' . $owner };
        $tlt   = $Cache_block{ 'mou_name_tlt' . $owner };
    }
    else {
        ( $mou_s, $mou_f ) = MOUName();
        $Cache_block{ 'mou_name_short' . $owner } = $mou_s;
        $Cache_block{ 'mou_name_num' . $owner }   = $mou_f;
        $mou_l = $Cache_block{ 'mou_name_long' . $owner } = MOUName('full');
        $tlt   = $Cache_block{ 'mou_name_tlt' . $owner }  = sqlff(
"select property_value from self_property where NAME = 'POST_ADDRESS'"
        );
    }
    return $mou_s, $mou_f, $mou_l, $tlt;
}

sub PrintPage ( $ % ) {
    my $file = $_[0];
    my $ref  = $_[1];
    my @data;
    my $null = '0';

    my @mou_name = MOUNameLocal();

    my $Copyright = qq^
<div class="footer">
	<div>&copy; $mou_name[2]</div>
	<div id="footer-second-line">&copy; 2005&ndash;2012 <a href="http://spcms.ru/" target="_blank">   &laquo; &raquo;$LIGHT</a></div>
</div>
^;
    $Copyright .= dump_queries() if $DEBUG;

    my $theme_url = GetThemeUrl();
    open FILE, "<$_[0]";
    @data = <FILE>;
    close FILE;
    my $analytics_published;
    if ( $Cache_block{ 'analytics_published' . $owner } ) {
        $analytics_published = $Cache_block{ 'analytics_published' . $owner };
    }
    else {
        $analytics_published = $Cache_block{ 'analytics_published' . $owner } =
          sqlffcms( "
                                                                                     select published from modules_cnf_users where owner = $owner
                                                                                     and mod_id = (select i_id from modules where modulename = 'analytics')"
          );
    }
    my $kod;
    if ($analytics_published) {
        if (    $Cache_block{ 'analytics' . $owner }
            and $Cache_time{ 'analytics' . $owner } eq $gdate )
        {
            $kod = $Cache_block{ 'analytics' . $owner };
        }
        else {
            $kod = $Cache_block{ 'analytics' . $owner } =
              sqlffcms("select CONTENT from ANALYTICS where OWNER = $owner")
              || '';
            $Cache_time{ 'analytics' . $owner } = $gdate;
        }
    }

    $title_head = TitleHead();

    my $site_author = $mou_name[2];
    if ( $owner != 6 ) {
        $site_author = human_hash($owner);
    }

    my $author_photo = '';
    if ( $owner != 6 ) {
        my %author_photo_tmp = Users_Photos( [$owner], 1 );
        $author_photo = $author_photo_tmp{$owner};
    }

    my $author_login = '';
    if ( $owner != 6 ) {
        $author_login = sqlff("select log from sp_users where uid = $owner");
    }

    my $blog_title = sqlff(
        qq[select f_int from sp_user_settings where id = 3 and uid = $owner]);
    $blog_title ||= $site_author;

    my $blog_subtitle = sqlff(
        qq[select f_int from sp_user_settings where id = 4 and uid = $owner]);
    $blog_subtitle ||=
qq[    (<a href="$cms?mod=settings&edt=settings_print"></a>)];

    if ($ref) {
        my $key;
        my $value;
        foreach my $line (@data) {
            while ( ( $key, $value ) = each(%$ref) ) {
                $line =~ s/\$$key\b/$value/gi;
            }

            $line =~ s/$cms\?/$cms\?ow=$owner&/gi if $owner ne '6';

            unless ( $gconf{'hide_copyright'} ) {
                if ( $line =~ /\<\/body\>/ ) {
                    $line =~ s/<\/body\>/$Copyright <\/body>/;
                }
                elsif ( $line =~ /\<\/html\>/ ) {
                    $line =~ s/<\/body\>/$Copyright >\/html>/;
                }
                elsif ( $line eq $data[-1] ) { s/$line/$Copyright/ }
            }

            if ($analytics_published) {
                if ( $line =~ /\<\/body\>/ ) {
                    $line =~ s/<\/body\>/$kod <\/body>/;
                }
                elsif ( $line =~ /\<\/html\>/ ) {
                    $line =~ s/<\/body\>/$kod >\/html>/;
                }
                elsif ( $line eq $data[-1] ) { s/$line/$kod/ }
            }

            $line =~ s/\$theme_dir\b/$theme_url\/$theme/g;
            $line =~ s/\$ou_name\b/$mou_name[0]/g;

            $line =~ s/\$ou_num\b//g;

            $line =~ s/\$ou_name_full\b/$mou_name[2]/g;
            $line =~ s/\$sitedate\b/$sitedate/g;
            $line =~ s/\$HEAD/$HEAD/g;
            $line =~ s|(<title>)(.+)(</title>)|$1$2 - $title_head$3|i;

            unless ( $owner == 6 ) {
                $line =~ s/\$author_login\b/$author_login/g;

                $line =~ s/\$author_photo\b/$author_photo/g;
            }

            $line =~ s/\$site_author\b/$site_author/g;

            $line =~ s/\$blog_title\b/$blog_title/g;

            $line =~ s/\$blog_subtitle\b/$blog_subtitle/g;

            if ( $chpu and $ENV{'QUERY_STRING'} !~ /&edt=/gi ) {
                $line =~ s/($cms\?.*?(\s|>))/Chpu($1)/geims;
            }

            if ( $gconf{'optimize_user_jpeg'} eq "1" ) {
                $line =~ s/(<img\s+.*?\>)/ImgRes($1)/gemi;
            }
        }
    }
    if ($GZIP) {
        binmode(STDOUT);
        print Compress::Zlib::memGzip( join '', @data );
    }
    else { print @data; }
}

sub TitleHead {
    my $mod = param('mod');
    my $t_n;
    if ( param('mod') ne 'content' and param('mod') ne 'news' and grep /^$mod$/,
        @modules )
    {
        if ( $Cache_block{ $mod . 'title' . $owner } ) {
            $t_n = $Cache_block{ $mod . 'title' . $owner };
        }
        else {
            $t_n = $Cache_block{ $mod . 'title' . $owner } = sqlffcms(
                "select visible_name from modules where modulename = '$mod'");
        }
        return $t_n;
    }
    elsif ( param('mod') eq 'news' ) {
        return " - $title_head" if param('rn');
        return ""               if !param('rn');
    }
    elsif ( !param('mod') ) {
        return "";
    }
    else { return $title_head }
}

sub ImgRes {
    my $urlImg = $_[0];
    my ( $src, $w, $h );
    if ( $urlImg !~ /_resized_sp_cms_/ and $urlImg !~ /\d+_--av\d+/ ) {
        $urlImg =~ s/ilo-full-src="(.+?\.jpg)"//i;
        if ( $urlImg =~ /src="(.+?\.jpg)"/i ) {
            $src = $1;
            ( $w, $h ) = Img_W_H($urlImg);
            if ( !$w or !$h ) {
                return $urlImg;
            }
            $src =~ s/^\///;
            $src =~ s/^[htps:]{5,6}?\/\/.+?\///i;
            $src = $rootdir . '/' . $src;
            my $resizedname = ImgResizedName( $src, $w, $h );
            my $ImgErr;
            if ( !-f "$resizedname" ) {
                $ImgErr = ImgResize( $w, $h, $src );
            }
            unless ( $ImgErr eq '123' ) {
                $src         =~ s/(^.*\/)//i;
                $resizedname =~ s/(^.*\/)//i;
                $urlImg      =~ s/\Q$src\E/$resizedname/i;
            }
            else {
                $urlImg =~ s/^<img/<img alt = "   " /;
            }
        }
    }
    return $urlImg;
}

sub Img_W_H {
    my $urlImg = $_[0];
    my ( $w, $h );
    if ( $urlImg =~ /width="(\d+)"/i )  { $w = $1 }
    if ( $urlImg =~ /height="(\d+)"/i ) { $h = $1 }
    if ( $urlImg =~ /width: (\d+)/i )   { $w = $1 }
    if ( $urlImg =~ /height: (\d+)/i )  { $h = $1 }
    return $w, $h;
}

sub ReturnPage ( $ % ) {
    my $file = $_[0];
    my $ref  = $_[1];
    my @data;
    open FILE, "<$_[0]";
    @data = <FILE>;
    close FILE;
    my $key;
    my $value;
    my $line;

    foreach $line (@data) {
        while ( ( $key, $value ) = each(%$ref) ) {
            $line =~ s/\$$key\b/$value/gi;
        }
    }
    my $htmlline;
    my $BlockContent;
    foreach $htmlline (@data) { $BlockContent .= $htmlline }
    return $BlockContent;
}

sub GetThemeUrl {
    my $theme_url_tmp;

    if ( $owner != 6 and !grep( /^$theme$/, @DefaultThemes ) ) {
        $theme_url_tmp = "$theme_url/Users_Themes/$owner";
    }
    else {
        $theme_url_tmp = $theme_url;
    }

    return $theme_url_tmp;
}

sub MonthYa {
    my $str_date   = $_[0];
    my %month_rplc = (
        ""   => "",
        ""  => "",
        ""     => "",
        ""   => "",
        ""      => "",
        ""     => "",
        ""     => "",
        ""   => "",
        "" => "",
        ""  => "",
        ""   => "",
        ""  => ""
    );
    while ( my ( $key, $value ) = each(%month_rplc) ) {
        $str_date =~ s/$key/$value/gi, $str_date =~ s/^0//;
    }
    return $str_date;
}

sub html_header_ant {
    return if param('edt') =~ m/^ajax_/;

    print "X-Powered-By: School Portal - www.spcms.ru\n";

    print
"Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0\nContent-type: text/html; charset=windows-1251\n\n";
    $g_http_headers_sent = 1;

    if ( defined param('edt') ) {

        print qq^<html><head>
<meta http-equiv="Content-Language" content="ru-ru">
<meta name="Pragma" content="no-cache">
<meta name="Expires" content="-1">
<meta http-equiv="Content-Type" content="text/html; charset=windows-1251">^;

        if ( param('edt') eq 'down' ) {
            my $tn    = param('tn');
            my @thems = ThemesGetArray();
            if ( grep /^\Q$tn\E$/, @thems ) {
                print
qq^\n<META HTTP-EQUIV="Refresh" CONTENT="2; URL=$theme_url/$tn.zip">^;
            }
            else {
                print("  ");
            }
        }

        print
qq^<link rel="stylesheet" type="text/css" href="/sp/yui/menu/assets/skins/sam/menu.css?$INCVER">
<link rel="stylesheet" type="text/css" href="/sp/yui/assets/skins/sam/sp.css?$INCVER">

<script type="text/javascript" src="/sp/yui/yahoo-dom-event/yahoo-dom-event.js"></script>
<script type="text/javascript" src="/sp/yui/container/container_core.js"></script>
<script type="text/javascript" src="/sp/yui/menu/menu.js"></script>

<script type="text/javascript" language="JavaScript1.2" src="/sp/ajax.js?$INCVER"></script>
<script type="text/javascript" language="JavaScript1.2" src="/sp/cms.js?$INCVER"></script>
<link rel="stylesheet" href="/sp/cms.css?$INCVER" type="text/css">
<link rel="shortcut icon" href="/sp/favicon.ico" type="image/x-icon">^;

        if ( param('mod') eq 'administration' or param('mod') eq 'bells' ) {
            print
qq^ <!--<link rel="stylesheet" type="text/css" href="/sp/yui/container/assets/skins/sam/container.css" />-->
<link rel="stylesheet" type="text/css" href="/sp/yui/assets/skins/sam/sp.css">
<script type="text/javascript" src="/sp/yui/container/container.js"></script>
<script type="text/javascript" src="/sp/yui/dragdrop/dragdrop.js"></script>
^;
        }

        if ( param('mod') eq 'content' and param('edt') eq 'lst' ) {
            print qq^<script type="text/javascript" src="/sp/cms.js"></script>^;
        }

        if (
               ( param('edt') eq 'as' and !defined param('chead') )
            or ( param('edt') eq 'ac' and !defined param('chead') )
            or param('edt') eq 'ec'
            or ( param('edt') eq 'an' and !defined param('newshead') )

            or param('edt') eq 'en' or param('edt') eq 'edit'
          )
        {
            my $areaHead = 'chead';
            $areaHead = 'newshead'
              if param('edt') eq 'en'
                  or param('edt') eq 'an';

            my $Def_GetTheme = $Cache_block{ 'Def_GetTheme' . $owner };

            if ( !$Def_GetTheme ) {
                $Cache_block{ 'Def_GetTheme' . $owner } = $Def_GetTheme =
                    GetThemeUrl() . '/'
                  . sqlffcms("select t_name from themes where owner = $owner");
            }

            if ( -d $Def_GetTheme ) {
                $Def_GetTheme = $gconf{sproot} . "/cms/themes";
            }

            print
qq^<script type="text/javascript" src="/sp/FCKeditor/fckeditor.js"></script>
<script type="text/javascript">
window.onload = function()
{
	var oFCKeditor = new FCKeditor('FCKeditor1');
	//oFCKeditor.Config['EditorAreaStyles'] = oFCKeditor.Config['ToolbarComboPreviewCSS'] = '$Def_GetTheme/style.css';
	oFCKeditor.ReplaceTextarea();\n^;

            if ( param('edt') eq 'en' or param('edt') eq 'an' ) {
                print qq^
	oFCKeditor = new FCKeditor('ExtTxt');
	oFCKeditor.BasePath = '/sp/FCKeditor/';
	//oFCKeditor.Config['EditorAreaStyles'] = oFCKeditor.Config['ToolbarComboPreviewCSS'] = '$Def_GetTheme/style.css';
	oFCKeditor.ReplaceTextarea();\n^;
            }

            print qq^
}
</script>

<script type="text/javascript">
  function isNotEmpty(elem)
  {
	var str = elem.value;
	var re = /.+/;
	if (!str.match(re))
	{
		alert(",   .");
		setTimeout("focusElement('" + elem.form.name + "', '" + elem.name + "')", 0);
		return false;
	}
	else { return true; }
  }
  function focusElement (formName, elemName)
  {
    var elem = document.forms[formName].elements[elemName];
    elem.focus();
    elem.select();
  }
  function validateForm(form)
  {
    if (isNotEmpty(form.$areaHead)){
    return true; }
    else { return false; }
  }
</script>
^;
        }
        my $title = ( defined $connected ) ? join '  ', MOUName() : '!';
        print qq^<title>$title -   - CMS</title></head>^;
    }

    if ( param('mod') ne 'administration' and param('mod') ne 'bells' ) {
        print "<body>";
    }
    else {
        print '<body class="yui-skin-sam">';
    }
}

sub GetOwner {
    if ( defined param 'edt' ) {
        my $_uid = uid();
        $guid = $_uid;
        read_acl();
        if ( $ACL{'6'} ) {
            $owner = '6';

            my $sp_blog_swtiched_on = sqlff(
"select f_int from sp_user_settings where uid = $guid and id = 5"
            );

            if ($sp_blog_swtiched_on) {
                $owner = $_uid;
            }

        }
        else {
            $owner = $_uid;
        }
        $autor_insert = $_uid;
        if ( param 'edt' eq 'down' ) { return $owner }
    }
    elsif ( defined param 'ow' ) {
        $owner = param('ow');
        if ($owner) { sec_gt0($owner) }
    }
    else { $owner = '6' }
}

sub GetTheme {
    unless ( defined param 'edt' ) {
        my $activeTheme = $Cache_block{ 'activeTheme' . $owner };

        unless ($activeTheme) {
            $Cache_block{ 'activeTheme' . $owner } = $activeTheme =
              sqlffcms("select t_name from themes where owner = $owner");
        }

        if ( !$activeTheme ) {
            if ( $owner == 6 ) {
                $theme = 'sp-default';
            }
            else {
                $theme = 'sp-blog';
            }
        }
        else {
            $theme = $activeTheme;
        }

    }
}

sub ThemesDown {
    my $t_name = $_[0];

    my @thems = ThemesGetArray();
    if ( grep /^\Q$t_name\E$/, @thems ) {
        if ( $owner eq '6' ) {
            chdir "$theme_dir";
            ZipCompress($t_name);
        }
        else {
            chdir "$theme_dir/Users_Themes/$owner" or die $!;
            if ( -d $t_name ) { ZipCompress($t_name) }
            elsif ( -d "$theme_dir/$t_name"
                and grep ( /^\Q$t_name\E$/, @DefaultThemes ) )
            {
                chdir "$theme_dir";
                ZipCompress($t_name);
            }
            else { stop("   "); }
        }
    }
    else { stop("   "); }
}

sub ZipCompress {
    my $t_name  = $_[0];
    my $ZipFile = "$t_name.zip";
    my $zip     = Archive::Zip->new();
    $zip->addTree( "$t_name", "$t_name" );
    die "Archive:Zip write error: $!"
      unless $zip->writeToFileNamed("$theme_dir/$ZipFile") == AZ_OK;
}

sub ZipUncompress {
    my $file_name = $_[0];
    chdir "$_[1]";
    my $zip         = Archive::Zip->new("$file_name");
    my @FileMembers = $zip->memberNames();
    my $item;
    my @dir_name;
    my $stop = 0;
    foreach $item (@FileMembers) {

        if ( $item =~ /\/$/ ) {
            if ( !-d $item ) {
                mkdir $item;
                if ( !$stop == 1 ) {
                    $item =~ s/(\/|\\)$//;
                    $dir_name[0] = $item;
                    $stop = 1;
                }
            }
            else {
                unlink "$file_name";
                die
"     $item  .\n    ,     .";
            }
        }
    }
    die "Arhive::Zip write error: $!" unless $zip->extractTree() == AZ_OK;
    unlink "$file_name";
    my @files2del;
    find sub {
        if ( $File::Find::name =~
/\.(php|php3|php4|php5|php6|phps|phtml|shtml|cgi|pl|htaccess|htpasswd)$/
          )
        {
            push @files2del, $File::Find::name;
        }
    }, @dir_name;
    if (@files2del) {
        foreach my $file2d (@files2del) { unlink "$file2d" }
    }
}

sub UploadFile {
    my $dir = $_[0];
    my $mod = param('mod');
    if ( !defined param('file') and $mod eq 'themes' ) {
        print qq^<center>
<h3>     </h3>
<form action=$cms enctype='multipart/form-data' method='post'>
	<input type="hidden" name="mod" value="$mod" />
	<input type="hidden" name="edt" value="upl" />
	<input type="file" name="file" accept="application/x-zip">&nbsp;<input type='submit' value=''>
</form>
<p>    zip-</p>
<p>
	<a href="http://wiki.spcms.ru/%D0%A2%D0%B5%D0%BC%D0%B0_%D0%BE%D1%84%D0%BE%D1%80%D0%BC%D0%BB%D0%B5%D0%BD%D0%B8%D1%8F" target="_blank">    </a>
</p>
</center>^
    }
    elsif ( !defined param('file') and $mod eq 'administration' ) {
        print qq^
<form action=$cms enctype='multipart/form-data' method='post'>
	<input type="hidden" name="mod" value="$mod" />
	<input type="hidden" name="edt" value="upl" />
	<input type="hidden" name="id" value="$dir" />
	<input type="file" name="file">&nbsp;<input type='submit' value=''>
</form>^;
    }
    elsif ( defined param('file') ) {
        my $file = param('file');
        $file =~ s/.*[\/\\](.*)/$1/;
        if ( $file =~ /^[a-zA-Z0-9_\-\.]+$/ ) {
            my $fh = upload('file');
            mkdir "$rootdirsp/tmp" unless -d "$rootdirsp/tmp";
            open UPLOADFILE, ">$dir/$file" or die $!;
            binmode UPLOADFILE;
            while (<$fh>) { print UPLOADFILE }
            close UPLOADFILE;
            return "$dir/$file";
        }
        elsif ( $mod eq 'administration' and $owner eq '6' ) {
            my $fh = upload('file');
            mkdir "$rootdirsp/tmp" unless -d "$rootdirsp/tmp";
            open UPLOADFILE, ">$dir/$file" or die $!;
            binmode UPLOADFILE;
            while (<$fh>) { print UPLOADFILE }
            close UPLOADFILE;
            return "$dir/$file";
        }
        else {
            stop(
"  .<br>       , ,  '_'  '-'."
            );
        }
    }
}

sub RemoveDir {
    while ( my $dir = shift ) {
        if ( -e $dir and -d $dir ) {
            rmdir($dir) ? print "" : unshift( @_, $dir )
              unless RemoveTree($dir);
        }
        else {
            print " '$dir'      ";
        }
    }
}

sub RemoveTree {
    while ( my $dir = shift ) {
        local *DIR;
        opendir( DIR, $dir ) or die "Can't open directory '$dir': $!\n";
        while ( my $file = readdir DIR ) {
            next if $file =~ /^\.\.?$/;
            if ( -d "$dir/$file" ) {
                rmdir("$dir/$file")
                  ? next
                  : push( @_, "$dir/$file" );
            }
            else {
                unlink("$dir/$file")
                  or die "Can't remove file '$dir/$file': $!\n";
            }
        }
        closedir(DIR) or die "Can't close directory '$dir': $!\n";
    }
    return 0;
}

sub gid_o {
    my $gid_o;
    if ( $owner ne '6' ) {
        $gid_o = sqlff("select gid from sp_users where uid = '$owner'");
    }
    elsif ( $owner eq '6' ) { $gid_o = $owner }
    return $gid_o;
}

sub SiteDate {
    $sitedate = strftime( "%A, %d %B %Y", localtime() );
    $sitedate =~ s/, 0/, /;
    return MonthYa($sitedate);
}

sub SchoolID {
    my ( $ou_type, $ou_num );
    if ( !defined $CACHE{'OU_ID'} ) {
        my $db_path = $gconf{'db_path'};
        unless ($CS) {
            $db_path =~ s/.*[\/\\](.*)/$1/;
            $db_path =~ /^XXI-(\d)-(\d+)/;
            $ou_type = $1;
            $ou_num  = $2;
            $ou_num =~ s/^0*//;
        }
        $CACHE{'OU_ID'} = $ou_type . $ou_num;
    }
    return $CACHE{'OU_ID'};
}

sub CSRating { }

sub ImgAdd2CS {
    my $url = $_[0];
    if ( $url !~ /_resized_sp_cms_/ ) {
        my ( $w, $h ) = Img_W_H($url);
        my $pathfile;
        if ( $url =~ /src="(.+?\.jpg)"/i ) {
            $pathfile = $1;
            $pathfile =~ s/^\///;
            $pathfile =~ s/^[htps:]{5,6}?\/\/.+?\///i;
            $pathfile = $rootdir . '/' . $pathfile;
            my $resizedname = ImgResizedName( $pathfile, $w, $h );
            $pathfile    =~ s/(^.*\/)//i;
            $resizedname =~ s/(^.*\/)//i;
            $url         =~ s/$pathfile/$resizedname/i;
        }
    }
    return $url;
}

sub ImgResize {

    my $imgX    = $_[0];
    my $imgY    = $_[1];
    my $picfile = $_[2];
    my $no      = $_[3];
    if ( -f "$picfile" ) {

        my $picfile_resized;

        if (
            ( param('mod') eq 'administration' and param('edt') ne 'upl' )
            or (    param('mod') eq 'news'
                and defined param('act')
                and param('act') ne 'upl' )
          )
        {
            return $picfile;
        }
        else {
            $picfile_resized = ImgResizedName( $picfile, $imgX, $imgY );
            my $size = $imgX . 'x' . $imgY;
            my $cmd =
qq^$imagemagick $picfile -resize $size -quality 81 $picfile_resized^;

            $cmd =~ s/\(/\\(/go;
            $cmd =~ s/\)/\\)/go;

            system $cmd;
            return $picfile_resized, $imgX, $imgY;
        }
    }
    else { return '123' }
}

sub ImgResizedName {
    if (   param('mod') eq 'administration' and param('edt') eq 'upl'
        or param('mod') eq 'news' and param('act') eq 'upl' )
    {
        return $_[0];
    }

    my $picfile = $_[0];
    my $imgX    = $_[1];
    my $imgY    = $_[2];
    $picfile =~ s/\.jpg$//i;
    return "$picfile" . '_resized_sp_cms_' . $imgX . 'x' . $imgY . '.jpg';
}

sub sqlCS($) { my $sql = shift;
    my $q = $gdbCS->prepare($sql)
      or error(
"   SQL:<br><b><pre>$sql</pre></b>  : <b><pre>$DBI::errstr</pre></b>"
      );
    $q->execute()
      or error(
"   SQL:<br><b><pre>$sql</pre></b>  : <b><pre>$DBI::errstr</pre></b>"
      );
    $q->finish();
}

sub sqlffCS($) {
    my $sql = shift;
    my $q   = $gdbCS->prepare($sql)
      or error(
"   SQL:<br><b><pre>$sql</pre></b>  : <b><pre>$DBI::errstr</pre></b>"
      );
    $q->execute()
      or error(
"   SQL:<br><b><pre>$sql</pre></b>  : <b><pre>$DBI::errstr</pre></b>"
      );
    my $a = ( $q->fetchrow_array() )[0];
    $q->finish;
    return $a;
}

sub sqlpcms2page { my $sql = shift;
    my $attr    = shift;
    my @from_to = PageFrom();
    $sql =~ s/$/ ROWS $from_to[0] to $from_to[1]/i;
    my $q = $gdbcms->prepare( $sql, $attr ) or report_sql_error($sql);
    $q->execute() or report_sql_error($sql);
    $queryes++ if $DEBUG;
    $SQLH{$sql}++ if $DEBUG;
    return $q;
}

sub PageFrom {
    my $module = param('mod');
    my $pg = param('pg') || '1';
    GetConfig($module);
    my $from =
      $pg * $MOD_CONFIG{ $module . '_item_on_page' } -
      $MOD_CONFIG{ $module . '_item_on_page' } + 1;
    my $to = $from + $MOD_CONFIG{ $module . '_item_on_page' } - 1;
    return $from, $to;
}

sub PageNext { my $my = $_[0];
    my $module         = param('mod');
    my $pg             = param('pg') || '1';
    my $sqlfilter      = '';
    my $filter_content = '';
    if ( param('filter') ) {
        my $filter = param('filter');
        $sqlfilter = "and parent=$filter";

        $filter_content = param('filter');
        $filter_content = "&filter=$filter_content";
    }
    if ( $my eq '1' ) { $sqlfilter .= " and autor = $autor_insert" }
    my $num_all_on_page =
      sqlffcms("select count(1) from $module where owner=$owner $sqlfilter");
    my $delim = $MOD_CONFIG{ $module . '_item_on_page' } || 1;
    my $nextnb = $num_all_on_page / $delim;
    unless ( $nextnb =~ /^-?\d+\/?\d*$/ ) {
        $nextnb =
          int( $num_all_on_page / $MOD_CONFIG{ $module . '_item_on_page' } ) +
          1;
    }
    my $i        = 1;
    my $hrefi    = 1;
    my $HrefNext = '<div class=pagenav>';
    if ( $pg > 1 ) {
        my $iii = param('pg') - 1;
        $HrefNext .=
qq^<a href="$cms?mod=$module&edt=lst$filter_content&pg=1" title=" ">&lt;&lt;</a>&nbsp;^;
        $HrefNext .=
qq^<a href='$cms?mod=$module&edt=lst$filter_content&pg=$iii' title=''>&lt;</a>&nbsp;&nbsp; ^;
    }
    while ( $i <= $nextnb ) {
        if ( $pg == $i ) {
            $HrefNext .=
qq^&nbsp;<span class="news_next_caren_pg"><b> $i </b></span>&nbsp;^;
        }
        else {
            $HrefNext .=
qq^<a title=" $i" href="$cms?mod=$module&edt=lst$filter_content&pg=$i&my=$my">&nbsp;$hrefi&nbsp;</a>^;
        }
        $i++;
        $hrefi++;
    }
    if ( $pg < $i - 1 ) {
        my $endpage = $i - 1;
        my $nextpg  = $pg + 1;
        $HrefNext .=
qq^&nbsp;&nbsp; <a href='$cms?mod=$module&edt=lst$filter_content&pg=$nextpg' title=' '>&gt;</a>^;
        $HrefNext .=
qq^&nbsp; <a href="$cms?mod=$module&edt=lst$filter_content&pg=$endpage" title=" ">&gt;&gt;</a>^;
    }
    $HrefNext .= PageNumSelector($my);
    $HrefNext .= '</div>' . "\n";
    return $HrefNext;
}

sub PageNumSelector {
    my $my         = $_[0];
    my $module     = param('mod');
    my $item_on_pg = $MOD_CONFIG{ $module . '_item_on_page' };
    my $pg         = param('pg') || '1';
    my $flt        = param('filter') || '';
    my $Data =
q^<p>   : <select name=section onchange='top.location.href = this.options[this.selectedIndex].value'>^;
    my $selected = "";
    unless ( $pg =~ /^-?\d+\/?\d*$/ ) { $selected = "selected" }
    my @items_on_page = ( 5, 10, 30, 50, 70 );

    foreach my $item (@items_on_page) {
        my $selected = "";
        if ( $item eq $item_on_pg ) { $selected = "selected" }
        $Data .=
qq[<option value="$cms?mod=$module&edt=lst&pgnum=$item&pg=1&filter=$flt&my=$my" $selected>$item</option>];
    }
    $Data .= "</select>";
    return $Data;
}

sub PageNumUpdate {
    my $module     = param('mod');
    my $item_on_pg = $MOD_CONFIG{ $module . '_item_on_page' };
    my $pg_num     = param('pgnum');
    my $ConfigData = sqlffcms(
        "select modules_cnf_users.m_config from modules, modules_cnf_users
		WHERE modules_cnf_users.mod_id = modules.i_id
		and modules.modulename = '$module' and modules_cnf_users.owner = '$owner'"
    );
    my $sqlcfg = $module . '_item_on_page';
    if ( $ConfigData =~ /_item_on_page=\d+,/ ) {
        $ConfigData =~ s/_item_on_page=\d+,/_item_on_page=$pg_num,/i;
    }
    else { $ConfigData = $ConfigData . $module . "_item_on_page=$pg_num," }
    sqlcms(
        "update modules_cnf_users
		set modules_cnf_users.m_config = '$ConfigData'
		where modules_cnf_users.m_config like '%$sqlcfg%' and modules_cnf_users.owner = '$owner'"
    );
}

sub StartHeaders {
    CheckParams();
    my @ex_headers = qw(comadd dc upl);
    my $pact       = param('act');
    if ( defined param 'edt' ) {
        html_header_ant();
    }
    elsif ( ( grep /^$pact$/, @ex_headers ) ) {
        return;
    }
    else {
        if ( $GZIP and param('mod') ne 'rss' ) {
            print "Content-Encoding: gzip\n";
        }
        if ( param('mod') ne 'rss' ) {
            print "Content-type: text/html; charset=windows-1251\n\n";
            $g_http_headers_sent = 1;
        }
        elsif ( param('mod') eq 'rss' ) {
            print "Content-type: text/xml; charset=UTF-8\n\n";
            $g_http_headers_sent = 1;
        }
    }
}

sub error404 {
    my $txt = $_[0];
    if ( param('edt') ) {
        if ($GZIP) { print "Content-Encoding: gzip\n" }
        print "X-Powered-By: School Portal - www.spcms.ru\n";
        print "Content-type: text/html; charset=windows-1251\n\n";
        $g_http_headers_sent = 1;
        security_alert("$txt,    edt");
    }
    else {
        print header(
            -type    => 'text/html',
            -status  => '404 Not Found',
            -charset => 'windows-1251'
        );
        print h1(' 404');
        print h2( '   ', $txt );
        print h2(
" <a href=\"http://$ENV{HTTP_HOST}\">   </a>"
        );
        print qq(<hr><div class="footer">
		<div>
			<div>&copy; 2005&ndash;2012 <a href="http://spcms.ru" target="_blank"></div>
			<div>   &laquo; &raquo;$LIGHT</a></div>
		</div>
		</div></center>);
        undef $error404;
        exit;
    }
}

sub CheckSession {
    session_check();
    session_keep_alive();

    ( $guid, $ggid, $state_date ) = uid_gid_gdate();

    $stat_inbox_new = get_new_message_count();

    if ( param('edt') !~ /^ajax_/ ) {
        print generate_menu();
    }

    return 1;
}

sub dump_queries() {
    my $result =
q[<div class=dontprint><h1>SQL- <a href="#sp_sql_dump" onclick="document.getElementById('sp_sql_dump').style.display = 'block';"></a></h1>
<div id="sp_sql_dump" style="display:none">];
    for ( sort keys %SQLH ) {
        $result .= qq[<div style="border-top:2px solid #ccc">];
        if ( $SQLH{$_} > 1 ) {
            $result .=
qq[<div><u><b>!</b>   &ndash; <b style="color:red">$SQLH{$_}</b></u></div>];
        }
        $result .= qq[<pre class=sql><code class="sql">$_</code></pre></div>];
    }
    $result .= qq[</div>];
    $result .= qq[</div>];
    return $result;
    return;
}

sub gallery() {
    GetConfig('gallery');

    my $converter = Text::Iconv->new( get_server_encoding(), "windows-1251" );

    my $resize    = $MOD_CONFIG{'resize'};
    my $resize_to = $MOD_CONFIG{'resize-to'};

    my $path     = $gconf{'sppath'} . "/pic/gallery";
    my $rel_path = $gconf{'sproot'} . "/pic/gallery";

    my $thumb_path     = "$path.thumbs";
    my $rel_thumb_path = "$rel_path.thumbs";

    my $resize_path     = "$path.resize";
    my $rel_resize_path = "$rel_path.resize";

    my $gallery_root = $path;

    my $folder = param('folder');
    if ( defined $folder ) {
        $folder = substr( $folder, 0, 128 );

        $folder =~ s![\|><\0\\]!!go;
        $folder =~ s!^\.+!!o;
        $folder =~ s!\*!/!g;

        $path        .= '/' . $folder;
        $thumb_path  .= '/' . $folder;
        $resize_path .= '/' . $folder;

        $rel_path        .= '/' . $folder;
        $rel_thumb_path  .= '/' . $folder;
        $rel_resize_path .= '/' . $folder;

        $rel_path        = uri_escape_leave_slash($rel_path);
        $rel_thumb_path  = uri_escape_leave_slash($rel_thumb_path);
        $rel_resize_path = uri_escape_leave_slash($rel_resize_path);

        sub uri_escape_leave_slash {
            my @parts = split( /\//, shift );
            $_ = uri_escape($_) for (@parts);
            return join( '/', @parts );
        }
    }

    my $dir_handle;
    opendir( $dir_handle, $path )
      || stop(qq[   <br>$path<br> :<br>"$!"]);
    my @names;
    @names = sort readdir($dir_handle);
    closedir $dir_handle;

    my @files;
    my @folders;
    for (@names) {
        next if $_ =~ m/^\./;

        if ( -d "$path/$_" ) {
            push @folders, $_;
        }
        else {
            if (/\.(jpe?g|gif|png)$/i) {
                push @files, $_;
            }
        }
    }

    my $html = q[
<style type="text/css">

	#gallery-block {
		text-align: center;
		margin-top: 16px;
	}

	#gallery-block a {
		display: inline-block;
		height: 108px;
		width:  108px;
		position: relative;
		margin: 12px 14px;
	}

	#gallery-block img {
		display: block;
		margin: 0 auto;
		padding: 3px;
		border: 1px solid #ccc;
		box-shadow: 2px 3px 7px rgba(0,0,0, 0.1);
		background-color: white;
	}

	#gallery-block a:hover img {
		border: 1px solid #999;
	}

	.gallery-path {
		font: normal 10pt Verdana, sans-serif;
		margin: 0 0 0.5em;
	}

	a.gallery-folder {
		background: transparent url('/sp/img/folder-photo-64.png') 8px center no-repeat;
		padding: 0.5em 0.3em 0.6em 84px;
		margin-bottom: 0.4em;
		display: inline-block;
		width: 150px;
		margin-right: 25px;
		overflow-: hidden;
		overflow-y: hidden;
		line-height: 1.2em;
		height: 4.3em;
		border: 1px solid #eee;
		background-color: #fdfdfd;
		font-size: 11pt;
		text-align: left;
	}

	a.gallery-folder:hover {
		border: 1px solid #999;
	}

	.gallery-empty-folder {
		color: grey;
		margin: 32px auto;
		width: 300px;
		padding: 16px 32px;
		border: 1px solid #ddd;
	}

</style>

<!-- fancy box -->
<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.4/jquery.min.js"></script>
<script type="text/javascript" src="/sp/fancybox/jquery.mousewheel-3.0.4.pack.js"></script>
<script type="text/javascript" src="/sp/fancybox/jquery.fancybox-1.3.4.pack.js"></script>
<link rel="stylesheet" type="text/css" href="/sp/fancybox/jquery.fancybox-1.3.4.css" media="screen" />

<script type="text/javascript">
	$(document).ready(function() {
		$("a[rel=sp-gallery]").fancybox({
		});
	});
</script>

<h1 class="gallery-header"></h1>

];

    if ( defined $folder ) {
        my @human_readable_path_parts = split( /\//, $folder );
        my @human_readable_path_html;

        for ( my $i = 0 ; $i < @human_readable_path_parts ; $i++ ) {
            if ( $i < @human_readable_path_parts - 1 ) {
                my @star_path_parts;
                for ( my $j = 0 ; $j <= $i ; $j++ ) {
                    push @star_path_parts, @human_readable_path_parts[$j];
                }
                my $star_path = join( '*', @star_path_parts );

                push @human_readable_path_html,
                    qq[<a href="$cms?mod=gallery&folder=]
                  . uri_escape($star_path) . qq[">]
                  . $converter->convert( $human_readable_path_parts[$i] )
                  . q[</a>];
            }
            else {
                push @human_readable_path_html,
                  $converter->convert( $human_readable_path_parts[$i] );
            }
        }

        $html .=
qq[<div class="gallery-path">: <a href="$cms?mod=gallery"></a> &rarr; ]
          . join( ' &rarr; ', @human_readable_path_html )
          . q[</div>];
    }

    for ( sort { -M "$path/$a" <=> -M "$path/$b" } @folders ) {
        my $subfoldername_uldencoded = uri_escape($_);
        my $folder_stars             = uri_escape_leave_slash($folder);
        $folder_stars =~ s/\//*/g;
        my $subfolder =
          $folder
          ? "$folder_stars*$subfoldername_uldencoded"
          : $subfoldername_uldencoded;
        my $win1251_foldername = $converter->convert($_);
        $html .=
qq[<a title="" class="gallery-folder" href="$cms?mod=gallery&folder=$subfolder">$win1251_foldername</a>];
    }

    $html .= qq[<div id="gallery-block">];

    my $ImageMagick = Image::Magick->new;

    for (@files) {
        my $filename_urlenc = uri_escape($_);

        unless ( -e "$thumb_path/$_" ) {
            unless ( -d $thumb_path ) {
                $thumb_path =~ s/'//go;
                system qq[mkdir -p '$thumb_path'];
            }
            system
qq^$imagemagick '$path/$_' -resize 100x100 -quality 85 '$thumb_path/$_'^;

            system qq[find $gallery_root -type d -atime -7 -fprintf ]
              . $gconf{'sppath'}
              . "/tmp/gallery-lastcontent"
              . q[ "%A+\\t%p\\n"];
        }

        my $resize_needed = 1;

        if ($resize) {

            my ( $width, $height, undef, undef ) =
              $ImageMagick->Ping("$path/$_");

            if ( $width and $height ) {
                my $longest_edge = max( $width, $height );
                if ( $longest_edge < $resize_to ) {
                    $resize_needed = 0;
                }
            }

            if ($resize_needed) {
                unless ( -e "$resize_path/$_" ) {
                    unless ( -d $resize_path ) {
                        $resize_path =~ s/'//go;
                        system qq[mkdir -p '$resize_path'];
                    }
                    system
qq^$imagemagick '$path/$_' -resize \Q$resize_to\Ex$resize_to -quality 85 '$resize_path/$_'^;
                }
            }
        }

        if ( $resize and $resize_needed ) {
            $html .=
              qq[<a rel="sp-gallery" href="$rel_resize_path/$filename_urlenc">];
        }
        else {
            $html .= qq[<a rel="sp-gallery" href="$rel_path/$filename_urlenc">];
        }

        $html .= qq[
	<img src="$rel_thumb_path/$filename_urlenc">
</a>
];
    }

    if ( !@files and !@folders ) {
        my $gallery_msg = '    .';
        if ( !$folder ) { $gallery_msg = '  .'; }
        $html .= qq[<div class="gallery-empty-folder">$gallery_msg</div>];
    }

    $html .= qq[</div>];

    return $html;
}

sub galleryConfig() {
    GetConfig('gallery');

    if ( param('edt') eq 'so' ) {
        my $mod_id    = param('i_id');
        my $resize    = param('gallery-resize') eq 'on';
        my $resize_to = param('gallery-resize-to');

        $resize_to and sec_gt0($resize_to);

        sqlcms(
qq^update modules_cnf_users set m_config = ',resize=$resize,resize-to=$resize_to,' where i_id = '$mod_id' and owner = '$owner'^
        );

        return;
    }

    my $tpl = tpl_str(
        "./tpl/gallery-options.html",
        {
            checked => $MOD_CONFIG{'resize'} ? 'checked' : '',
            resize_to => $MOD_CONFIG{'resize-to'},
        }
    );

    return $tpl;
}

sub guestbook() {
    if ( defined param('edt') ) {
        if ( param('edt') eq 'lst' ) {
            guestbook_admin_list();
        }
        elsif ( param('edt') eq 'del' ) {
            my $item_id = param('i_id');
            sec_gt0($item_id);
            sqlcms(
                "delete from guestbook where id = $item_id and owner = $owner");
            guestbook_admin_list();
        }
        elsif ( param('edt') eq 'approve' ) {
            my $item_id = param('i_id');
            sec_gt0($item_id);
            sqlcms(
"update guestbook set published = 1 where id = $item_id and owner = $owner"
            );
            guestbook_admin_list();
        }
    }
    else {
        my @tpl_guestbook = open_tpl("$theme_dir/$theme/guestbook.html");
        my @tpl_guestbook_item_cache =
          open_tpl("$theme_dir/$theme/guestbook-item.html");
        my @tpl_guestbook_item;

        if ( $ENV{'REQUEST_METHOD'} eq 'GET' ) {
            my $q = sqlpcms(
                "select * from guestbook
				where published = 1 and owner = $owner
				order by post_date desc",
                { ib_timestampformat => '%d.%m.%Y %H:%M' }
            );
            my %hash;
            $q->bind_columns( \( @hash{ @{ $q->{NAME_lc} } } ) );
            my $messages      = '';
            my $message_count = 0;
            while ( $q->fetch ) {
                @tpl_guestbook_item = @tpl_guestbook_item_cache;

                $messages .= join '',
                  tpl_replace_ant(
                    {
                        name => $hash{name},
                        date => $hash{post_date},
                        text => $hash{text},
                    },
                    \@tpl_guestbook_item
                  );

                $message_count++;
            }

            unless ($message_count) {
                $messages =
'<div class="guestbook-empty">  .      .</div>';
            }

            return join '',
              tpl_replace_ant(
                {
                    messages => $messages,
                    owner    => $owner,
                },
                \@tpl_guestbook
              );
        }
        elsif ( $ENV{'REQUEST_METHOD'} eq 'POST' ) {
            my $name = param_dexss_lim( 'name', 128 );
            my $text = param_dexss_lim( 'text', 1500 );

            ( $name, $text ) = trim( $name, $text );
            if ( !$name or !$text ) {
                stop("    .");
            }

            sqlbcms(
                "INSERT INTO GUESTBOOK
				(NAME, TEXT, POST_DATE, published, owner)
				VALUES
				(?,    ?,    'NOW',     0,         $owner)",
                $name, $text
            );

            my $target_user = $owner;
            if ( $owner == 6 ) {
                $target_user =
                  sqlff("select uid from sp_users where log = 'admin'");
            }

            msg_send(
                $target_user,
                "    ",
"    . :\nhttp://$ENV{SERVER_NAME}/$cms?mod=guestbook&edt=lst\n\n: $name\n\n:\n\n$text",
                -1
            );

            return "<h1> </h1>
<p>       .</p>
";
        }
    }

}

sub guestbook_admin_list() {
    my $q = sqlpcms(
        "select * from guestbook
		where owner = $owner
		order by post_date desc",
        { ib_timestampformat => '%d.%m.%Y %H:%M' }
    );
    my %hash;
    $q->bind_columns( \( @hash{ @{ $q->{NAME_lc} } } ) );

    my $table         = '';
    my $message_count = 0;

    while ( $q->fetch ) {
        my $class = $hash{published} ? '' : 'unapproved';
        my $approve =
          $hash{published}
          ? '&nbsp;'
          : qq[<a href="$cms?mod=guestbook&edt=approve&i_id=$hash{id}"></a>];
        $table .= qq[
			<tr class="$class">
				<td>
					: <b>$hash{name}</b><br>
					: $hash{post_date}
					<p>$hash{text}</p>
				</td>
				<td>$approve</td>
				<td><a href="$cms?mod=guestbook&edt=del&i_id=$hash{id}"></a></td>
			</tr>
		];

        $message_count++;
    }

    unless ($message_count) {
        $table =
'<tr><td colspan="3">  .   ,         .     .             .</td></tr>';
    }

    print q[<h1>  </h1>
<table width="75%" class="adminlist">
<tr>
	<th></th>
	<th colspan="2"></th>
</tr>
], $table, '</table>';
}
